#ifndef __CINIFILE_H
#define __CINIFILE_H

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

class CIniFile
{
protected:
	char _IniFile[256];
	char _MyDir[256];
	char _WinDir[256];
	char _TempDir[256];
public:
	CIniFile(char *filename = NULL);
	CIniFile(HINSTANCE hInstance);
	~CIniFile();


#ifdef _OWLPCH
	void GetTempPath(int len, char *lpbuffer);
#endif
	BOOL IsValid();
	BOOL SetIniFile();
	BOOL CreateIniFileName(HINSTANCE hInstance);
	char *IniFile()
	{
		return _IniFile;
	};
	char *MyDir()
	{
		return _MyDir;
	};
	char *WinDir()
	{
		return _WinDir;
	};
	char *TempDir()
	{
		return _TempDir;
	};
	BOOL WriteString(char *lpszSection, char *lpszKey, char *lpszString)
	{
		return WritePrivateProfileString(lpszSection, lpszKey, lpszString, _IniFile);
	};
	BOOL WriteInt(char *lpszSection, char *lpszKey, int i)
	{
		char str[30];
		sprintf(str, "%d", i);
		return WritePrivateProfileString(lpszSection, lpszKey, str, _IniFile);
	};
	BOOL WriteBool(char *lpszSection, char *lpszKey, BOOL b)
	{
		if(b)
			return WritePrivateProfileString(lpszSection, lpszKey, "1", _IniFile);
		else
			return WritePrivateProfileString(lpszSection, lpszKey, "0", _IniFile);
	};
	BOOL GetString(char *lpszSection, char *lpszKey, char *DefStr,
				char *lpszString, int len = 256)
	{
		return GetPrivateProfileString(lpszSection, lpszKey, DefStr,
						lpszString, len, _IniFile);
	};
	BOOL GetFileName(char *lpszSection, char *lpszKey, char *DefStr,
				char *lpszString, int len = 256)
	{
		return GetString(lpszSection, lpszKey, DefStr,
						lpszString, 256);
	};
	UINT GetInt(char *lpszSection, char *lpszKey, int dwDefault)
	{
		return GetPrivateProfileInt(lpszSection, lpszKey, dwDefault, _IniFile);
	};
	BOOL GetBool(char *lpszSection, char *lpszKey, BOOL dwDefault);
    BOOL SaveCurrentDir(char *lpszSection, char *lpszKey, char *fname);
};



#endif