#!/usr/bin/bash


if [ "$1" == "" ]; then
	echo Usage: x-open.sh command args
	exit
fi


cmd1=`which $1`
if [ $? -eq 0 ]; then
	echo execute [$*]
	$* &
	exit
fi

cmd=$1
shift
for arg in "$@"; do
	escaped_str=\"$arg\"
#	escaped_str="${arg//\*/\\*}"
	cmd="$cmd $escaped_str"
done
cmd=${cmd#"${cmd%%[![:space:]]*}"}


echo "x-open.sh: command -v test [$1]"
command -v $1 > /dev/null 2>&1
if [ $? -ne 0 -o $# -gt 1 ]; then
	echo execute [$cmd]
	$cmd &
else
	echo execute [xdg-open $cmd]
	xdg-open $cmd &
fi

