// PeakSearchDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CurveFit.h"
#include "PeakSearchDialog.h"
#include <math.h>
#include "..\IniFile.h"

extern CIniFile *IniFile;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPeakSearchDialog _CAO


CPeakSearchDialog::CPeakSearchDialog(CGraphData *pdata, CPeakSearch *ppeak, CWnd* pParent /*=NULL*/)
	: CDialog(CPeakSearchDialog::IDD, pParent)
{
	m_pData = pdata;
	m_pPeakSearch = ppeak;
	//{{AFX_DATA_INIT(CPeakSearchDialog)
	m_nSmooth = 0;
	m_Threshold = 0.0;
	//}}AFX_DATA_INIT
}


void CPeakSearchDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPeakSearchDialog)
	DDX_Control(pDX, IDC_RESULTLIST, m_Results);
	DDX_Text(pDX, IDC_NSMOOTHEDIT, m_nSmooth);
	DDX_Text(pDX, IDC_THRESHOLDEDIT, m_Threshold);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPeakSearchDialog, CDialog)
	//{{AFX_MSG_MAP(CPeakSearchDialog)
	ON_BN_CLICKED(IDC_PEAKSEARCHBUTTON, OnPeaksearchbutton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPeakSearchDialog bZ[W nh

BOOL CPeakSearchDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_nSmooth = IniFile->GetInt("PeakSearch", "nSmooth", 5);
	m_Threshold = IniFile->GetDouble("PeakSearch", "Threshold", 100);
	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPeakSearchDialog::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	UpdateData(TRUE);
	IniFile->WriteInt("PeakSearch", "nSmooth", m_nSmooth);
	IniFile->WriteDouble("PeakSearch", "Threshold", m_Threshold);

	for(int i = 0 ; i < m_PeakSearch.m_nPeaks ; i++)
	{
		m_pPeakSearch->AddPeak(m_PeakSearch.m_Position[i],
							m_PeakSearch.m_CTotal[i], m_PeakSearch.m_GaussFraction[i],
							m_PeakSearch.m_FWHMGLRatio[i], m_PeakSearch.m_FWHMLorentz[i]);
	}
	CDialog::OnOK();
}

void CPeakSearchDialog::OnPeaksearchbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	while(1)
		if(m_Results.DeleteString(0) == LB_ERR) break;

	m_PeakSearch.m_OutputRegionX0 = m_pPeakSearch->m_OutputRegionX0;
	m_PeakSearch.m_OutputRegionX1 = m_pPeakSearch->m_OutputRegionX1;
	PeakSearch(m_pData, &m_PeakSearch, m_nSmooth, m_Threshold);
	return;
}

double CPeakSearchDialog::FWHM(int idx, CGraphData *pData)
{
	int i;
	double Yhalf;

	Yhalf = fabs(m_MinY + (m_pData->Y(idx) - m_MinY)*0.5);
	for(i = 0 ; idx-i >= 0 || idx+i < pData->nData() ; i++)
	{
		if(idx-i >= 0 && pData->Y(idx-i) < Yhalf)
			return ((pData->X(idx) - pData->X(idx-i)) * 2.0);
		if(idx+i < pData->nData() && pData->Y(idx+i) < Yhalf)
			return ((pData->X(idx+i) - pData->X(idx)) * 2.0);
		if(idx-i >= 0 && m_pData->Y(idx-i) > pData->Y(idx))
			return (pData->X(idx) - pData->X(idx-i));
		if(idx+i < pData->nData() && pData->Y(idx+i) > pData->Y(idx))
			return (pData->X(idx+i) - pData->X(idx));
	}
	return (0.1);
}

int CPeakSearchDialog::PeakSearch(CGraphData *pData, CPeakSearch *pPeakSearch, int nSmooth, double Threshold)
{
	int Q;
	int n;
	int m = 0, mg, h, k, i, j;
	double g = 0.0, p;
	char str[256];
	double fwhm;
	int div;

	
	m_MinY = 1e30;
	for(i = 0 ; i < pData->nData() ; i++)
	{
		if(pData->X(i) < pPeakSearch->m_OutputRegionX0 || pData->X(i) > pPeakSearch->m_OutputRegionX1)
			continue;
		if(m_MinY > pData->Y(i)) m_MinY = pData->Y(i);
	}

	sprintf(str, "No.  2Theta    I    fwhhm");
	m_Results.AddString(str);
	sprintf(str, "nS:%d  Thres:%g  datan:%ld", nSmooth, Threshold, pData->nData());

	if(nSmooth <= 0) nSmooth = 4;
	if(Threshold <= 0.0) Threshold = 20.;
	n = pData->nData();
	Q = nSmooth;
	pPeakSearch->RemoveAll();
	div = n/20;
	for(i = Q ; i < n-Q ; i++)
	{
		if(i % div == 0)
		{
//			sprintf(str, "%d%%", (int)((float)i*100.0/(float)n));
//			pTMessage->SetText(str);
		}
		p = 0.0;
		for(j = 1 ; j <= Q ; j++)
			p += (pData->Y(i+j) - pData->Y(i-j))*j;
		mg = m;
		if(p < 0.0) m = -1;
		else if(p > 0.0) m = 1;
		else m = 0;
		if(m == 1)
		{
			g = 0.0;
			continue;
		}
		if(m == 0)
		{
			g += 1.0;
			continue;
		}
		if(mg ==0)
		{
			j = i-(int)(g/2.0);
			h = j;
			for(k = j-Q ; k <= j+Q ; k++)
			{
				if(k < 0 || k >= n) continue;
				if(pData->Y(k) > pData->Y(h)) h = k;
			}
			if(pData->Y(h)-m_MinY > Threshold)
			{
				if(pData->X(h) < pPeakSearch->m_OutputRegionX0 || pData->X(h) > pPeakSearch->m_OutputRegionX1) 
				{
				}
				else
				{
					fwhm = FWHM(h, pData);
					pPeakSearch->AddPeak(m_pData->X(h), m_pData->Y(h)-m_MinY, 0.5, 1.0, fwhm);
					sprintf(str, "%3ld:%7.3f %6.0f %7.3f", pPeakSearch->m_nPeaks-1, m_pData->X(h),
									m_pData->Y(h)-m_MinY, fwhm);
					m_Results.AddString(str);
				}
			}
			i += Q;
			continue;
		}
		else if(mg == 1)
		{
			j = i;
			h = j;
			for(k = j-Q ; k <= j+Q ; k++)
			{
				if(k < 0 || k >= n) continue;
				if(pData->Y(k) > pData->Y(h)) h = k;
			}
			if(pData->Y(h)-m_MinY > Threshold)
			{
				if(pData->X(h) < pPeakSearch->m_OutputRegionX0 || pData->X(h) > pPeakSearch->m_OutputRegionX1) 
				{
				}
				else
				{
					fwhm = FWHM(h, pData);
					pPeakSearch->AddPeak(m_pData->X(h), m_pData->Y(h)-m_MinY, 0.5, 1.0, fwhm);
					sprintf(str, "%3ld:%7.3f %6.0f %7.3f", pPeakSearch->m_nPeaks-1, m_pData->X(h),
								m_pData->Y(h)-m_MinY, fwhm);
					m_Results.AddString(str);
				}
			}
			i += Q;
			continue;
		}
		else g = 0.0;
	}

	return pPeakSearch->m_nPeaks;
}
