// SetupCurveFitView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CurveFit.h"
#include "SetupCurveFitView.h"
#include "SetupLSQDialog.h"
#include "PeakSearchDialog.h"
#include "SelectDataDialog.h"
#include "CurveFitEditView.h"
#include "..\IniFile.h"
#include <math.h>
#include <stdlib.h>

extern CIniFile *IniFile;
extern CCurveFitApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupCurveFitView

IMPLEMENT_DYNCREATE(CSetupCurveFitView, CFormView)

CSetupCurveFitView::CSetupCurveFitView()
	: CFormView(CSetupCurveFitView::IDD)
{
	//{{AFX_DATA_INIT(CSetupCurveFitView)
	m_OutputPath = _T("");
	m_InputPath = _T("");
	m_PFCPath = _T("");
	m_OptRegionX1 = 0.0;
	m_OutputRegionX0 = 0.0;
	m_OutputRegionX1 = 0.0;
	m_OptRegionX0 = 0.0;
	m_AutoRedraw = FALSE;
	m_Optimizeb0 = FALSE;
	m_b0 = 0.0;
	m_b1 = 0.0;
	m_Optimizeb2 = FALSE;
	m_Optimizeb1 = FALSE;
	m_b2 = 0.0;
	m_IRatio = 0.0;
	m_LKa1 = 0.0;
	m_LKa2 = 0.0;
	m_OptimizePosition = FALSE;
	m_Position = 0.0;
	m_QRange = 0.0;
	m_OptimizeCGauss = FALSE;
	m_CGauss = 0.0;
	m_OptimizeCLorentz = FALSE;
	m_CLorentz = 0.0;
	m_OptimizeFWHMGauss = FALSE;
	m_FWHMGauss = 0.0;
	m_OptimizeFWHMLorentz = FALSE;
	m_FWHMLorentz = 0.0;
	m_iPeak = 0;
	m_OptimizeCTotal = FALSE;
	m_CTotal = 0.0;
	m_OptimizeFWHMGLRatio = FALSE;
	m_FWHMGLRatio = 0.0;
	m_OptimizeGaussFraction = FALSE;
	m_GaussFraction = 0.0;
	m_Optimizeb3 = FALSE;
	m_b3 = 0.0;
	m_Optimizeb4 = FALSE;
	m_b4 = 0.0;
	m_DeltaMag = 0.0;
	m_OptimizeAniso = FALSE;
	m_Aniso = 0.0;
	//}}AFX_DATA_INIT
}

CSetupCurveFitView::~CSetupCurveFitView()
{
//	SaveCurrentSetting();
}

void CSetupCurveFitView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupCurveFitView)
	DDX_Control(pDX, IDC_YAXISTYPEBUTTON, m_YAxisType);
	DDX_Control(pDX, IDC_ANISOTROPYSPIN, m_AnisoSpin);
	DDX_Control(pDX, IDC_GAUSSFRACTIONSPIN, m_GaussFractionSpin);
	DDX_Control(pDX, IDC_FWHMLORENTZSPIN, m_FWHMLorentzSpin);
	DDX_Control(pDX, IDC_FWHMGLRATIOSPIN, m_FWHMGLRatioSpin);
	DDX_Control(pDX, IDC_POSITIONSPIN, m_PositionSpin);
	DDX_Control(pDX, IDC_FWHMGAUSSSPIN, m_FWHMGaussSpin);
	DDX_Control(pDX, IDC_CTOTALSPIN, m_CTotalSpin);
	DDX_Control(pDX, IDC_CLORENTZSPIN, m_CLorentzSpin);
	DDX_Control(pDX, IDC_CGAUSSSPIN, m_CGaussSpin);
	DDX_Control(pDX, IDC_B4SPIN, m_b4Spin);
	DDX_Control(pDX, IDC_B3SPIN, m_b3Spin);
	DDX_Control(pDX, IDC_B2SPIN, m_b2Spin);
	DDX_Control(pDX, IDC_B1SPIN, m_b1Spin);
	DDX_Control(pDX, IDC_B0SPIN, m_b0Spin);
	DDX_Control(pDX, IDC_PEAKLISTCOMBO, m_PeakList);
	DDX_Text(pDX, IDC_OUTPUTPATHEDIT, m_OutputPath);
	DDX_Text(pDX, IDC_INPUTPATHEDIT, m_InputPath);
	DDX_Text(pDX, IDC_PFCPATHEDIT, m_PFCPath);
	DDX_Text(pDX, IDC_OPTREGIONX1EDIT, m_OptRegionX1);
	DDX_Text(pDX, IDC_OUTPUTREGIONX0EDIT, m_OutputRegionX0);
	DDX_Text(pDX, IDC_OUTPUTREGIONX1EDIT, m_OutputRegionX1);
	DDX_Text(pDX, IDC_OPTREGIONX0EDIT, m_OptRegionX0);
	DDX_Check(pDX, IDC_AUTOREDRAWCHECK, m_AutoRedraw);
	DDX_Check(pDX, IDC_B0CHECK, m_Optimizeb0);
	DDX_Text(pDX, IDC_B0EDIT, m_b0);
	DDX_Text(pDX, IDC_B1EDIT, m_b1);
	DDX_Check(pDX, IDC_B2CHECK, m_Optimizeb2);
	DDX_Check(pDX, IDC_B1CHECK, m_Optimizeb1);
	DDX_Text(pDX, IDC_B2EDIT, m_b2);
	DDX_Text(pDX, IDC_IRATIOEDIT, m_IRatio);
	DDX_Text(pDX, IDC_LKA1EDIT, m_LKa1);
	DDX_Text(pDX, IDC_LKA2EDIT, m_LKa2);
	DDX_Check(pDX, IDC_POSITIONCHECK, m_OptimizePosition);
	DDX_Text(pDX, IDC_POSITIONEDIT, m_Position);
	DDX_Text(pDX, IDC_QRANGEEDIT, m_QRange);
	DDX_Check(pDX, IDC_CGAUSSCHECK, m_OptimizeCGauss);
	DDX_Text(pDX, IDC_CGAUSSEDIT, m_CGauss);
	DDX_Check(pDX, IDC_CLORENTZCHECK, m_OptimizeCLorentz);
	DDX_Text(pDX, IDC_CLORENTZEDIT, m_CLorentz);
	DDX_Check(pDX, IDC_FWHMGAUSSCHECK, m_OptimizeFWHMGauss);
	DDX_Text(pDX, IDC_FWHMGAUSSEDIT, m_FWHMGauss);
	DDX_Check(pDX, IDC_FWHMLORENTZCHECK, m_OptimizeFWHMLorentz);
	DDX_Text(pDX, IDC_FWHMLORENTZEDIT, m_FWHMLorentz);
	DDX_Text(pDX, IDC_IPEAKEDIT, m_iPeak);
	DDX_Check(pDX, IDC_CTOTALCHECK, m_OptimizeCTotal);
	DDX_Text(pDX, IDC_CTOTALEDIT, m_CTotal);
	DDX_Check(pDX, IDC_FWHMGLRATIOCHECK, m_OptimizeFWHMGLRatio);
	DDX_Text(pDX, IDC_FWHMGLRATIOEDIT, m_FWHMGLRatio);
	DDX_Check(pDX, IDC_GAUSSFRACTIONCHECK, m_OptimizeGaussFraction);
	DDX_Text(pDX, IDC_GAUSSFRACTIONEDIT, m_GaussFraction);
	DDX_Check(pDX, IDC_B3CHECK, m_Optimizeb3);
	DDX_Text(pDX, IDC_B3EDIT, m_b3);
	DDX_Check(pDX, IDC_B4CHECK, m_Optimizeb4);
	DDX_Text(pDX, IDC_B4EDIT, m_b4);
	DDX_Text(pDX, IDC_DELTAMAGNIFICATIONEDIT, m_DeltaMag);
	DDV_MinMaxDouble(pDX, m_DeltaMag, 1.e-003, 1000.);
	DDX_Check(pDX, IDC_ANISOTROPYCHECK, m_OptimizeAniso);
	DDX_Text(pDX, IDC_ANISOTROPYEDIT, m_Aniso);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupCurveFitView, CFormView)
	//{{AFX_MSG_MAP(CSetupCurveFitView)
	ON_BN_CLICKED(IDC_REDRAWBUTTON, OnRedrawbutton)
	ON_BN_CLICKED(IDC_SETUPLSQBUTTON, OnSetuplsqbutton)
	ON_BN_CLICKED(IDC_OUTPUTPATHBUTTON, OnOutputpathbutton)
	ON_BN_CLICKED(IDC_INPUTPATHBUTTON, OnInputpathbutton)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_PFCPATHBUTTON, OnPfcpathbutton)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_GETVIEWRANGEASOUTPUTREGIONBUTTON, OnGetViewRangeAsOutputRegionButton)
	ON_BN_CLICKED(IDC_GETVIEWRANGEASOPTREGIONBUTTON, OnGetViewRangeAsOptRegionButton)
	ON_BN_CLICKED(IDC_PEAKSEARCHBUTTON, OnPeaksearchbutton)
	ON_BN_CLICKED(IDC_CLEARPEAKSBUTTON, OnClearpeaksbutton)
	ON_BN_CLICKED(IDC_ADDPEAKBUTTON, OnAddpeakbutton)
	ON_BN_CLICKED(IDC_DELETEPEAKBUTTON, OnDeletepeakbutton)
	ON_NOTIFY(UDN_DELTAPOS, IDC_B0SPIN, OnDeltaposB0spin)
	ON_CBN_SELCHANGE(IDC_PEAKLISTCOMBO, OnSelchangePeaklistcombo)
	ON_NOTIFY(UDN_DELTAPOS, IDC_B1SPIN, OnDeltaposB1spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_B2SPIN, OnDeltaposB2spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_B3SPIN, OnDeltaposB3spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_B4SPIN, OnDeltaposB4spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CGAUSSSPIN, OnDeltaposCgaussspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CLORENTZSPIN, OnDeltaposClorentzspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CTOTALSPIN, OnDeltaposCtotalspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_FWHMGAUSSSPIN, OnDeltaposFwhmgaussspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_FWHMGLRATIOSPIN, OnDeltaposFwhmglratiospin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_FWHMLORENTZSPIN, OnDeltaposFwhmlorentzspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_GAUSSFRACTIONSPIN, OnDeltaposGaussfractionspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_POSITIONSPIN, OnDeltaposPositionspin)
	ON_BN_CLICKED(IDC_EXECCURVEFITBUTTON, OnExeccurvefitbutton)
	ON_BN_CLICKED(IDC_EDITPFCFILEBUTTON, OnEditpfcfilebutton)
	ON_BN_CLICKED(IDC_EDITOUTPUTFILEBUTTON, OnEditoutputfilebutton)
	ON_BN_CLICKED(IDC_EDITINPUTFILEBUTTON, OnEditinputfilebutton)
	ON_BN_CLICKED(IDC_SETOPTIMIZEVIEWRANGEBUTTON, OnSetoptimizeviewrangebutton)
	ON_BN_CLICKED(IDC_SETOUTPUTVIEWRANGEBUTTON, OnSetoutputviewrangebutton)
	ON_BN_CLICKED(IDC_SAVEPFCFILEBUTTON, OnSavepfcfilebutton)
	ON_EN_CHANGE(IDC_B0EDIT, OnChangeB0edit)
	ON_EN_CHANGE(IDC_B1EDIT, OnChangeB1edit)
	ON_EN_CHANGE(IDC_B2EDIT, OnChangeB2edit)
	ON_EN_CHANGE(IDC_B3EDIT, OnChangeB3edit)
	ON_EN_CHANGE(IDC_B4EDIT, OnChangeB4edit)
	ON_EN_CHANGE(IDC_CGAUSSEDIT, OnChangeCgaussedit)
	ON_EN_CHANGE(IDC_CLORENTZEDIT, OnChangeClorentzedit)
	ON_EN_CHANGE(IDC_CTOTALEDIT, OnChangeCtotaledit)
	ON_EN_CHANGE(IDC_FWHMGAUSSEDIT, OnChangeFwhmgaussedit)
	ON_EN_CHANGE(IDC_FWHMGLRATIOEDIT, OnChangeFwhmglratioedit)
	ON_EN_CHANGE(IDC_FWHMLORENTZEDIT, OnChangeFwhmlorentzedit)
	ON_EN_CHANGE(IDC_GAUSSFRACTIONEDIT, OnChangeGaussfractionedit)
	ON_EN_CHANGE(IDC_LKA1EDIT, OnChangeLka1edit)
	ON_EN_CHANGE(IDC_LKA2EDIT, OnChangeLka2edit)
	ON_EN_CHANGE(IDC_POSITIONEDIT, OnChangePositionedit)
	ON_EN_CHANGE(IDC_QRANGEEDIT, OnChangeQrangeedit)
	ON_BN_CLICKED(IDC_DEFAULTXRDPARAMBUTTON, OnDefaultxrdparambutton)
	ON_NOTIFY(UDN_DELTAPOS, IDC_ANISOTROPYSPIN, OnDeltaposAnisotropyspin)
	ON_EN_CHANGE(IDC_ANISOTROPYEDIT, OnChangeAnisotropyedit)
	ON_BN_CLICKED(IDC_CALCBGBUTTON, OnCalcbgbutton)
	ON_BN_CLICKED(IDC_YAXISTYPEBUTTON, OnYAxisTypeButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupCurveFitView ff

#ifdef _DEBUG
void CSetupCurveFitView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupCurveFitView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupCurveFitView bZ[W nh

void CSetupCurveFitView::OnRedrawbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnSetuplsqbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CSetupLSQDialog sld(GetDocument()->GetPeakSearch());

	if(sld.DoModal() == IDOK)
	{
	}
}

void CSetupCurveFitView::OnOutputpathbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog fd(true, NULL, NULL, OFN_HIDEREADONLY, 
		"Output Files (*.out)|*.out|All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;

	m_OutputPath = fd.GetPathName();
	UpdateData(FALSE);
}

void CSetupCurveFitView::OnInputpathbutton()
{
	GetDocument()->NewDocument();
	SetInputpath();
}

CString& CSetupCurveFitView::SetInputpath() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);

	char str[_MAX_PATH];
	IniFile->GetString("Preferences", "InputDir", "", str);
	SetCurrentDirectory(str);
	IniFile->GetString("Preferences", "InputMask", 
		"Spectrum Files |*.;*.xrd;*.dat;*.rmn;*.ram;*.ras;*.txt;*.asc;*.ir;*.xdt;*.int;*.pat;*.csv;"
		"*.0*;*.1*;*.2*;*.3;*.4*;*.5*;*.6*;*.7*;*.8*;*.9*", str);
	strcat(str, "|All Files (*.*)|*.*||");
	CFileDialog fd(true, NULL, NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, str);
	static CString ret = "";
	if(fd.DoModal() != IDOK) return ret;

	GetDocument()->m_iYAxisType = YAXISTYPE_LINEAR;
	m_YAxisType.SetWindowText("Log");

	ReadFile(fd.GetPathName());
	return m_InputPath;
}

BOOL CSetupCurveFitView::OnInitDialog() 
{
//	CDialog::OnInitDialog();
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

BOOL CSetupCurveFitView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	BOOL ret = CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);

	ClearDialog();
	m_InputPath = "";
	m_OutputPath = "";
	m_PFCPath = "";
	UpdateData(FALSE);
	return ret;
}

int CSetupCurveFitView::ClearDialog(bool clearlist)
{
	if(clearlist)
	{
		while(1)
			if(m_PeakList.DeleteString(0) == LB_ERR) break;
	}
	char str[256];
	IniFile->GetString("LSQ", "InputPath", "", str);
	m_InputPath = str;
	IniFile->GetString("LSQ", "OutputPath", "", str);
	m_OutputPath = str;
	IniFile->GetString("LSQ", "PFCPath", "", str);
	m_PFCPath = str;
	m_DeltaMag = IniFile->GetDouble("LSQ", "DeltaMagnification", 1.0);
	m_OptRegionX0 = IniFile->GetDouble("LSQ", "OptRegionX0", 5);
	m_OptRegionX1 = IniFile->GetDouble("LSQ", "OptRegionX1", 70);
	m_OutputRegionX0 = IniFile->GetDouble("LSQ", "OutputRegionX0", 5);
	m_OutputRegionX1 = IniFile->GetDouble("LSQ", "OutputRegionX1", 70);
	m_AutoRedraw = IniFile->Getbool("LSQ", "AutoRedraw", 1);
	m_b0 = IniFile->GetDouble("LSQ", "b0", 0.0);
	m_b1 = IniFile->GetDouble("LSQ", "b1", 0.0);
	m_b2 = IniFile->GetDouble("LSQ", "b2", 0.0);
	m_b3 = IniFile->GetDouble("LSQ", "b3", 0.0);
	m_b4 = IniFile->GetDouble("LSQ", "b4", 0.0);
	m_Optimizeb0 = IniFile->Getbool("LSQ", "Optimizeb0", 1);
	m_Optimizeb1 = IniFile->Getbool("LSQ", "Optimizeb1", 1);
	m_Optimizeb2 = IniFile->Getbool("LSQ", "Optimizeb2", 0);
	m_Optimizeb3 = IniFile->Getbool("LSQ", "Optimizeb3", 0);
	m_Optimizeb4 = IniFile->Getbool("LSQ", "Optimizeb4", 0);
	m_Position = IniFile->GetDouble("LSQ", "Position", 28.6);
	m_OptimizePosition = IniFile->Getbool("LSQ", "OptimizePosition", 1);
	m_CTotal = IniFile->GetDouble("LSQ", "CTotal", 200);
	m_OptimizeCTotal = IniFile->Getbool("LSQ", "OptimizeCTotal", 1);
	m_GaussFraction = IniFile->GetDouble("LSQ", "GaussFraction", 0.5);
	m_OptimizeGaussFraction = IniFile->Getbool("LSQ", "OptimizeGaussFraction", 1);
	m_FWHMGLRatio = IniFile->GetDouble("LSQ", "FWHMGLRatio", 1.0);
	m_OptimizeFWHMGLRatio = IniFile->Getbool("LSQ", "OptimizeFWHMGLRatio", 1);
	m_CGauss = IniFile->GetDouble("LSQ", "CGauss", 100);
	m_OptimizeCGauss = IniFile->Getbool("LSQ", "OptimizeCGauss", 0);
	m_FWHMGauss = IniFile->GetDouble("LSQ", "FWHMGauss", 0.2);
	m_OptimizeFWHMGauss = IniFile->Getbool("LSQ", "OptimizeFWHMGauss", 0);
	m_CLorentz = IniFile->GetDouble("LSQ", "CLorentz", 100);
	m_OptimizeCLorentz = IniFile->Getbool("LSQ", "OptimizeCLorentz", 1);
	m_FWHMLorentz = IniFile->GetDouble("LSQ", "FWHMLorentz", 0.2);
	m_OptimizeFWHMLorentz = IniFile->Getbool("LSQ", "OptimizeFWHMLorentz", 1);
	m_Aniso = IniFile->GetDouble("LSQ", "Aniso", 0.0);
	m_OptimizeAniso = IniFile->Getbool("LSQ", "OptimizeAniso", 0);

	m_IRatio = IniFile->GetDouble("LSQ", "IRatio", 0.5);
	m_LKa1 = IniFile->GetDouble("LSQ", "LKa1", 1.540560);
	m_LKa2 = IniFile->GetDouble("LSQ", "LKa2", 1.544390);
	m_QRange = IniFile->GetDouble("LSQ", "QRange", 5);
	UpdateData(FALSE);
	return 0;
}

void CSetupCurveFitView::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
//	SaveCurrentSetting();
	CFormView::OnClose();
}

void CSetupCurveFitView::OnPfcpathbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char str[256];
	IniFile->GetString("Preferences", "PFCDir", "", str);
	SetCurrentDirectory(str);
	CFileDialog fd(true, NULL, NULL, OFN_HIDEREADONLY, 
		"CurveFit Files (*.pfc)|*.pfc|All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;
	strcpy(str, fd.GetPathName());
	char *cp = strrchr(str, '\\');
	if(cp != NULL) *cp = 0;
	IniFile->WriteString("Preferences", "PFCDir", str);
	SetCurrentDirectory(str);

	m_PFCPath = fd.GetPathName();
	UpdateData(FALSE);
	ReadPFCFile(m_PFCPath);
}

int CSetupCurveFitView::ReadPFCFile(LPCSTR pfcfile)
{
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
		return ReadXRDPFCFile(pfcfile);
	else
		return ReadRamanPFCFile(pfcfile);
}

int CSetupCurveFitView::ReadRamanPFCFile(LPCSTR pfcfile)
{
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();

	if(pPeak->ReadPFCFile(pfcfile, true) != 1) return -1;
	GetDocument()->m_Comment = "";
	m_b0 = pPeak->m_BGb[0];
	m_b1 = pPeak->m_BGb[1];
	m_b2 = pPeak->m_BGb[2];
	m_b3 = pPeak->m_BGb[3];
	m_b4 = pPeak->m_BGb[4];
	m_Optimizeb0 = pPeak->m_OptimizeBGb[0];
	m_Optimizeb1 = pPeak->m_OptimizeBGb[1];
	m_Optimizeb2 = pPeak->m_OptimizeBGb[2];
	m_Optimizeb3 = pPeak->m_OptimizeBGb[3];
	m_Optimizeb4 = pPeak->m_OptimizeBGb[4];
	m_IRatio = pPeak->m_IRatio;
	m_LKa1 = pPeak->m_LKa1;
	m_LKa2 = pPeak->m_LKa2;
	m_QRange = pPeak->m_QRange;
	m_OutputRegionX0 = pPeak->m_OutputRegionX0;
	m_OutputRegionX1 = pPeak->m_OutputRegionX1;
	m_OptRegionX0 = pPeak->m_OptRegionX0;
	m_OptRegionX1 = pPeak->m_OptRegionX1;
	m_InputPath = pPeak->m_DataPath;
	UpdatePeakList(0);
	if(GetDocument()->CreateGraphFrameWithData(1) <= 0)
	{
		MessageBox("Can't Create GraphFrame", "CSetupCurveFitView::OnRamanPFCFile");
		return -1;
	}
	GetDocument()->SetPathName(pPeak->m_DataPath, TRUE);
	GetDocument()->GetGraphFrameArray()->CalcAllFrameViewRange();
	GetGraphFrame(0)->SetXAxisString(CString("Wave number / cm-1"));
	GetGraphFrame(0)->SetYAxisString(CString("Raman Intensity"));
	GetGraphFrame(0)->SetViewXMin(m_OutputRegionX0);
	GetGraphFrame(0)->SetViewXMax(m_OutputRegionX1);
	GetDocument()->UpdateAllViews(this);
	return 1;
}

int CSetupCurveFitView::ReadXRDPFCFile(LPCSTR pfcfile)
{
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();

	if(pPeak->ReadPFCFile(pfcfile, true) != 1) return -1;
	m_b0 = pPeak->m_BGb[0];
	m_b1 = pPeak->m_BGb[1];
	m_b2 = pPeak->m_BGb[2];
	m_b3 = pPeak->m_BGb[3];
	m_b4 = pPeak->m_BGb[4];
	m_Optimizeb0 = pPeak->m_OptimizeBGb[0];
	m_Optimizeb1 = pPeak->m_OptimizeBGb[1];
	m_Optimizeb2 = pPeak->m_OptimizeBGb[2];
	m_Optimizeb3 = pPeak->m_OptimizeBGb[3];
	m_Optimizeb4 = pPeak->m_OptimizeBGb[4];
	m_IRatio = pPeak->m_IRatio;
	m_LKa1 = pPeak->m_LKa1;
	m_LKa2 = pPeak->m_LKa2;
	m_QRange = pPeak->m_QRange;
	m_OutputRegionX0 = pPeak->m_OutputRegionX0;
	m_OutputRegionX1 = pPeak->m_OutputRegionX1;
	m_OptRegionX0 = pPeak->m_OptRegionX0;
	m_OptRegionX1 = pPeak->m_OptRegionX1;
	m_InputPath = pPeak->m_DataPath;
	UpdatePeakList(0);
	if(GetDocument()->CreateGraphFrameWithData(1) <= 0)
	{
		MessageBox("Can't Create GraphFrame", "CSetupCurveFitView::OnPfcpathbutton");
		return -1;
	}
	GetDocument()->SetPathName(pPeak->m_DataPath, TRUE);
	GetDocument()->GetGraphFrameArray()->CalcAllFrameViewRange();
	GetGraphFrame(0)->SetXAxisString(CString("Diffraction angle 2Theta / deg."));
	GetGraphFrame(0)->SetYAxisString(CString("Intensity"));
	GetGraphFrame(0)->SetViewXMin(m_OutputRegionX0);
	GetGraphFrame(0)->SetViewXMax(m_OutputRegionX1);
	GetDocument()->UpdateAllViews(this);
	return 1;
}

int CSetupCurveFitView::SaveCurrentSetting()
{
	UpdateData(TRUE);
	IniFile->WriteString("LSQ", "InputPath", (LPCSTR)m_InputPath);
	IniFile->WriteString("LSQ", "OutputPath", (LPCSTR)m_OutputPath);
	IniFile->WriteString("LSQ", "PFCPath", (LPCSTR)m_PFCPath);
	IniFile->WriteDouble("LSQ", "DeltaMagnification", m_DeltaMag);
	IniFile->WriteDouble("LSQ", "OptRegionX0", m_OptRegionX0);
	IniFile->WriteDouble("LSQ", "OptRegionX1", m_OptRegionX1);
	IniFile->WriteDouble("LSQ", "OutputRegionX0", m_OutputRegionX0);
	IniFile->WriteDouble("LSQ", "OutputRegionX1", m_OutputRegionX1);
	IniFile->WriteBool("LSQ", "AutoRedraw", m_AutoRedraw);
	IniFile->WriteDouble("LSQ", "Position", m_Position);
	IniFile->WriteBool("LSQ", "OptimizePosition", m_OptimizePosition);
	IniFile->WriteDouble("LSQ", "CGauss", m_CGauss);
	IniFile->WriteBool("LSQ", "OptimizeCGauss", m_OptimizeCGauss);
	IniFile->WriteDouble("LSQ", "CLorentz", m_CLorentz);
	IniFile->WriteBool("LSQ", "OptimizeCLorentz", m_OptimizeCLorentz);
	IniFile->WriteDouble("LSQ", "FWHMLorentz", m_FWHMLorentz);
	IniFile->WriteBool("LSQ", "OptimizeFWHMLorentz", m_OptimizeFWHMLorentz);
	IniFile->WriteDouble("LSQ", "FWHMGauss", m_FWHMGauss);
	IniFile->WriteBool("LSQ", "OptimizeFWHMGauss", m_OptimizeFWHMGauss);
	IniFile->WriteDouble("LSQ", "Aniso", m_Aniso);
	IniFile->WriteBool("LSQ", "OptimizeAniso", m_OptimizeAniso);

	IniFile->WriteDouble("LSQ", "IRatio", m_IRatio);
	IniFile->WriteDouble("LSQ", "LKa1", m_LKa1);
	IniFile->WriteDouble("LSQ", "LKa2", m_LKa2);
	IniFile->WriteDouble("LSQ", "QRange", m_QRange);
	return 0;
}

void CSetupCurveFitView::OnDestroy() 
{
	SaveCurrentSetting();
	CFormView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
}

void CSetupCurveFitView::OnGetViewRangeAsOutputRegionButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) return;
	m_OutputRegionX0 = pFrame->ViewXMin();
	m_OutputRegionX1 = pFrame->ViewXMax();
	UpdateData(FALSE);
}

void CSetupCurveFitView::OnGetViewRangeAsOptRegionButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) return;
	m_OptRegionX0 = pFrame->ViewXMin();
	m_OptRegionX1 = pFrame->ViewXMax();
	UpdateData(FALSE);
}

void CSetupCurveFitView::OnPeaksearchbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdatePeakList(0);
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) return;
	CGraphData *pData = pFrame->GetGraphData(0);
	if(pData == NULL) return;

	UpdateData(TRUE);
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	pPeak->m_OutputRegionX0 = m_OutputRegionX0;
	pPeak->m_OutputRegionX1 = m_OutputRegionX1;
	CPeakSearchDialog psd(pData, pPeak);
	
	if(psd.DoModal() == IDOK)
	{
		UpdatePeakList(0);
		GetDocument()->UpdateAllViews(this);
	}
}

void CSetupCurveFitView::OnClearpeaksbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDocument()->GetPeakSearch()->RemoveAll();
	UpdatePeakList(0);
}

void CSetupCurveFitView::OnAddpeakbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	int idx = m_PeakList.GetCurSel();
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	int ii;
	if(idx == LB_ERR || idx >= pPeak->m_nPeaks || idx < 0)
	{
		if(pPeak->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
			ii = pPeak->AddPeak((m_OptRegionX0+m_OptRegionX1)/2.0, 2000, 0.5, 1.0, 0.2);
		else
			ii = pPeak->AddPeak((m_OptRegionX0+m_OptRegionX1)/2.0, 50, 0.5, 1.0, 10.0);
	}
	else
	{
		ii = pPeak->AddPeak(m_Position, m_CTotal, m_GaussFraction, m_FWHMGLRatio,
							m_FWHMLorentz);
	}
	ii--;
	if(ii < 0) return;
	UpdatePeakList(ii);
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnDeletepeakbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int idx = m_PeakList.GetCurSel();
	if(idx == LB_ERR) return;
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	pPeak->DeletePeak(idx);
	if(idx < 0) idx = 0;
	else if(idx >= m_PeakList.GetCount())
		idx--;
	UpdatePeakList(idx);
}

void CSetupCurveFitView::UpdatePeakSearch()
{
	UpdateData(TRUE);
	int idx = m_iPeak;
//	if(idx == m_PeakList.GetCurSel()) return;
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	pPeak->m_DataPath = m_InputPath;
	pPeak->m_Position[idx] = m_Position;
	if(m_OptimizePosition) pPeak->m_OptimizePosition[idx] = 1;
	else pPeak->m_OptimizePosition[idx] = 0;
	pPeak->m_CTotal[idx] = m_CTotal;
	if(m_OptimizeCTotal) pPeak->m_OptimizeCTotal[idx] = 1;
	else pPeak->m_OptimizeCTotal[idx] = 0;
	pPeak->m_GaussFraction[idx] = m_GaussFraction;
	if(m_OptimizeGaussFraction) pPeak->m_OptimizeGaussFraction[idx] = 1;
	else pPeak->m_OptimizeGaussFraction[idx] = 0;
	pPeak->m_FWHMGLRatio[idx] = m_FWHMGLRatio;
	if(m_OptimizeFWHMGLRatio) pPeak->m_OptimizeFWHMGLRatio[idx] = 1;
	else pPeak->m_OptimizeFWHMGLRatio[idx] = 0;
	pPeak->m_CGauss[idx] = m_CGauss;
	if(m_OptimizeCGauss) pPeak->m_OptimizeCGauss[idx] = 1;
	else pPeak->m_OptimizeCGauss[idx] = 0;
	pPeak->m_FWHMGauss[idx] = m_FWHMGauss;
	if(m_OptimizeFWHMGauss) pPeak->m_OptimizeFWHMGauss[idx] = 1;
	else pPeak->m_OptimizeFWHMGauss[idx] = 0;
	pPeak->m_CLorentz[idx] = m_CLorentz;
	if(m_OptimizeCLorentz) pPeak->m_OptimizeCLorentz[idx] = 1;
	else pPeak->m_OptimizeCLorentz[idx] = 0;
	pPeak->m_FWHMLorentz[idx] = m_FWHMLorentz;
	if(m_OptimizeFWHMLorentz) pPeak->m_OptimizeFWHMLorentz[idx] = 1;
	else pPeak->m_OptimizeFWHMLorentz[idx] = 0;
	pPeak->m_Aniso[idx] = m_Aniso;
	if(m_OptimizeAniso) pPeak->m_OptimizeAniso[idx] = 1;
	else pPeak->m_OptimizeAniso[idx] = 0;

	pPeak->m_iCurrentPeak = m_iPeak;
	char str[256];
	IniFile->GetString("SetupLSQ", "XRDLSQProgram", "", str);
	pPeak->m_XRDLSQProgram = str;
	IniFile->GetString("SetupLSQ", "RamanLSQProgram", "", str);
	pPeak->m_RamanLSQProgram = str;
	pPeak->m_LSQMethod  = "Marq";
//	pPeak->m_MaxIter             = IniFile->GetInt("SetupLSQ", "MaxIteration", 30);
//	pPeak->m_ConvergenceCriteria = IniFile->GetDouble("SetupLSQ", "ConvergenceCriteria", 0.01);
//	pPeak->m_DumpingFactor       = IniFile->GetDouble("SetupLSQ", "DumpingFactor", 0.3);
	pPeak->m_BGb[0] = m_b0;
	pPeak->m_BGb[1] = m_b1;
	pPeak->m_BGb[2] = m_b2;
	pPeak->m_BGb[3] = m_b3;
	pPeak->m_BGb[4] = m_b4;
	pPeak->m_OptimizeBGb[0] = m_Optimizeb0;
	pPeak->m_OptimizeBGb[1] = m_Optimizeb1;
	pPeak->m_OptimizeBGb[2] = m_Optimizeb2;
	pPeak->m_OptimizeBGb[3] = m_Optimizeb3;
	pPeak->m_OptimizeBGb[4] = m_Optimizeb4;
	pPeak->m_IRatio = m_IRatio;
	pPeak->m_LKa1   = m_LKa1;
	pPeak->m_LKa2   = m_LKa2;
	pPeak->m_QRange = m_QRange;
	pPeak->m_OptRegionX0    = m_OptRegionX0;
	pPeak->m_OptRegionX1    = m_OptRegionX1;
	pPeak->m_OutputRegionX0 = m_OutputRegionX0;
	pPeak->m_OutputRegionX1 = m_OutputRegionX1;
}

void CSetupCurveFitView::OnSelchangePeaklistcombo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	UpdatePeakSearch();

	int idx = m_PeakList.GetCurSel();
	if(idx == LB_ERR) return;
	UpdatePeakList(idx);
	GetDocument()->UpdateAllViews(this);
}

int CSetupCurveFitView::UpdatePeakList(int idx)
{
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	while(1)
		if(m_PeakList.DeleteString(0) == LB_ERR) break;
	for(int i = 0 ; i < pPeak->m_nPeaks ; i++)
	{
		char str[256];
		sprintf(str, "%3d: %7.4f %7.0f %6.4f %5.3f %5.3f",
				i, pPeak->m_Position[i], pPeak->m_CTotal[i], pPeak->m_FWHMLorentz[i],
				pPeak->m_GaussFraction[i], pPeak->m_FWHMGLRatio[i]);
		m_PeakList.AddString(str);
	}
	if(m_PeakList.SetCurSel(idx) == LB_ERR) return -1;
	pPeak->m_iCurrentPeak = idx;
	m_iPeak = idx;
	m_Position = pPeak->m_Position[idx];
	m_CTotal = pPeak->m_CTotal[idx];
	m_GaussFraction = pPeak->m_GaussFraction[idx];
	m_FWHMGLRatio = pPeak->m_FWHMGLRatio[idx];
	m_CGauss = pPeak->m_CGauss[idx];
	m_FWHMGauss = pPeak->m_FWHMGauss[idx];
	m_CLorentz = pPeak->m_CLorentz[idx];
	m_FWHMLorentz = pPeak->m_FWHMLorentz[idx];
	m_Aniso = pPeak->m_Aniso[idx];
	m_OptimizePosition = pPeak->m_OptimizePosition[idx];
	m_OptimizeCTotal = pPeak->m_OptimizeCTotal[idx];
	m_OptimizeGaussFraction = pPeak->m_OptimizeGaussFraction[idx];
	m_OptimizeFWHMGLRatio = pPeak->m_OptimizeFWHMGLRatio[idx];
	m_OptimizeCGauss = pPeak->m_OptimizeCGauss[idx];
	m_OptimizeFWHMGauss = pPeak->m_OptimizeFWHMGauss[idx];
	m_OptimizeCLorentz = pPeak->m_OptimizeCLorentz[idx];
	m_OptimizeFWHMLorentz = pPeak->m_OptimizeFWHMLorentz[idx];
	m_OptimizeAniso = pPeak->m_OptimizeAniso[idx];
	UpdateData(FALSE);
	return idx;
}

void CSetupCurveFitView::OnDeltaposB0spin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_b0 -= 0.005 * fabs(m_b0) * pNMUpDown->iDelta * m_DeltaMag;
	UpdateData(FALSE);
	m_b0Spin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);

	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposB1spin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_b1 -= 0.005 * fabs(m_b1) * pNMUpDown->iDelta * m_DeltaMag;
	UpdateData(FALSE);
	m_b1Spin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposB2spin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_b2 -= 0.005 * fabs(m_b2) * pNMUpDown->iDelta * m_DeltaMag;
	UpdateData(FALSE);
	m_b2Spin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposB3spin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_b3 -= 0.005 * fabs(m_b3) * pNMUpDown->iDelta * m_DeltaMag;
	UpdateData(FALSE);
	m_b3Spin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposB4spin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_b4 -= 0.005 * fabs(m_b4) * pNMUpDown->iDelta * m_DeltaMag;
	UpdateData(FALSE);
	m_b4Spin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposCgaussspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_CGauss -= 0.005 * fabs(m_CGauss) * pNMUpDown->iDelta * m_DeltaMag;
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
	{
		m_CLorentz = m_CTotal - m_CGauss;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	else
	{
		m_CTotal = m_CGauss + m_CLorentz;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	UpdateData(FALSE);
	m_CGaussSpin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);

	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposClorentzspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_CLorentz -= 0.005 * fabs(m_CLorentz) * pNMUpDown->iDelta * m_DeltaMag;
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
	{
		m_CGauss = m_CTotal - m_CLorentz;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	else
	{
		m_CTotal = m_CGauss + m_CLorentz;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	UpdateData(FALSE);
	m_CLorentzSpin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposCtotalspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_CTotal -= 0.005 * fabs(m_CTotal) * pNMUpDown->iDelta * m_DeltaMag;
	m_CGauss = m_CTotal * m_GaussFraction;
	m_CLorentz = m_CTotal - m_CGauss;
	UpdateData(FALSE);
	m_CTotalSpin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposFwhmgaussspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
	{
		m_FWHMGauss -= 0.005*pNMUpDown->iDelta * m_DeltaMag;
		m_FWHMLorentz = m_FWHMGauss / m_FWHMGLRatio;
	}
	else
	{
		m_FWHMGauss -= 0.2*pNMUpDown->iDelta * m_DeltaMag;
		m_FWHMLorentz = m_FWHMGauss / m_FWHMGLRatio;
	}
	UpdateData(FALSE);
	m_FWHMGaussSpin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);

	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposFwhmglratiospin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_FWHMGLRatio -= 0.05*pNMUpDown->iDelta;
	m_FWHMLorentz = m_FWHMGauss / m_FWHMGLRatio;
	UpdateData(FALSE);
	m_FWHMGLRatioSpin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposFwhmlorentzspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
	{
		m_FWHMLorentz -= 0.005*pNMUpDown->iDelta * m_DeltaMag;
		m_FWHMGauss = m_FWHMLorentz * m_FWHMGLRatio;
	}
	else
	{
		m_FWHMLorentz -= 0.2*pNMUpDown->iDelta * m_DeltaMag;
		m_FWHMGauss = m_FWHMLorentz * m_FWHMGLRatio;
	}
	UpdateData(FALSE);
	m_FWHMLorentzSpin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposGaussfractionspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_GaussFraction -= 0.02*pNMUpDown->iDelta;
	m_CGauss = m_CTotal * m_GaussFraction;
	m_CLorentz = m_CTotal - m_CGauss;
	UpdateData(FALSE);
	m_GaussFractionSpin.SetPos(0);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);

	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposAnisotropyspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_Aniso -= 0.05 * pNMUpDown->iDelta * m_DeltaMag;
	UpdateData(FALSE);
	m_AnisoSpin.SetPos(0);

	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnDeltaposPositionspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
		m_Position -= 0.005 * pNMUpDown->iDelta * m_DeltaMag;
	else
		m_Position -= 0.2 * pNMUpDown->iDelta * m_DeltaMag;
	UpdateData(FALSE);
	m_PositionSpin.SetPos(0);

	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
	
	*pResult = 0;
}

void CSetupCurveFitView::OnExeccurvefitbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdatePeakSearch();

	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) 
	{
		MessageBox("Can't get pFrame", "Error in CSetupCurveFitView::OnExeccuvefitbutton");
		return;
	}
	CGraphData *pData = pFrame->GetGraphData(0);
	if(pData == NULL) 
	{
		MessageBox("Can't get pData", "Error in CSetupCurveFitView::OnExeccuvefitbutton");
		return;
	}

	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();

	if(pPeak->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
	{
		if(pPeak->m_MaxIter > 30)
		{
			CString s;
			s.Format("MaxIter [%d] is larger than 30\r\n   Continue?", pPeak->m_MaxIter);
			if(MessageBox(s, "Very Large MaxIter", MB_YESNO) != IDYES) return;
		}
	}
	else
	{
		if(pPeak->IsUsePeakFit(pPeak->m_RamanLSQProgram))
		{
			if(pPeak->m_MaxIter > 30)
			{
				CString s;
				s.Format("MaxIter [%d] is larger than 30\r\n   Continue?", pPeak->m_MaxIter);
				if(MessageBox(s, "Very Large MaxIter", MB_YESNO) != IDYES) return;
			}
		}
		else
		{
			if(pPeak->m_MaxIter < 100)
			{
				CString s;
				s.Format("MaxIter [%d] is smaller than 100\r\n   Continue?", pPeak->m_MaxIter);
				if(MessageBox(s, "Very Small MaxIter", MB_YESNO) != IDYES) return;
			}
		}
	}
	pPeak->SavePFCFile((LPCSTR)m_PFCPath);

	if(pPeak->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
		ExecutePeakFitLSQ(pPeak->m_XRDLSQProgram);
	else
	{
		if(pPeak->IsUsePeakFit(pPeak->m_RamanLSQProgram))
			ExecutePeakFitLSQ(pPeak->m_RamanLSQProgram);
		else
			ExecuteRmnFitLSQ();
	}
}

int CSetupCurveFitView::ExecuteRmnFitLSQ()
{
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();

	STARTUPINFO StartupInfo;
	PROCESS_INFORMATION ProcessInformation;
	GetStartupInfo(&StartupInfo);
	SECURITY_ATTRIBUTES SecurityAttribute;
	SecurityAttribute.nLength = sizeof(SECURITY_ATTRIBUTES);
	SecurityAttribute.lpSecurityDescriptor = NULL;
	SecurityAttribute.bInheritHandle = TRUE;
	char str[256], dir[256];
	strcpy(dir, (LPCSTR)m_PFCPath);
	char *cp = strrchr(dir, '\\');
	if(cp != NULL) *cp = 0;
	SetCurrentDirectory(dir);

	sprintf(str, "%s\\prev.pfc", dir);
	if(CopyFile((LPCSTR)m_PFCPath, str, FALSE) == 0)
	{
		CString s;
		s.Format("Can't copy [%s] to [%s]", LPCSTR(m_PFCPath), str);
		MessageBox(s, "Error");
		return -1;
	}
	sprintf(str, "%s\\fit.pfc", dir);
	if(CopyFile((LPCSTR)m_PFCPath, str, FALSE) == 0)
	{
		CString s;
		s.Format("Can't copy [%s] to [%s]", LPCSTR(m_PFCPath), str);
		MessageBox(s, "Error");
		return -1;
	}
	DeleteFile(m_PFCPath);
	sprintf(str, "%s\\prevout.txt", dir);
	if(CopyFile((LPCSTR)m_OutputPath, str, FALSE) == 0)
	{
//		CString s;
//		s.Format("Can't copy [%s] to [%s]", LPCSTR(m_OutputPath), str);
//		MessageBox(s, "Error");
//		return -1;
	}
	DeleteFile(m_OutputPath);
	sprintf(str, "%s\\new.pfc", dir);
	DeleteFile(str);

	if (CreateProcess(NULL, (char *)(LPCSTR)(pPeak->m_RamanLSQProgram), NULL, NULL, TRUE, 
				CREATE_NEW_CONSOLE, NULL, NULL, &StartupInfo, &ProcessInformation)) 
	{
		WaitForSingleObject(ProcessInformation.hProcess, INFINITE);
	}
	else
	{
		CString s;
		s = "Can't exec [" + pPeak->m_RamanLSQProgram + "]";
		MessageBox(s, "Error");
		return -1;
	}

	sprintf(str, "%s\\out.txt", dir);
	if(CopyFile(str, (LPCSTR)m_OutputPath, FALSE) == 0)
	{
		CString s;
		s.Format("Can't copy [%s] to [%s]", str, (LPCSTR)m_OutputPath);
		MessageBox(s, "Error");
//		return -1;
	}

	sprintf(str, "%s\\new.pfc", dir);
	if(CopyFile(str, (LPCSTR)m_PFCPath, FALSE) == 0)
	{
		if(GetFileAttributes(str) == 0xffffffff)
		{
			CString s;
			s.Format("File [%s] doesn't exist\r\n"
					 "Some error must occur in the calculation\r\n"
					 "Retrieve previous file", str);
			MessageBox(str, "Calculation error");
		}
		else
		{
			CString s;
			s.Format("Can't copy [%s] to [%s]\r\n", 
					 "Some error must occur in file system\r\n"
					 "Retrieve previous file", str, LPCSTR(m_PFCPath));
			MessageBox(s, "Error");
		}
		sprintf(str, "%s\\prev.pfc", dir);
		if(CopyFile(str, (LPCSTR)m_PFCPath, FALSE) == 0)
		{
			CString s;
			s.Format("Can't copy [%s] to [%s]", str, LPCSTR(m_PFCPath));
			MessageBox(s, "Error");
		}
//		return -1;
	}

	ReadPFCFile((LPCSTR)m_PFCPath);
	GetDocument()->GetCurveFitEditView()->ClearText();
	GetDocument()->GetCurveFitEditView()->ReadTextFile(m_OutputPath);
	FILE *in;
	if((in = fopen((LPCSTR)m_OutputPath, "rb")) == NULL)
	{
	}
	else
	{
		bool IsAdd = false;
		GetDocument()->m_Comment = "";
		while(!feof(in))
		{
			*str = 0;
			fgets(str, 256, in);
			if(strstr(str, "[Peak Area]") != NULL)
				IsAdd = true;
			else if(IsAdd && strstr(str, "[") != NULL)
				IsAdd = false;
			if(IsAdd)
				GetDocument()->m_Comment += str;
		}
		fclose(in);
		CString ss;
		ss.Format("\r\nSigma: %lg   %lg %%", pPeak->m_Sigma, pPeak->m_PercentSigma);
		(GetDocument()->m_Comment) += ss;
	}
	return 1;
}

int CSetupCurveFitView::ExecutePeakFitLSQ(LPCSTR LSQProgram)
{
	CString command;
	char str[256], dir[256];
	char *cp;
	strcpy(dir, (LPCSTR)m_PFCPath);
	cp = strrchr(dir, '\\');
	if(cp != NULL) *cp = 0;
	SetCurrentDirectory(dir);

	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	command.Format("\"%s\" \"%s\"", LSQProgram, (LPCSTR)m_PFCPath);
	STARTUPINFO StartupInfo;
	PROCESS_INFORMATION ProcessInformation;
	GetStartupInfo(&StartupInfo);
	SECURITY_ATTRIBUTES SecurityAttribute;
	SecurityAttribute.nLength = sizeof(SECURITY_ATTRIBUTES);
	SecurityAttribute.lpSecurityDescriptor = NULL;
	SecurityAttribute.bInheritHandle = TRUE;
/*
	HANDLE Handle_Stdout;
	Handle_Stdout = CreateFile((LPCSTR)m_OutputPath, GENERIC_WRITE, 0, &SecurityAttribute,
							CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (Handle_Stdout == INVALID_HANDLE_VALUE) 
	{
		CString s;
		s = "Can't write to [" + m_OutputPath + "]";
        MessageBox(s, "Error");
		return -1;
	}
	StartupInfo.dwFlags = StartupInfo.dwFlags | STARTF_USESTDHANDLES;
	StartupInfo.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	StartupInfo.hStdError = Handle_Stdout;
	StartupInfo.hStdOutput = Handle_Stdout;
*/
	sprintf(str, "%s\\prev.pfc", dir);
	if(CopyFile((LPCSTR)m_PFCPath, str, FALSE) == 0)
	{
		CString s;
		s.Format("Can't copy [%s] to [%s]", LPCSTR(m_PFCPath), str);
		MessageBox(s, "Error");
		return -1;
	}
	sprintf(str, "%s\\prevout.txt", dir);
	if(CopyFile((LPCSTR)m_OutputPath, str, FALSE) == 0)
	{
//		CString s;
//		s.Format("Can't copy [%s] to [%s]", LPCSTR(m_OutputPath), str);
//		MessageBox(s, "Error");
//		return -1;
	}
	DeleteFile(m_OutputPath);
	sprintf(str, "%s\\new.pfc", dir);
	DeleteFile(str);

	if (CreateProcess(NULL, (char *)(LPCTSTR)command, NULL, NULL, TRUE, 
				CREATE_NEW_CONSOLE, NULL, NULL, &StartupInfo, &ProcessInformation)) 
	{
		WaitForSingleObject(ProcessInformation.hProcess, INFINITE);
	}
	else
	{
		CString s;
		s = "Can't exec [" + command + "]";
		MessageBox(s, "Error");
//		CloseHandle(Handle_Stdout);
		return -1;
	}
//	CloseHandle(Handle_Stdout);

	sprintf(str, "%s\\out.txt", dir);
	if(CopyFile(str, (LPCSTR)m_OutputPath, FALSE) == 0)
	{
		CString s;
		s.Format("Can't copy [%s] to [%s]", str, (LPCSTR)m_OutputPath, str);
		MessageBox(s, "Error");
//		return -1;
	}
	sprintf(str, "%s\\new.pfc", dir);
	if(CopyFile(str, (LPCSTR)m_PFCPath, FALSE) == 0)
	{
		if(GetFileAttributes(str) == 0xffffffff)
		{
			CString s;
			s.Format("File [%s] doesn't exist\r\n"
					 "Some error must occur in the calculation\r\n"
					 "Retrieve previous file", str);
			MessageBox(str, "Calculation error");
		}
		else
		{
			CString s;
			s.Format("Can't copy [%s] to [%s]\r\n", 
					 "Some error must occur in file system\r\n"
					 "Retrieve previous file", str, LPCSTR(m_PFCPath));
			MessageBox(s, "Error");
		}
		sprintf(str, "%s\\prev.pfc", dir);
		if(CopyFile(str, (LPCSTR)m_PFCPath, FALSE) == 0)
		{
			CString s;
			s.Format("Can't copy [%s] to [%s]", str, LPCSTR(m_PFCPath));
			MessageBox(s, "Error");
		}
//		return -1;
	}

	ReadPFCFile((LPCSTR)m_PFCPath);
	GetDocument()->GetCurveFitEditView()->ClearText();
	GetDocument()->GetCurveFitEditView()->ReadTextFile(m_OutputPath);
	FILE *in;
	if((in = fopen((LPCSTR)m_OutputPath, "rb")) == NULL)
	{
	}
	else
	{
		bool IsAdd = false;
		GetDocument()->m_Comment = "";
		double sigma = -1, psigma = -1;
		while(!feof(in))
		{
			*str = 0;
			fgets(str, 256, in);
			if(strstr(str, "*** Peak area: #   2Q") != NULL)
				IsAdd = true;
			if(strncmp(str, " Start cycle ", 13) == 0)
			{
				int i;
				sscanf(str+13, "%d %lg %lg", &i, &sigma, &psigma);
			}
			if(IsAdd)
				GetDocument()->m_Comment += str;
		}
		fclose(in);
		CString ss;
		ss.Format("\r\nSigma: %lg   %lg %%", sigma, psigma);
		(GetDocument()->m_Comment) += ss;
	}
	return 1;
}

void CSetupCurveFitView::OnEditpfcfilebutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString command;
	char editor[256];
	IniFile->GetString("Preferences", "Editor", "notepad.exe", editor);
	command.Format("\"%s\" \"%s\"", editor, (LPCSTR)m_PFCPath);
	if(WinExec(command, SW_SHOW) < 32)
	{
		CString err;
		err = "Can't exec [" + command + "]";
		MessageBox(err, "Error in CSetupCurveFitView::OnEditpfcfilebutton");
		return;
	}
}

void CSetupCurveFitView::OnEditoutputfilebutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString command;
	char editor[256];
	IniFile->GetString("Preferences", "Editor", "notepad.exe", editor);
	command.Format("\"%s\" \"%s\"", editor, (LPCSTR)m_OutputPath);
	if(WinExec(command, SW_SHOW) < 32)
	{
		CString err;
		err = "Can't exec [" + command + "]";
		MessageBox(err, "Error in CSetupCurveFitView::OnEditoutputfilebutton");
		return;
	}
}

void CSetupCurveFitView::OnEditinputfilebutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString command;
	char editor[256];
	IniFile->GetString("Preferences", "Editor", "notepad.exe", editor);
	command.Format("\"%s\" \"%s\"", editor, (LPCSTR)m_InputPath);
	if(WinExec(command, SW_SHOW) < 32)
	{
		CString err;
		err = "Can't exec [" + command + "]";
		MessageBox(err, "Error in CSetupCurveFitView::OnEditinputfilebutton");
		return;
	}
}

void CSetupCurveFitView::OnSetoptimizeviewrangebutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	GetGraphFrame(0)->SetViewXMin(m_OptRegionX0);
	GetGraphFrame(0)->SetViewXMax(m_OptRegionX1);
	GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnSetoutputviewrangebutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	GetGraphFrame(0)->SetViewXMin(m_OutputRegionX0);
	GetGraphFrame(0)->SetViewXMax(m_OutputRegionX1);
	GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnSavepfcfilebutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdatePeakSearch();
	char str[256];
	IniFile->GetString("Preferences", "PFCDir", "", str);
	SetCurrentDirectory(str);
	CFileDialog fd(false, ".pfc", "*.pfc", OFN_HIDEREADONLY, 
		"PFC Files (*.pfc)|*.pfc|All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;
	strcpy(str, fd.GetPathName());
	char *cp = strrchr(str, '\\');
	if(cp != NULL) *cp = 0;
	IniFile->WriteString("Preferences", "PFCDir", str);
	SetCurrentDirectory(str);
	if(GetFileAttributes(fd.GetPathName()) != 0xffffffff)
	{
		CString s;
		s = "File [" + fd.GetPathName() + "] exists\r\n"
			+ "Overwrite it?";
		if(MessageBox(s, "Confirm", MB_YESNO) != IDYES) return;
	}
	GetDocument()->GetPeakSearch()->SavePFCFile(fd.GetPathName());
}

void CSetupCurveFitView::OnChangeB0edit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeB1edit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeB2edit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeB3edit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeB4edit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeCgaussedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
	{
		m_CLorentz = m_CTotal - m_CGauss;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	else
	{
		m_CTotal = m_CGauss + m_CLorentz;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	UpdateData(FALSE);
	UpdatePeakSearch();
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeClorentzedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	if(GetDocument()->GetPeakSearch()->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
	{
		m_CGauss = m_CTotal - m_CLorentz;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	else
	{
		m_CTotal = m_CGauss + m_CLorentz;
		m_GaussFraction = m_CGauss / m_CTotal;
	}
	UpdateData(FALSE);
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeCtotaledit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_CGauss = m_CTotal * m_GaussFraction;
	m_CLorentz = m_CTotal - m_CGauss;
	UpdateData(FALSE);
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeFwhmgaussedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_FWHMLorentz = m_FWHMGauss / m_FWHMGLRatio;
	m_FWHMGLRatio = m_FWHMGauss / m_FWHMLorentz;
	UpdateData(FALSE);
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeFwhmglratioedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_FWHMLorentz = m_FWHMGauss / m_FWHMGLRatio;
	UpdateData(FALSE);
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeFwhmlorentzedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_FWHMGauss = m_FWHMLorentz * m_FWHMGLRatio;
	m_FWHMGLRatio = m_FWHMGauss / m_FWHMLorentz;
	UpdateData(FALSE);
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeGaussfractionedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	m_CGauss = m_CTotal * m_GaussFraction;
	m_CLorentz = m_CTotal - m_CGauss;
	UpdateData(FALSE);
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeLka1edit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeLka2edit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangePositionedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeAnisotropyedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnChangeQrangeedit() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

void CSetupCurveFitView::OnDefaultxrdparambutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();

	UpdateData(TRUE);
	pPeak->m_LKa1 = m_LKa1 = 1.54056;
	pPeak->m_LKa2 = m_LKa2 = 1.54439;
	pPeak->m_QRange = m_QRange = 5;
	pPeak->m_IRatio = m_IRatio = 0.5;
	UpdateData(FALSE);
}


void CSetupCurveFitView::OnCalcbgbutton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) return;
	CGraphData *pData = pFrame->GetGraphData(0);
	if(pData == NULL) return;
	if(pData->nData() < 2) return;
	double x0 = m_OptRegionX0;
	double x1 = m_OptRegionX1;
	double y0 = pData->YVal(x0);
	double y1 = pData->YVal(x1);

	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	if(pPeak->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD ||
	   (pPeak->m_SpectrumKind != PEAKSEARCH_SPECTRUMKIND_XRD 
	     && pPeak->IsUsePeakFit(pPeak->m_RamanLSQProgram)))
	{
		m_b1 = (y1-y0) / (x1-x0);
		m_b0 = y1 -  m_b1*x1;
	}
	else
	{
		m_b1 = (y1-y0) / 2.0;
		m_b0 = y1 -  m_b1*1.0;
	}
	UpdateData(FALSE);
	UpdatePeakSearch();	
	if(m_AutoRedraw)
		GetDocument()->UpdateAllViews(this);
}

int CSetupCurveFitView::ReadFile(LPCSTR filename)
{
	UpdateData(TRUE);
	GetDocument()->m_Comment = "";
	SetCursor(theApp.LoadStandardCursor(IDC_WAIT));
	m_InputPath = filename;
	UpdateData(FALSE);

	IniFile->WriteString("LSQ", "InputPath", (LPCSTR)m_InputPath);
	m_OutputPath = m_InputPath;
	char str[MAX_PATH];
	strcpy(str, (LPCSTR)m_InputPath);

	char *cp = strrchr(str, '.');
	if(cp != NULL) 
	{
		if(stricmp(cp, ".xrd") == 0)
		{
			GetDocument()->GetPeakSearch()->m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
		}
		*cp = 0;
	}
	cp = strrchr(str, '\\');
	if(cp) *cp = 0;
	IniFile->WriteString("Preferences", "InputDir", str);
	char ss[MAX_PATH];
	strcpy(ss, filename);
	int iDataIndex = GetDocument()->ReadDataFile(ss);
//char s[256];
//sprintf(s, "iD=%d", iDataIndex);
//MessageBox("c", s);

	strcpy(str, (LPCSTR)m_InputPath);
	cp = strrchr(str, '.');
	if(cp) *cp = 0;
	sprintf(str+strlen(str), "#%d.pfc", iDataIndex);
	m_PFCPath = str;
	if(cp != NULL) *cp = 0;
	sprintf(str+strlen(str), "#%d.out", iDataIndex);
	m_OutputPath = str;
	UpdateData(FALSE);

	cp = strrchr(str, '\\');
	if(cp != NULL) *cp = 0;

	SetCursor(theApp.LoadStandardCursor(IDC_ARROW));

	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) return -1;
	pFrame->CalcFrameViewRange();
	GetDocument()->UpdateAllViews(this);
	CGraphData *pData = pFrame->GetGraphData(0);
	if(pData == NULL) return -1;
	m_OutputRegionX0 = m_OptRegionX0 = pData->MinX();
	m_OutputRegionX1 = m_OptRegionX1 = pData->MaxX();
	UpdateData(FALSE);
	
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	pPeak->RemoveAll();
	if(pPeak->ReadPFCFile(m_PFCPath) == 1)
	{
		m_b0 = pPeak->m_BGb[0];
		m_b1 = pPeak->m_BGb[1];
		m_b2 = pPeak->m_BGb[2];
		m_b3 = pPeak->m_BGb[3];
		m_b4 = pPeak->m_BGb[4];
		m_Optimizeb0 = pPeak->m_OptimizeBGb[0];
		m_Optimizeb1 = pPeak->m_OptimizeBGb[1];
		m_Optimizeb2 = pPeak->m_OptimizeBGb[2];
		m_Optimizeb3 = pPeak->m_OptimizeBGb[3];
		m_Optimizeb4 = pPeak->m_OptimizeBGb[4];
		if(pPeak->m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
		{
			m_IRatio = pPeak->m_IRatio;
			m_LKa1 = pPeak->m_LKa1;
			m_LKa2 = pPeak->m_LKa2;
			m_QRange = pPeak->m_QRange;
		}
		m_OutputRegionX0 = pPeak->m_OutputRegionX0;
		m_OutputRegionX1 = pPeak->m_OutputRegionX1;
		m_OptRegionX0 = pPeak->m_OptRegionX0;
		m_OptRegionX1 = pPeak->m_OptRegionX1;
		GetGraphFrame(0)->SetViewXMin(m_OutputRegionX0);
		GetGraphFrame(0)->SetViewXMax(m_OutputRegionX1);
	}
	UpdatePeakList(0);

	GetDocument()->GetCurveFitEditView()->ReadTextFile(m_OutputPath);
	return 1;
}

void CSetupCurveFitView::OnYAxisTypeButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
//	MessageBox("a","a");
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) return;
	if(GetDocument()->m_iYAxisType == YAXISTYPE_LINEAR)
	{
		GetDocument()->m_iYAxisType = YAXISTYPE_LOGABSY;
		m_YAxisType.SetWindowText("Lin");
		pFrame->SetForceViewRangeYMin(-6.0);
	}
	else
	{
		GetDocument()->m_iYAxisType = YAXISTYPE_LINEAR;
		m_YAxisType.SetWindowText("Log");
		pFrame->SetForceViewRangeYMin(0.0);
	}
	pFrame->SetYAxisType(GetDocument()->m_iYAxisType);
	GetDocument()->GetPeakSearch()->SetYAxisType(GetDocument()->m_iYAxisType);
	pFrame->CalcAllDataMinMax();
	pFrame->CalcFrameViewRange();
	CString s;
//	s.Format("%lg %lg %lg - %lg %lg", pFrame->GetGraphData(0)->MinY(), pFrame->ViewXMin(), pFrame->ViewYMin(), pFrame->ViewXMax(), pFrame->ViewYMax());
//	MessageBox(s,"s");
	GetDocument()->UpdateAllViews(this);
}
