package PHASE;
use Exporter;
@ISA = qw(Exporter);

#JTu[`
@EXPORT = qw();

#use lib "d:/Programs/Perl/lib";

use strict;
use File::Basename;

use ProgVars;
use Utils;
use GraphData;
use Sci::Science;
use Sci::EnergyBandArray;
#use MyTk::GraphFrameArray;

use Crystal::Crystal;
use Crystal::AtomType;
use Crystal::AtomSite;
use Crystal::XCrySDen;
use Crystal::CIF;

#===============================================
# XNvgϐ
#===============================================
my $LF = "<br>\n";
my $DirectorySeparator = Deps::DirectorySeparator(); #"\\";

#===============================================
# pXiǂݍDBj
# Web֌Wϐ
# CGI ̉zpX
# vO
#===============================================
my $Program        = ProgVars::Program();
my $ProgramDir     = ProgVars::ProgramDir();
my $ProgramOldDir  = ProgVars::ProgramOldDir();
my $PHASEDir      = ProgVars::PHASEDir();
my $PHASEPerlDir  = ProgVars::PHASEPerlDir();
my $PHASEPotDir   = ProgVars::PHASEPotDir();
my $WebRootDir     = ProgVars::WebRootDir();
my $KListDBDir     = ProgVars::KListDBDir();

#============================================================
#@ϐ擾AĒ`֐
#============================================================
sub ClearAll      { my $this=shift; delete $this->{FileType}; delete $this->{DataArray}; }
sub FileType      { return shift->{'FileType'}; }
sub FileName      { return shift->{'FileName'}; }
sub SetFileName   { my ($this,$f)=@_; return $this->{'FileName'} = $f; }
sub SetSampleName { my ($this,$n)=@_; return $this->{'SampleName'} = $n; }
sub SampleName    { return shift->{'SampleName'}; }
sub KListDBDir {
	my $this = shift;
	return $this->{'KListDBDir'} if($this->{'KListDBDir'});
	return $this->{'KListDBDir'} = $KListDBDir;
}
sub SetKListDBDir { 
	my($this, $d) = @_; 
	$this->{'KListDBDir'} = $d;
	return $d;
}
sub GetFileName {
	my($this, $path, $fname) = @_; 
	my $s;
	if(-d $path) {
		$s = $path;
	}
	else {
		my ($drive, $dir, $filename, $ext, $lastdir, $filebody) = Deps::SplitFilePath($path);
#print "[$drive] [$dir] [$filename]\n";
		if($drive) {
			$s = Deps::MakePath($drive, $dir);
		}
		elsif($dir) {
			$s = $dir;
		}
		else {
			$s = '';
		}
	}
	my $path2 = Deps::MakePath($s, $fname);
#print "s=$path2\n";
	return $path2;
}

#============================================================
#@pNXŒ`Ȃ֐
#============================================================

#============================================================
#@RXgN^AfXgN^
#============================================================
sub new
{
	my ($module) = @_;
	my $this = {};
	bless $this;
	return $this;
}

sub DESTROY { my $this = shift; }

#============================================================
#@t@Cǂݍ݊֐
#============================================================
sub ReadPPDataToHash
{
	my ($this, $path) = @_;

	open(IN, $path) or return undef;
	my @a = Utils::Split("\\s+", <IN>);
	close(IN);
	my %hash = (
		Z    => $a[0],
		nVEL => $a[1],
		);
	return \%hash;
}

sub MakeControlInp
{
	my ($this, $path, $Crystal) = @_;
	$path = 'control.inp' if(!defined $path);

	open(OUT, ">$path") or return undef;

	my ($ax,$ay,$az,$bx,$by,$bz,$cx,$cy,$cz) = $Crystal->LatticeVectorsByOutputMode(0);
	my $a0 = Sci::a0() * 1.0e10;
	printf OUT "origin  %8.5f %8.5f %8.5f\n", 0.0, 0.0, 0.0;
	printf OUT "vector1 %8.5f %8.5f %8.5f\n", $ax / $a0, $ay / $a0, $az / $a0;
	printf OUT "vector1 %8.5f %8.5f %8.5f\n", $bx / $a0, $by / $a0, $bz / $a0;
	printf OUT "vector1 %8.5f %8.5f %8.5f\n", $cx / $a0, $cy / $a0, $cz / $a0;

	close(OUT);
}

sub MakeKPointFile
{
	my ($this, $path, $Crystal) = @_;
	$path = 'kpoint.txt' if(!defined $path);

	open(OUT, ">$path") or return undef;
	print OUT<<EOT;
141 141
0 50 50 100 1
0 49 49 100 1
0 48 48 100 1
0 47 47 100 1
0 46 46 100 1
0 45 45 100 1
0 44 44 100 1
0 43 43 100 1
0 42 42 100 1
0 41 41 100 1
0 40 40 100 1
0 39 39 100 1
0 38 38 100 1
0 37 37 100 1
0 36 36 100 1
0 35 35 100 1
0 34 34 100 1
0 33 33 100 1
0 32 32 100 1
0 31 31 100 1
0 30 30 100 1
0 29 29 100 1
0 28 28 100 1
0 27 27 100 1
0 26 26 100 1
0 25 25 100 1
0 24 24 100 1
0 23 23 100 1
0 22 22 100 1
0 21 21 100 1
0 20 20 100 1
0 19 19 100 1
0 18 18 100 1
0 17 17 100 1
0 16 16 100 1
0 15 15 100 1
0 14 14 100 1
0 13 13 100 1
0 12 12 100 1
0 11 11 100 1
0 10 10 100 1
0 9 9 100 1
0 8 8 100 1
0 7 7 100 1
0 6 6 100 1
0 5 5 100 1
0 4 4 100 1
0 3 3 100 1
0 2 2 100 1
0 1 1 100 1
0 0 0 100 1
1 1 1 86 1
2 2 2 86 1
3 3 3 86 1
4 4 4 86 1
5 5 5 86 1
6 6 6 86 1
7 7 7 86 1
8 8 8 86 1
9 9 9 86 1
10 10 10 86 1
11 11 11 86 1
12 12 12 86 1
13 13 13 86 1
14 14 14 86 1
15 15 15 86 1
16 16 16 86 1
17 17 17 86 1
18 18 18 86 1
19 19 19 86 1
20 20 20 86 1
21 21 21 86 1
22 22 22 86 1
23 23 23 86 1
24 24 24 86 1
25 25 25 86 1
26 26 26 86 1
27 27 27 86 1
28 28 28 86 1
29 29 29 86 1
30 30 30 86 1
31 31 31 86 1
32 32 32 86 1
33 33 33 86 1
34 34 34 86 1
35 35 35 86 1
36 36 36 86 1
37 37 37 86 1
38 38 38 86 1
39 39 39 86 1
40 40 40 86 1
41 41 41 86 1
42 42 42 86 1
43 43 43 86 1
242 236 242 480 1
244 232 244 480 1
246 228 246 480 1
248 224 248 480 1
250 220 250 480 1
252 216 252 480 1
254 212 254 480 1
256 208 256 480 1
258 204 258 480 1
260 200 260 480 1
262 196 262 480 1
264 192 264 480 1
266 188 266 480 1
268 184 268 480 1
270 180 270 480 1
272 176 272 480 1
274 172 274 480 1
276 168 276 480 1
278 164 278 480 1
280 160 280 480 1
282 156 282 480 1
284 152 284 480 1
286 148 286 480 1
288 144 288 480 1
290 140 290 480 1
292 136 292 480 1
294 132 294 480 1
296 128 296 480 1
298 124 298 480 1
300 120 300 480 1
168 64 168 272 1
166 60 166 272 1
164 56 164 272 1
162 52 162 272 1
160 48 160 272 1
158 44 158 272 1
156 40 156 272 1
154 36 154 272 1
152 32 152 272 1
150 28 150 272 1
148 24 148 272 1
146 20 146 272 1
144 16 144 272 1
142 12 142 272 1
140 8 140 272 1
138 4 138 272 1
136 0 136 272 1
EOT
	close(OUT);
	return 1;
}

sub GetPPPath
{
	my ($this, $atomname, $PPType, $Functional) = @_;

	my $fmask;
	my @f;
	if($PPType eq 'auto') {
		$fmask = Deps::MakePath($PHASEPotDir, "${atomname}_${Functional}_us_*.pp", 0);
	}
	else {
		$fmask = Deps::MakePath($PHASEPotDir, "${atomname}_${Functional}_${PPType}_*.pp", 0);
	}
	@f = sort glob($fmask);
	if(@f == 0 and $PPType eq 'auto') {
		$fmask = Deps::MakePath($PHASEPotDir, "${atomname}_${Functional}_*.pp", 0);
#print "fmask2: $fmask\n";
		@f = sort glob($fmask);
	}
	if(!defined $f[0]) {
		print("  Error: Can not find potential file for [$atomname] in [$PHASEPotDir].\n");
		exit;
	}
#print "  Potential [$f[0]] is used for [$name]\n";
	$f[0] =~ s/\\/\//g;
	return $f[0];
}

sub GetPHASELatticeSystemName
{
	my ($this, $Crystal) = @_;

	my $SPG        = $Crystal->GetCSpaceGroup();
	my $SPGName    = $SPG->SPGName();
	my $LatticeSystem;
	if($SPGName =~ /^\s*F/) {
		$LatticeSystem = 'facecentered';
	}
	elsif($SPGName =~ /^\s*I/) {
		$LatticeSystem = 'bodycentered';
	}
	elsif($SPGName =~ /^\s*R/ or $SPGName =~ /^\s*P\s*3/) {
		$LatticeSystem = 'rhombohedral';
	}
	elsif($SPGName =~ /P\s*6/) {
		$LatticeSystem = 'hexagonal';
	}
	elsif($SPGName =~ /^\s*C/) {
		$LatticeSystem = 'basecentered';
	}
	elsif($SPGName =~ /^\s*P/) {
		$LatticeSystem = 'primitive';
	}
	else {
		$LatticeSystem = '';
	}
	return $LatticeSystem;
}

sub GetDefaultFileNames
{
	my ($this, $Function, $filebody) = @_;
	$Function = '' if(!defined $Function);
	$filebody = '' if(!defined $filebody);

	my %FileNameList = (
			F_INP      => "Input_${Function}_${filebody}.txt",
			F_KPOINT   => 'kpoint.txt',
			F_DYNM     => 'nfdynm.txt',
			F_CHGT     => 'nfchgt.data',
			F_CNST     => 'nfinp.cnst.txt',
			F_ENF      => 'nfefn.txt',
			F_ENERG    => 'nfenergy.txt',
			F_CNTN     => 'continue.txt',
			F_CNTN_BIN => 'continue_bin.data',
			F_ZAJ      => 'zaj.data',
			F_STOP     => 'nfstop.txt',
			F_CHR      => 'nfchr.cube',
			F_DOS      => 'dos.txt',
			F_MODE     => 'mode.data',
			F_EPSOUT   => 'eps.data',
			F_WANNIER  => 'nfwannier.cube',
		);
	return %FileNameList;
}

sub MakeFileNamesData
{
	my ($this, $WriteDir, $path, $pFileNameList, $Functional, $PPType, $Crystal, $CopyFile) = @_;
	$path = 'file_names.data' if(!defined $path);
	$path =~ s/\\/\//g;
	$path = Utils::MakePath($WriteDir, $path, '/', 0) if(defined $WriteDir);

print("\nCreate [$path]\n");

	my @AtomTypeList = $Crystal->GetCAtomTypeList();
	for(my $i = 1 ; $i <= @AtomTypeList ; $i++) {
		my $name  = $AtomTypeList[$i-1]->AtomNameOnly();
		my $PPPath = $this->GetPPPath($name, $PPType, $Functional);

		my ($drive, $dir, $filename, $ext, $lastdir, $filebody) = Deps::SplitFilePath($PPPath);
		if($CopyFile) {
			$pFileNameList->{"F_POT($i)"} = $filename;
			my $TargetPath = ($WriteDir ne '')? Utils::MakePath($WriteDir, $filename, '/', 0) : $filename;
			if(Utils::CopyFile($PPPath, $TargetPath)) {
				print("  Copy [$PPPath] to [$TargetPath]\n");
			}
			else {
				print("  Error in PHASE.pl: Can not copy [$PPPath] to [$TargetPath]\n");
				exit;
			}
		}
		else {
			$pFileNameList->{"F_POT($i)"} = $PPPath;
		}
	}

	open(OUT, ">$path") or return undef;

	print OUT<<EOT;
c ====<< & or & >>===
c & : VPP, VP 
c \$ : DEC, HP, SUN
 &fnames
 F_INP      = '$pFileNameList->{F_INP}'
EOT
	for(my $i = 1 ; $i <= @AtomTypeList ; $i++) {
		my $key = "F_POT($i)";
		printf OUT " %-10s = '%s'\n", $key, $pFileNameList->{$key};
	}
	foreach my $key qw(F_KPOINT F_DYNM F_CHGT F_CNST F_CNTN_BIN F_ENF F_ENERG F_CNTN F_ZAJ F_STOP
					   F_CHR F_DOS F_MODE F_EPSOUT F_WANNIER) {
		printf OUT " %-10s = '%s'\n", $key, $pFileNameList->{$key} if(defined $pFileNameList->{$key});
	}
	print OUT " &end\n";

	print OUT<<EOT;
 &f_ldos_names
 F_LDOS1  = 'nfldos_s1.txt'
 F_LDOS   = 'nfldos.txt'
 &end

 &f_param_names
 F_PARAM_MAIN = './parameters_decided.txt'
 F_PARAM_SUB  = './para_p.inc.txt'
 F_STDOUT     = './paramset.out.txt'
 &end
c                           @(#)file_names.data 8.1 97/04/10 14:51:25
EOT

	close(OUT);

print("\nCreate [$path]: finished\n");

	return 1;
}

1;