#!/usr/bin/perl

use lib 'c:/Programs/Perl/lib';
use lib 'c:/Programs/Perl/lib2.0';
use lib 'd:/Programs/Perl/lib';
use lib 'd:/Programs/Perl/lib2.0';
use lib '.';

use strict;

use MyApplication2;
use Device::Device;
use Device::Keithley236;
use Device::Keithley6517A;

$SIG{INT} = \&ctrl_c_handler;
BEGIN {
#	$| = 1;
	open (STDERR, ">&STDOUT");
}

#===============================================
# ֌Wϐ
#===============================================
#f[^t@C̖O
my $DataFileName = "test.csv";

# OWait
my $WaitBefore         = 1.0; # seconds
my $WaitForMeasurement = 0.0; # seconds

# d͈
my $VLeft  = -1.7;
my $VRight =  1.9;
my $VStep  =  0.050;
my $nCycle =  3;

# ς
my $nAverage = 5;

#d~b^[̐ݒ
my $VSourceLimit = 3.0;

# ZeroCheck
my $ZeroCheck = 'on';

my $Who = 'Koizumi';
my $Today = Utils::BuildDateString(time());

#===============================================
# ApplicationIuWFNg쐬
#===============================================
my $App = new MyApplication2;
$App->SetOutputMode("auto");
my $ProgramPath = $App->SpeculateProgramPath($0, "");
my $IniFile = $App->OpenIniFile($ProgramPath, 1);
$App->AddIniFileVariable("\\Preferences\\DeviceName", "DeviceName", "Keithley6517");
$App->AddIniFileVariable("\\Preferences\\Port",       "Port",       "GPIB27");
$App->ReadSetting();

#===============================================
# DeviceIuWFNg쐬
#===============================================
#my $K6517A = OpenDevice("Keithley236",  "GPIB16");
my $K6517A = OpenDevice("Keithley6517A",  "GPIB27");

#Keithley6517Ȁ
$K6517A->Initialize();
$K6517A->MeterConnect('on');
$K6517A->SetDCCurrentMode($ZeroCheck);
$K6517A->SetVSourceLimit($VSourceLimit);
$K6517A->SetAutoRangeForCurrent("on");
$K6517A->SetIMeasureLimit(0.0e-3);

#===============================================
# Jn
#===============================================

#t@C
my $out = new JFile;
if(!$out->Open($DataFileName, "w")) {
	print "Error: Can not write to [$DataFileName]\n";
	exit;
}

#ExcelpɃf[^o
$out->print("V,I,**********Measured by $Who, $Today,\n");
$out->Close();

$K6517A->SetSourceVoltage(0.0);
$K6517A->SetVSourceOutput("on");

Utils::sleep($WaitBefore);
print("Waiting $WaitBefore s before the measurement...\n");

my $V = 0.0;
$K6517A->SetSourceVoltage($V);
Utils::sleep($WaitForMeasurement);
print("Waiting $WaitForMeasurement s...\n");
my $I = $K6517A->MeasureAveraged($nAverage);
print("V=$V    I=$I\n");
$out->Open($DataFileName, "a");
$out->print("$V,$I\n");
$out->Close();
for(my $i = 0.0 ; $i < $nCycle ; $i++) {
	for($V = $VStep ; $V <= $VRight+1.0e-6 ; $V += $VStep) {
		$K6517A->SetSourceVoltage($V);
		Utils::sleep($WaitForMeasurement);
		print("Waiting $WaitForMeasurement s...\n");
		$I = $K6517A->MeasureAveraged($nAverage);
		print("V=$V    I=$I\n");
		$out->Open($DataFileName, "a");
		$out->print("$V,$I\n");
		$out->Close();
	}
	for($V = $VRight-$VStep ; $V >= $VLeft-1.0e-6 ; $V -= $VStep) {
		$K6517A->SetSourceVoltage($V);
		Utils::sleep($WaitForMeasurement);
		print("Waiting $WaitForMeasurement s...\n");
		$I = $K6517A->MeasureAveraged($nAverage);
		print("V=$V    I=$I\n");
		$out->Open($DataFileName, "a");
		$out->print("$V,$I\n");
		$out->Close();
	}
	for($V = $VLeft+$VStep ; $V <= 1.0e-6 ; $V += $VStep) {
		$K6517A->SetSourceVoltage($V);
		Utils::sleep($WaitForMeasurement);
		print("Waiting $WaitForMeasurement s...\n");
		$I = $K6517A->MeasureAveraged($nAverage);
		print("V=$V    I=$I\n");
		$out->Open($DataFileName, "a");
		$out->print("$V,$I\n");
		$out->Close();
	}
}

exit;



#============================================================
#@ʊ֐
#============================================================
sub ctrl_c_handler{
	$App->print("CTRL+C pressed\n");
	$App->print("Input 'yes' if terminate this program.\n>>");
	my $line = <>;
	if($line =~ /^\s*yes\s*$/i) {
	   exit;
	}
	return;
}

sub OpenDevice
{
	my ($DeviceName, $Port) = @_;
	Utils::DelSpace($DeviceName);
	Utils::DelSpace($Port);

#RS232C̐ݒ
my $ConfFile        = '';
my $COMPort         = 'COM1';
my $UseModule       = 0;
my $BaudRate        = 9600;
my $Parity          = 'none';
my $DataBits        = 8;
my $StopBits        = 1;
my $HandShake       = 'none';
my $WriteBufferSize = 1024 * 20;
my $ReadBufferSize  = 1024 * 4;
my $ReadInterval    = 800;
my $ReadCharTime    = 400;
my $ErrorMessage    = 1;
my $UserMessage     = 1;

#GPIB̐ݒ
my $GPIBInterface   = "ni";
my $GPIBTimeOut     = GPIB->T1s;
my $GPIBEOT         = 1;
my $GPIBEOS         = 0;

	my $dev = new Device(
			-Port               => $Port,
			-ModuleName         => $DeviceName,
			-DeviceName         => $DeviceName,
			-GPIBInterface      => $GPIBInterface,
			-GPIBTimeOut        => $GPIBTimeOut,
			-GPIBEOT            => $GPIBEOT,
			-GPIBEOS            => $GPIBEOS,
			-COMConfName        => $ConfFile,
			-COMBaudRate        => $BaudRate,
			-COMParity          => $Parity,
			-COMDataBits        => $DataBits,
			-COMStopBits        => $StopBits,
			-COMHandShake       => $HandShake,
			-COMWriteBufferSize => $WriteBufferSize,
			-COMReadBufferSize  => $ReadBufferSize,
			-COMReadInterval    => $ReadInterval,
			-COMReadCharTime    => $ReadCharTime,
			-COMErrorMessage    => $ErrorMessage,
			-COMUserMessage     => $UserMessage,
			-PrintError         => 1,
			);
	if(!defined $dev) {
		$App->print("Device can not be opened. [$DeviceName: $Port]\n");
		exit;
	}

	my $Id = $dev->GetId();
	$App->print("$DeviceName: [$dev->{ModuleName}:$dev->{Port}] (Object: $dev)\n");
	$App->print("Id: $Id\n");

	return $dev;
}
