#!/usr/bin/perl

use lib 'd:/Programs/Perl/lib';
use lib 'd:/Programs/Perl/lib2.0';
use lib '.';

use strict;

use MyApplication2;
use Device::Device;

$SIG{INT} = \&ctrl_c_handler;
BEGIN {
#	$| = 1;
	open (STDERR, ">&STDOUT");
}

#===============================================
# ֌Wϐ
#===============================================
#f[^t@C̖O
my $DataFileName = "Test1.csv";

# OWait
my $WaitBefore = 1.0;
my $WaitForMeasurement = 0.1;


# d͈
my $VStart = -3.0;
my $VEnd   =  3.0;
my $VStep  =  0.1;

#d~b^[̐ݒ
my $VSourceLimit = 3.0;

#莞
#my $IAperture = 0.1; # 166.67e-6 to 200e-3
# ς
my $nAverage = 10;

# ZeroCheck
my $ZeroCheck = 'on';

my $Who = 'Tsukamoto';
my $Today = Utils::BuildDateString(time());


#===============================================
# ApplicationIuWFNg쐬
#===============================================
my $App = new MyApplication2;
$App->SetOutputMode("auto");
my $ProgramPath = $App->SpeculateProgramPath($0, "");
my $IniFile = $App->OpenIniFile($ProgramPath, 1);
#$App->AddIniFileVariable("\\Preferences\\DeviceName", "DeviceName", "Keithley2000");
#$App->AddIniFileVariable("\\Preferences\\Port",       "Port",       "GPIB17");
$App->ReadSetting();


#===============================================
# DeviceIuWFNg쐬
#===============================================
#my $K6517A         = OpenDevice("General",        "GPIB27");
my $K6517A         = OpenDevice("Keithley6517A",  "GPIB27");
my $K2000          = OpenDevice("Keithley2000",   "GPIB17");
my $Cornerstone130 = OpenDevice("Cornerstone130", "COM1");
my $Laserstar3APLS = OpenDevice("Laserstar3APLS", "COM4");

#Cornerstone130̐ݒ
$Cornerstone130->GOWAVE(500);



#Laserstar 3AP-LSݒ
my $ret = $Laserstar3APLS->ShowInformations();
   $App->print($ret);
$Laserstar3APLS->SetRange("auto");
$Laserstar3APLS->SetPowerMode();
my $val = $Laserstar3APLS->Measure();
   $App->print("Power: $val\n");

#Keithley6517Ȁ
$K6517A->Initialize();
$K6517A->SetDCCurrentMode($ZeroCheck);
$K6517A->SetVSourceLimit($VSourceLimit);
$K6517A->SetAutoRangeForCurrent("on");






#===============================================
# Jn
#===============================================
my $nVStep = int( ($VEnd - $VStart) / $VStep + 1.0001 );

Utils::sleep($WaitBefore);
$K6517A->SetSourceVoltage($VStart);
$K6517A->SetVSourceOutput("on");

#t@C
if(-w $DataFileName) { print "Can write to [$DataFileName]\n"; }
my $out = new JFile;
if(!$out->Open($DataFileName, "w")) {
	print "Error: Can not write to [$DataFileName]\n";
	exit;
}

#ExcelpɃf[^o
$out->print("V,I,|I|,L,**********Measured by $Who, $Today,\n");
for(my $i = 0 ; $i < $nVStep ; $i++) {
	my $V = $VStart + $VStep * $i;

	$K6517A->SetSourceVoltage($V);
	Utils::sleep($WaitForMeasurement);

	my $I = $K6517A->MeasureAveraged($nAverage);
	my $L = $Laserstar3APLS->Measure;
	print("V=$V  I=$I  L=$L\n");
	my $absI = abs($I);
	$out->print("$V,$I,$absI,$L\n");
}

$out->Close();

exit;

#============================================================
#@ʊ֐
#============================================================
sub ctrl_c_handler{
	$App->print("CTRL+C pressed\n");
	$App->print("Input 'yes' if terminate this program.\n>>");
	my $line = <>;
	if($line =~ /^\s*yes\s*$/i) {
	   exit;
	}
	return;
}

sub OpenDevice
{
	my ($DeviceName, $Port) = @_;
	Utils::DelSpace($DeviceName);
	Utils::DelSpace($Port);

#RS232C̐ݒ
my $ConfFile        = '';
my $COMPort         = 'COM1';
my $UseModule       = 0;
my $BaudRate        = 9600;
my $Parity          = 'none';
my $DataBits        = 8;
my $StopBits        = 1;
my $HandShake       = 'none';
my $WriteBufferSize = 1024 * 20;
my $ReadBufferSize  = 1024 * 4;
my $ReadInterval    = 800;
my $ReadCharTime    = 400;
my $ErrorMessage    = 1;
my $UserMessage     = 1;

#GPIB̐ݒ
my $GPIBInterface   = "ni";
my $GPIBTimeOut     = GPIB->T1s;
my $GPIBEOT         = 1;
my $GPIBEOS         = 0;

	my $dev = new Device(
			-Port               => $Port,
			-ModuleName         => $DeviceName,
			-DeviceName         => $DeviceName,
			-GPIBInterface      => $GPIBInterface,
			-GPIBTimeOut        => $GPIBTimeOut,
			-GPIBEOT            => $GPIBEOT,
			-GPIBEOS            => $GPIBEOS,
			-COMConfName        => $ConfFile,
			-COMBaudRate        => $BaudRate,
			-COMParity          => $Parity,
			-COMDataBits        => $DataBits,
			-COMStopBits        => $StopBits,
			-COMHandShake       => $HandShake,
			-COMWriteBufferSize => $WriteBufferSize,
			-COMReadBufferSize  => $ReadBufferSize,
			-COMReadInterval    => $ReadInterval,
			-COMReadCharTime    => $ReadCharTime,
			-COMErrorMessage    => $ErrorMessage,
			-COMUserMessage     => $UserMessage,
			-PrintError         => 1,
			);
	if(!defined $dev) {
		$App->print("Device can not be opened. [$DeviceName: $Port]\n");
		exit;
	}

	my $Id = $dev->GetId();
	$App->print("$DeviceName: [$dev->{ModuleName}:$dev->{Port}] (Object: $dev)\n");
	$App->print("Id: $Id\n");

	return $dev;
}
