#============================================================
# JSParams
#============================================================
package JSParams;
use Common;
@ISA = qw(Common);

#֥롼
@EXPORT = qw(%MultiFunctionTableConfig $MultiFunctionTableJScript
	     %MultiFunctionTableConfigByClass $MultiFunctionTableJScriptByClass
	     %MultiFunctionTableMessage
	     );
#@EXPORT_OK = qw();

use strict;

#==========================================
# ѿ
#==========================================
our $ModuleName        = "JSParams";
our $ModuleExplanation = "JavaScript Parameters";

our %MultiFunctionTableConfig = (
	id => 'TestTable3', 
	class => 'tablesorter'
	);

our $MultiFunctionTableJScript = <<EOT;

<link rel="stylesheet" href="/jscripts/jquery-tablesorter/themes/blue/style.css" type="text/css">
<script type="text/javascript" src="/jscripts/jquery-tablesorter/jquery.tablesorter.js"></script> 
<script type="text/javascript" src="/jscripts/jquery-columnFilters/jquery.columnfilters.js"></script>

<script language="JavaScript"><!--

//tablesorterthemeȤflexigridheadertable
\$(function(){
	\$('#$MultiFunctionTableConfig{id}').tablesorter(
		{
//			sortList: [[0,0], [1,0]]
		} 
	);

	\$('#$MultiFunctionTableConfig{id}').columnFilters();
});

//--></script>

EOT
#<!--<link rel="stylesheet" href="/jscripts/jquery-tablesorter/themes/blue/style.css" type="text/css">-->


our %MultiFunctionTableConfigByClass = (
#	id    => 'TestTable3', 
	class => 'tablesorter'
	);

our $MultiFunctionTableJScriptByClass = <<EOT;

<!--<link rel="stylesheet" href="/jscripts/jquery-tablesorter/themes/blue/style.css" type="text/css">-->
<link rel="stylesheet" href="/jscripts/jquery-tablesorter/themes/blue/style.css" type="text/css">
<script type="text/javascript" src="/jscripts/jquery-tablesorter/jquery.tablesorter.js"></script> 
<script type="text/javascript" src="/jscripts/jquery-columnFilters/jquery.columnfilters.js"></script>

<script language="JavaScript"><!--

//tablesorterthemeȤflexigridheadertable
\$(function(){
	\$('.$MultiFunctionTableConfigByClass{class}').each(function(i, v) {
//		alert(v);
		\$(v).tablesorter(
		{
//			sortList: [[0,0], [1,0]]
		});
		\$(v).columnFilters();
	});
});

//--></script>

EOT

our %MultiFunctionTableMessage = (
	'en' => "<H6>Input a keyword in a textbox below for filtering ('*' is for a wild card).<br>"
		    ."Click a title label to sort.</H6>\n",
	'jp' => "<H6>Υƥȥܥå˥ɤϤФǤޤ ('*'Ǥʸ˥ޥåޤ)<br>"
		    ."ȥ٥򥯥åȥȤޤ</H6>\n",
	);

our %AcordionConfigByClass = (
#	id    => 'TestTable3', 
	class => 'accordion'
	);

our $AcordionJScriptByClass = <<EOT;

<script language="JavaScript"><!--
$(function() {
	$("#accordion").accordion({
//		event: "mouseover",
		header: "h3",
		active: 0,
		fillSpace: true,
//		animated: "bounceslide",
		autoHeight: false,
		clearStyle: true,
		collapsible: true,
		alwaysOpen: false
	});
}); 

//--></script>

EOT

#============================================================
#󥹥ȥ饯ǥȥ饯
#============================================================
sub new
{
	my ($module) = @_;
	my $this = {};
	bless $this;
#	$this->SUPER::new(@_);
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#============================================================
#Сؿ
#============================================================
sub GetJSResizableString() {
	my ($this, $tag) = @_;
	$tag = '#TextAreaText' if(!defined $tag);

	my $s = <<EOT;
<script language="JavaScript"><!--
\$(function(){
	\$('$tag').resizable({
		autoHide:true
	});
});
//--></script>
EOT
	return $s;
}

sub GetTinyMCEString() {
	my ($this, $tag, %args) = @_;
	$tag = '#TextAreaText' if(!defined $tag);

	$args{Language} = 'jp' if($args{Language} eq '');
	$args{Mode}     = 'exact' if($args{Mode} eq '');
	$args{Elements} = 'TextAreaText' if($args{Mode} eq '');
	
	my $option = '';
	$option .= "		language : \"$args{Language}\",";
	$option .= "		mode : \"$args{Mode}\",";
	$option .= "		elements : \"$args{Elements}\",";
	$option .= "		document_base_url : '$args{DocumentBaseURL}'," if($args{DocumentBaseURL});

	my $s = <<EOT;
<!-- TinyMCE -->
<script type="text/javascript" src="/jscripts/tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
\$(function(){
	tinyMCE.init({
// General options
		theme : "advanced",
		skin : "o2k7",
$option
//		width : '100%',
//		height : '400',
		relative_urls                    : false,
		remove_script_host               : false,
		convert_urls                     : true,
//		forced_root_block                : 'p',
//		force_p_newlines                 : true,
//		apply_source_formatting          : true,
		remove_linebreaks                : false,
//		convert_fonts_to_spans           : true,
//		valid_elements                   : mce_valid_elements,
//		extended_valid_elements          : mce_extended_valid_elements,
//		invalid_elements                 : mce_invalid_elements,
//		popup_css_add                    : '/jscripts/tiny_mce/style/popup_add.css',
//		theme_advanced_source_editor_height : 400,
//		accessibility_warnings : false,
// Theme options
//		plugins : "style,iespell,inlinepopups,preview,contextmenu,noneditable,visualchars,wordcount,advlist",
		plugins : "autolink,lists,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount,advlist,autosave",

		// Theme options
		theme_advanced_buttons1 : "charmap,sub,sup,bold,italic,underline,strikethrough,forecolor,backcolor,|,formatselect,fontsizeselect,|,bullist,numlist,|,outdent,indent", 
		theme_advanced_buttons2 : "table,visualaid,hr,insertdate,inserttime,|,removeformat,pastetext,pasteword,undo,redo,|,zoom,visualchars,code,preview", 
		theme_advanced_buttons3 : "",
//		theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
//		theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
//		theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
//		theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak,restoredraft",
//		theme_advanced_buttons1 : "charmap,sub,sup,bold,italic,underline,|,table,iespell,paste,visualchars,code,preview",
//		theme_advanced_buttons1 : "charmap,sub,sup,|,code,preview",
		theme_advanced_toolbar_location : "top",
		theme_advanced_toolbar_align : "left",
		theme_advanced_statusbar_location : "bottom",
		theme_advanced_resizing : true,
		theme_advanced_resize_horizontal :  true,
		theme_advanced_font_sizes        : '80%,90%,100%,120%,140%,160%,180%,220%,260%,320%,400%,500%,700%',
		theme_advanced_blockformats      : 'p,h1,h2,h3,h4,h5,h6,div,blockquote,code,pre',
		theme_advanced_styles            : 'align left=justifyleft;align right=justifyright',
//		theme_advanced_disable           : '',
		formats : {
			alignleft   : {selector : 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li,table,img', classes : 'justifyleft'},
			alignright  : {selector : 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li,table,img', classes : 'justifyright'},
			alignfull   : {selector : 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li,table,img', classes : 'justifyfull'}
		},
// Example content CSS (should be your site CSS)
//		content_css : "/css/NavigationBar.css",
		content_css : "css/word.css",
// Drop lists for link/image/media/template dialogs
		template_external_list_url : "lists/template_list.js",
		external_link_list_url : "lists/link_list.js",
		external_image_list_url : "lists/image_list.js",
		media_external_list_url : "lists/media_list.js",

		fullscreen_settings : {
			theme_advanced_buttons1_add_before : 'save'
		},
// Style formats
		style_formats : [
			{title : 'Bold text', inline : 'b'},
			{title : 'Red text', inline : 'span', styles : {color : '#ff0000'}},
			{title : 'Red header', block : 'h1', styles : {color : '#ff0000'}},
			{title : 'Example 1', inline : 'span', classes : 'example1'},
			{title : 'Example 2', inline : 'span', classes : 'example2'},
			{title : 'Table styles'},
			{title : 'Table row 1', selector : 'tr', classes : 'tablerow1'}
		],
// Replace values for the template plugin
		template_replace_values : {
			username : "Some User",
			staffid : "991234"
		},
		plugin_insertdate_dateFormat     : '%Y/%m/%d',
		plugin_insertdate_timeFormat     : '%H:%M:%S',
		entity_encoding                  : 'named',
		file_browser_callback            : 'modx_fb',
		onchange_callback                : false,
		valid_elements : "*[*]"
	});
});
</script>
<!-- /TinyMCE -->
EOT
	return $s;
}

sub GetMultiFunctionalTableString() {
	my ($this, $tag, %args) = @_;
	$tag = '#TestTable3' if(!defined $tag);

#	$args{SortList} = '[[0,0], [1,0]]';

	my $option1 = '';
	my @array = qw(sortList);
	foreach my $key (@array) {
		if(defined $args{$key}) {
			if($args{$key} =~ /^\[/ or $args{$key} =~ /^\d+$/) {
				$option1 .= "		$key: $args{$key},\n" 
			}
			else {
				$option1 .= "		$key: '$args{$key}',\n" 
			}
		}
	}
	my $option2 = '';
	my @array2 = qw(wildCard notCharacter caseSensitive minSearchCharacters excludeColumns alternateRowClassNames underline);
	foreach my $key (@array2) {
		if(defined $args{$key}) {
			if($args{$key} =~ /^\[/ or $args{$key} =~ /^\d+$/) {
				$option2 .= "		$key: $args{$key},\n" 
			}
			else {
				$option2 .= "		$key: '$args{$key}',\n" 
			}
		}
	}
	$option1 =~ s/,\n$//s;
	$option2 =~ s/,\n$//s;

	my $s = <<EOT;
<link rel="stylesheet" href="/jscripts/jquery-tablesorter/themes/blue/style.css" type="text/css">
<script type="text/javascript" src="/jscripts/jquery-tablesorter/jquery.tablesorter.js"></script> 
<script type="text/javascript" src="/jscripts/jquery-columnFilters/jquery.columnfilters.js"></script>

<script language="JavaScript"><!--
//tablesorterthemeȤflexigridheadertable
\$(function(){
EOT

	if($tag =~ /^\.(.*)$/) {
		my $class = $1;
		$s .= <<EOT;
	\$('.$MultiFunctionTableConfigByClass{class}').each(function(i, v) {
//		alert(v);
		\$(v).tablesorter(
		{
$option1
		});
		\$(v).columnFilters(
		{
$option2
		});
	});
EOT
	}
	else {
		$s .= <<EOT;
	\$('#$MultiFunctionTableConfig{id}').tablesorter(
		{
$option1
		} 
	);
	\$('#$MultiFunctionTableConfig{id}').columnFilters(
		{
$option2
		});
EOT
	}

		$s .= <<EOT;
});
//--></script>
EOT
	return $s;
}

sub GetFileListsForMultiFunctionalTable2() {
	my ($this) = @_;

	my $s = <<EOT;
<link rel="stylesheet" href="/jscripts/jquery-tablesorter/themes/blue/style.css" type="text/css">
<script type="text/javascript" src="/jscripts/jquery-tablesorter/jquery.tablesorter.js"></script> 
<script type="text/javascript" src="/jscripts/jquery-columnFilters/jquery.columnfilters.js"></script>
EOT
	return $s;
}

sub GetMultiFunctionalTableString2() {
	my ($this, $tag, %args) = @_;
	$tag = '#TestTable3' if(!defined $tag);

#	$args{SortList} = '[[0,0], [1,0]]';

	my $option1 = '';
	my @array = qw(sortList);
	foreach my $key (@array) {
		if(defined $args{$key}) {
			if($args{$key} =~ /^\[/ or $args{$key} =~ /^\d+$/) {
				$option1 .= "		$key: $args{$key},\n" 
			}
			else {
				$option1 .= "		$key: '$args{$key}',\n" 
			}
		}
	}
	my $option2 = '';
	my @array2 = qw(wildCard notCharacter caseSensitive minSearchCharacters excludeColumns alternateRowClassNames underline);
	foreach my $key (@array2) {
		if(defined $args{$key}) {
			if($args{$key} =~ /^\[/ or $args{$key} =~ /^\d+$/) {
				$option2 .= "		$key: $args{$key},\n" 
			}
			else {
				$option2 .= "		$key: '$args{$key}',\n" 
			}
		}
	}
	$option1 =~ s/,\n$//s;
	$option2 =~ s/,\n$//s;

	my $s = <<EOT;
<script language="JavaScript"><!--
//tablesorterthemeȤflexigridheadertable
\$(function(){
EOT

	if($tag =~ /^\.(.*)$/) {
		my $class = $1;
		$s .= <<EOT;
	\$('.$class').each(function(i, v) {
//		alert(v);
		\$(v).tablesorter(
		{
$option1
		});
		\$(v).columnFilters(
		{
$option2
		});
	});
EOT
	}
	elsif($tag =~ /^\#(.*)$/) {
		my $id = $1;
		$s .= <<EOT;
	\$('#$id').each(function(i, v) {
//		alert(v);
		\$(v).tablesorter(
		{
$option1
		});
		\$(v).columnFilters(
		{
$option2
		});
	});
EOT
	}
	else {
		$s .= <<EOT;
	\$('#$MultiFunctionTableConfig{id}').tablesorter(
		{
$option1
		} 
	);
	\$('#$MultiFunctionTableConfig{id}').columnFilters(
		{
$option2
		});
EOT
	}

		$s .= <<EOT;
});
//--></script>
EOT
	return $s;
}

sub GetPictureGalleryString
{
	my ($this, $Script, %args) = @_;

	my ($DivClass, $HrefClass, $HrefGroup, $ImgClass, $s);
	if($Script eq 'polaroid') {
		$DivClass = 'polaroid';
		$s = '<link rel="stylesheet" href="/jscripts/polaroid/css/style.css" type="text/css">' . "\n"
		    .'<script type="text/javascript" src="/jscripts/polaroid/js/script.js"></script>' . "\n";
	}
	elsif($Script eq 'thickbox') {
		$DivClass  = undef;
		$HrefClass = 'thickbox';
		$HrefGroup = 'group1';
		$ImgClass  = 'mini';
		$s = '<link rel="stylesheet" href="/jscripts/thickbox/thickbox.css" type="text/css">' . "\n"
		    .'<script type="text/javascript" src="/jscripts/thickbox/thickbox.js"></script>' . "\n";
	}
	return ($DivClass, $HrefClass, $HrefGroup, $ImgClass, $s);
}

sub GetDatePickerString
{
	my ($this, $keyYear, $keyMonth, $keyDay, $BaseURL) = @_;

	my $JumpString = ($BaseURL eq '')? '' : 
		"location.href = \"$BaseURL&Year=\" + sArray[0] + \"&Month=\" + sArray[1] + \"&Day=\" + sArray[2];";

	my $s = <<EOT;

<script language="JavaScript"><!--
\$(function() {
	var DefaultDate = new Date(\$("$keyYear").val(), \$("$keyMonth").val()-1, \$("$keyDay").val());
	\$("$keyYear,$keyMonth,$keyDay").datepicker({
		beforeShow: function() {
//			\$(this).defaultDate = '+' + CalDiffDay() + 'd';
			\$(this).defaultDate = DefaultDate;
//			y = \$("$keyYear").val();
//			m = \$("$keyMonth").val();
//			d = \$("$keyDay").val();
//			\$("$keyYear,$keyMonth,$keyDay").datepicker('setDate', new Date(\$($keyYear).val(), \$($keyMonth).val(), \$($keyDay).val()));
//			\$("$keyYear").val(y);
//			\$("$keyMonth").val(m);
//			\$("$keyDay").val(d);
//			alert(this.defaultDate);
		},
		dateFormat: "yy/mm/dd",
//		defaultDate: '+' + CalDiffDay() + 'd',
		defaultDate: DefaultDate,
		changeYear: true,
		changeMonth: true,
		dayNamesMin: ["", "", "", "", "", "", ""],
//		dayNamesShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
		dayNamesMin: ["", "", "", "", "", "", ""],
		monthNames: ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"],
//		monthNames: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
		monthNamesShort: ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"],
		onSelect: function(d) {
//			alert(d + " is selected");
			sArray = d.split("/");
			\$("$keyYear").val(sArray[0]);
			\$("$keyMonth").val(sArray[1]);
			\$("$keyDay").val(sArray[2]);

			$JumpString
		}
	});
});
//--></script>

EOT
	return $s;
}

sub GetJSChangePageString
{
	my ($this) = @_;

	my $s =<<EOT;

<script type="text/javascript">
// <!--
function ChangePage(obj, url, TargetFrame) {
	if (TargetFrame === undefined) {
		TargetFrame = window;
	}
	var index = obj.selectedIndex;
	if (index !== undefined) {
		TargetFrame.document.location.href = url + obj.options[index].value;
	}
}
// -->
</script>

EOT
	return $s;
}

sub GetJSChangeApparatusString
{
	my ($this, $url) = @_;

	my $s =<<EOT;

<script type="text/javascript">
// <!--
function ChangeApparatus(obj, TargetFrame) {
	if (TargetFrame === undefined) {
		TargetFrame = window;
	}
	var index = obj.selectedIndex;
	if (index !== undefined) {
		TargetFrame.document.location.href = "$url" + obj.options[index].value;
	}
}
// -->
</script>

EOT
	return $s;
}

sub GetJSChangeLanguageString
{
	my ($this, $url) = @_;

	my $s =<<EOT;

<script type="text/javascript">
// <!--
function ChangeAppLanguage(obj, TargetFrame) {
	if (TargetFrame === undefined) {
		TargetFrame = window;
	}
	var index = obj.selectedIndex;
	if (index !== undefined) {
		TargetFrame.document.location.href = "$url" + obj.options[index].value;
	}
}
// -->
</script>

EOT
	return $s;
}

sub RemoveTinyMCETags
{
	my ($this, $pHash, @keys) = @_;
	return if(!$pHash);

	foreach my $key (@keys) {
#print "$key: $pHash->{$key}<br>\n";
		$pHash->{$key} =~ s/\<\/?span[^\>]*\>//isg;
		$pHash->{$key} =~ s/\<\/?strong[^\>]*\>//isg;
		$pHash->{$key} =~ s/\<\/?p[^\>]*\>//isg;
		$pHash->{$key} =~ s/\<\/?b[^\>]*\>//isg;
		$pHash->{$key} =~ s/\<\/?u[^\>]*\>//isg;
#		$pHash->{$key} =~ s/^\<sub\>//isg;
#		$pHash->{$key} =~ s/\<\/sub\>$//isg;
		Utils::DelSpace($pHash->{$key});
#print "  => $pHash->{$key}<br>\n";
	}
}

1;
