#============================================================
# MyCharConvEUCJP
#============================================================
package MyCharConvEUCJP;
use MyCharConv;
@ISA = qw(MyCharConv);

use strict;
use Encode;

use Jcode;
#use Text::Kakasi;

#===============================================
# ץѿ
#===============================================
my $ScriptCodeCharCode = Jcode::getcode("пڶ");

my $UseKakasiModule = 0;
my $KakasiPath      = "/usr/local/bin/kakasi";
my $KakasiCharCode  = "euc";
if($^O =~ /^MSWin/) {
	$KakasiPath = "c:\\kakasi\\bin\\kakasi.exe";
	$KakasiCharCode  = "sjis";
}

my %ConvTbl = (
	'a'   => '',
	'i'   => '',
	'u'   => '',
	'e'   => '',
	'o'   => '',
	'ka'  => '',
	'ki'  => '',
	'ku'  => '',
	'ke'  => '',
	'ko'  => '',
	'sa'  => '',
	'shi' => '',
	'si'  => '',
	'su'  => '',
	'se'  => '',
	'so'  => '',
	'ta'  => '',
	'chi' => '',
	'ti'  => '',
	'tu'  => '',
	'te'  => '',
	'to'  => '',
	'na'  => '',
	'ni'  => '',
	'nu'  => '',
	'ne'  => '',
	'no'  => '',
	'ha'  => '',
	'hi'  => '',
	'hu'  => '',
	'he'  => '',
	'ho'  => '',
	'ma'  => '',
	'mi'  => '',
	'mu'  => '',
	'me'  => '',
	'mo'  => '',
	'ya'  => '',
	'yi'  => '',
	'yu'  => '',
	'ye'  => '',
	'yo'  => '',
	'ra'  => '',
	'ri'  => '',
	'ru'  => '',
	're'  => '',
	'ro'  => '',
	'wa'  => '',
	'wi'  => '',
	'wu'  => '',
	'we'  => '',
	'wo'  => '',
	'n'   => '',
	'm'   => '',

	'da'  => '',
	'di'  => '',
	'du'  => '',
	'de'  => '',
	'do'  => '',

	'ba'  => '',
	'bi'  => '',
	'bu'  => '',
	'be'  => '',
	'bo'  => '',

	'ca'  => '',
	'ci'  => '',
	'cu'  => '',
	'ce'  => '',
	'co'  => '',

	'fa'  => 'դ',
	'fi'  => 'դ',
	'fu'  => '',
	'fe'  => 'դ',
	'fo'  => 'դ',

	'ga'  => '',
	'gi'  => '',
	'gu'  => '',
	'ge'  => '',
	'go'  => '',

	'ja'  => '',
	'ji'  => '',
	'ju'  => '',
	'je'  => '',
	'jo'  => '',

	'la'  => '',
	'li'  => '',
	'lu'  => '',
	'le'  => '',
	'lo'  => '',

	'pa'  => '',
	'pi'  => '',
	'pu'  => '',
	'pe'  => '',
	'po'  => '',

	'qa'  => '',
	'qi'  => '',
	'qu'  => '',
	'qe'  => '',
	'qo'  => '',

	'va'  => '',
	'vi'  => '',
	'vu'  => '',
	've'  => '',
	'vo'  => '',

	'xa'  => '',
	'xi'  => '',
	'xu'  => '',
	'xe'  => '',
	'xo'  => '',

	'za'  => '',
	'zi'  => '',
	'zu'  => '',
	'ze'  => '',
	'zo'  => '',

	'cha' => '',
	'chi' => '',
	'chu' => '',
	'che' => '',
	'cho' => '',

	'tsa' => 'Ĥ',
	'tsi' => '',
	'tsu' => '',
	'tse' => 'Ĥ',
	'tso' => 'Ĥ',

	'tha' => '',
	'thi' => '',
	'thu' => '',
	'the' => '',
	'tho' => '',
	
	'kya' => '',
	'kyi' => '',
	'kyu' => '',
	'kye' => '',
	'kyo' => '',
	'sya' => '',
	'syi' => '',
	'syu' => '',
	'sye' => '',
	'syo' => '',
	'sha' => '',
	'shi' => '',
	'shu' => '',
	'she' => '',
	'sho' => '',
	'tya' => '',
	'tyi' => '',
	'tyu' => '',
	'tye' => '',
	'tyo' => '',
	'nya' => 'ˤ',
	'nyi' => 'ˤ',
	'nyu' => 'ˤ',
	'nye' => 'ˤ',
	'nyo' => 'ˤ',
	'hya' => 'Ҥ',
	'hyi' => 'Ҥ',
	'hyu' => 'Ҥ',
	'hye' => 'Ҥ',
	'hyo' => 'Ҥ',
	'mya' => 'ߤ',
	'myi' => 'ߤ',
	'myu' => 'ߤ',
	'mye' => 'ߤ',
	'myo' => 'ߤ',
	'rya' => '',
	'ryi' => 'ꤣ',
	'ryu' => '',
	'rye' => 'ꤧ',
	'ryo' => '',
	'wya' => '嵐',
	'wyi' => '藍',
	'wyu' => '拉',
	'wye' => '蠟',
	'wyo' => '朗',

	'nji' => '',
	'nta' => '',
	);
foreach my $key (keys %ConvTbl) {
	Jcode::convert(\$ConvTbl{$key}, "utf8", $ScriptCodeCharCode);
}
my $ltu = "";
Jcode::convert(\$ltu, "utf8", $ScriptCodeCharCode);
my $oh  = "";
Jcode::convert(\$oh,  "utf8", $ScriptCodeCharCode);
my $nn  = "";
Jcode::convert(\$nn,  "utf8", $ScriptCodeCharCode);

#===============================================
# 󥹥ȥ饯ǥȥ饯
#===============================================
sub new
{
	my ($module, $buff) = @_;
	my $this = {};
	bless $this;

	$this->{pJcode} = new Jcode;
	$this->{pUTF8}  = find_encoding('utf8');
	$this->{pEUCjp} = find_encoding('eucjp');
	$this->{pSJIS}  = find_encoding('sjis');

	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->Close();
}

sub Initialize
{
	my ($this) = @_;
}

#===============================================
# ѿؿ
#===============================================

#===============================================
# ̥дؿ
#===============================================
sub Hankaku2Zenkaku
{
	my ($this, $s, $sourcecharcode, $ConvertKana) = @_;
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);
	$ConvertKana = 1 if(!defined $ConvertKana);

#print("c[$ScriptCodeCharCode][$sourcecharcode]<br>\n");
$this->convert(\$s, $ScriptCodeCharCode, $sourcecharcode);
#	$s = Jcode->new($s)->tr('a-zA-Z0-9 @!\"#$%&\'()=-^\\|{}:;+*?_/<>', 
#				'--ڣ-!#$()=ݡáСѡ+?/')->h2z() . '';
	$s = Jcode->new($s)->tr('a-zA-Z0-9 ', '--ڣ-');
	$s = $s->tr('@!\"#$%&\'',             'ɡ');
	$s = $s->tr('()=-^\\|{}:;+*?_/<>',    '()=ݡáСѡ+');
	if($ConvertKana) {
		$s = $s->h2z() . '';
	}
	else {
		$s = $s . '';
	}
$this->convert(\$s, $sourcecharcode, $ScriptCodeCharCode);
	return $s;
#	return Jcode->new($s)->h2z();
}

sub Zenkaku2Hankaku
{
	my ($this, $s, $sourcecharcode, $ConvertKana) = @_;
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);
	$ConvertKana = 1 if(!defined $ConvertKana);

$this->convert(\$s, $ScriptCodeCharCode, $sourcecharcode);
#	$s = Jcode->new($s)->tr('--ڣ-ɡǡʡˡݡáСѡܡ', 
#				'a-zA-Z0-9 @!"#$%&\'()=-^\\|{}:;+*?_/<>')->z2h() . '';
	$s = Jcode->new($s)->tr('--ڣ-',    'a-zA-Z0-9 ');
	$s = $s->tr('ɡ',                 '@!\"#$%&\'');
	$s = $s->tr('()=ݡáСѡ+', '()=-^\\|{}:;+*?_/<>');
	if($ConvertKana) {
		$s = $s->z2h() . '';
	}
	else {
		$s = $s . '';
	}
	$this->convert(\$s, $sourcecharcode, $ScriptCodeCharCode);
	return $s;
#	return Jcode->new($s)->z2h();
}

sub Zenkaku2HankakuKana
{
	my ($this, $s, $sourcecharcode) = @_;
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);

	$s = Jcode->new($s)->z2h() . '';
	$this->convert(\$s, $sourcecharcode);
	return $s;
}

sub HankakuKana2Zenkaku
{
	my ($this, $s, $sourcecharcode) = @_;
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);

$this->convert(\$s, $ScriptCodeCharCode, $sourcecharcode);
	$s = Jcode->new($s)->h2z() . '';
	$this->convert(\$s, $sourcecharcode, $ScriptCodeCharCode);
	return $s;
}

sub Hiragana2Katakana
{
	my ($this, $s, $sourcecharcode) = @_;
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);

	$s = Jcode->new($s)->tr('-', '-') . '';
	$this->convert(\$s, $sourcecharcode, $ScriptCodeCharCode);
	return $s;
}

sub Katakana2Hiragana
{
	my ($this, $s, $sourcecharcode) = @_;
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);

$this->convert(\$s, $ScriptCodeCharCode, $sourcecharcode);
	$s = $this->HankakuKana2Zenkaku($s, $sourcecharcode);
	$s = Jcode->new($s)->tr('-', '-') . '';
	$this->convert(\$s, $sourcecharcode);
	return $s;
}

#my $ZenkakuKigou    = "[-]";
#my $ZenkakuSpace    = "([!-~])([!-~])";
#my $ZenkakuAlphabet = "[-ڣ--ݡ]";
#Jcode::convert(\$ZenkakuKigou,    'utf8', $ScriptCodeCharCode);
#Jcode::convert(\$ZenkakuSpace,    'utf8', $ScriptCodeCharCode);
#Jcode::convert(\$ZenkakuAlphabet, 'utf8', $ScriptCodeCharCode);
sub Zen2Han
{
	my ($this, $s, $sourcecharcode) = @_;
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);

	$s = $this->Zenkaku2Hankaku($s, $sourcecharcode) . '';
#	$this->convert(\$s, $sourcecharcode);
	return $s;
}

sub Roma2Kana {
	my ($this, $s, $charcode, $sourcecharcode) = @_;
	$charcode = 'sjis'                   if(!defined $charcode);
	$sourcecharcode = $this->getcode($s) if(!defined $sourcecharcode);

	$s = lc $this->Zenkaku2Hankaku($s, $sourcecharcode);

$this->convert(\$s, "utf8", $sourcecharcode);
	$s =~ s/([aiueo])h([bcdfghjklmnpqrstvwxyz])/$1$1$2/g;
	$s =~ s/[nm]([^aiueon])/$nn$1/g;
	$s =~ s/nn/$nn/g;
	$s =~ s/n-([aiueo])/$nn$1/g;

	my ($others, $hit, $rest);
	my $ret = '';
	while(1) {
#print "s=[$s]\n";
		my ($others, $hit, $rest) = ($s =~ /^(.*?)([bcdfghjklmnpqrstvwxyz]*[aiueon])(.*)$/sg);
		if(!defined $hit) {
$this->convert(\$s, $charcode, "utf8");
			$ret .= $s;
			return $ret;
		}

		my $pre = '';
		if($hit =~ /^([bcdfghjklmnpqrstvwxyz])([bcdfghjklmnpqrstvwxyz])(.*)$/) {
			if($1 eq $2) {
#				$pre = $ltu;
#				$hit = $2 . $3;
			}
		}
		if($hit =~ /^(oh)(.*)$/) {
#			$pre .= $oh;
#			$hit = $2;
		}
		$hit = $ConvTbl{$hit} if(defined $ConvTbl{$hit});
$this->convert(\$others, $charcode, "utf8");
$this->convert(\$hit,    $charcode, "utf8");
$this->convert(\$pre,    $charcode, "utf8");
		$ret .= $others . $pre .$hit;
		$s = $rest;
	}
}

sub Conv2Hiragana
{
	my ($this, $s, $sourcecharcode, $targetcharcode) = @_;
$sourcecharcode = Jcode::getcode($s);
$this->convert(\$s, $ScriptCodeCharCode, $sourcecharcode);
	if($this->match($s, "^[---]*\$")) {
$this->convert(\$s, $sourcecharcode, $ScriptCodeCharCode);
		return $this->Katakana2Hiragana($s, $sourcecharcode, $targetcharcode);
	}
$this->convert(\$s, $sourcecharcode, $ScriptCodeCharCode);
	return $this->Kakasi($s, $sourcecharcode, $targetcharcode, qw/-aH -jH -KH -JH -EH -kH/);
#	return $this->Kakasi($s, $sourcecharcode, $targetcharcode, qw/-ieuc -oeuc -aH -jH -KH -JH -EH -kH/);
}

sub Conv2Roma
{
	my ($this, $s, $sourcecharcode, $targetcharcode) = @_;
	return $this->Kakasi($s, $sourcecharcode, $targetcharcode, qw/-Ha -ja -Ka -Ja -Ea -ka/);
#	return $this->Kakasi($s, $sourcecharcode, $targetcharcode, qw/-ieuc -oeuc -Ha -ja -Ka -Ja -Ea -ka/);
}

sub Kakasi {
	my ($this, $s, $sourcecharcode, $targetcharcode, @options) = @_;
	$sourcecharcode = $this->getcode($sourcecharcode) if(!defined $sourcecharcode);
	$targetcharcode = $sourcecharcode if(!defined $targetcharcode);
	return $s if($s eq '');

#print "s1: [$s]<br>\n";
$s =~ s/([^\\])([\(\)\{\}\[\]\>\<\*\?\|\!\$\%\&\~\=\-\'\"\`\/\#])/$1\\$2/g;
$this->convert(\$s, $KakasiCharCode, $sourcecharcode);
#print "s2: [$s]<br>\n";
	if($UseKakasiModule) {
		my $kakasi = Text::Kakasi->new(@options);
		$s  = $kakasi->get($s);
	}
	else {
		my $cmd = "$KakasiPath " . join(' ', @options);
#print "cmd: [$cmd]\n";
#$s =~ s/\(/\\(/g;
#$s =~ s/\)/\\(/g;
#print "[$s]<br>\n";
		$s = `echo $s | $cmd`;
		$s =~ s/[\r\n]+$//s;
	}
$this->convert(\$s, $targetcharcode, $KakasiCharCode);

	return $s;
}

1;
