#
# util.pl
#

use Jcode;

#
# parseInput(encoding)
# <IN>  encoding: {R[h(jis|sjis|euc)
# <OUT> Name=>Val ̃nbViOuj
#
sub parseInput
{
	my($encoding) = @_;
	my($method) = $ENV{'REQUEST_METHOD'};
	local($query, @in, $key, $val);

	# {ꂪKvȏꍇ jcode.pl 荞
#	require 'jcode.pl' if $encoding;

	# GET\bhPOST\bh𔻕ʂ
	if ($method eq 'GET') {
		$query = $ENV{'QUERY_STRING'};
	}
#	elsif ($method eq 'POST') {
#		read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
#	}

	# ̓f[^𕪉
	local(@query) = split(/&/, $query);

	# Name=Val  $in{'Name'} = 'Val' ̃nbVɂB
	foreach (@query) {

		# + 󔒕ɕϊ
		tr/+/ /;

		# Name=Val 𕪂
		($key, $val) = split(/=/);

		# %HH`̕ɃfR[hB
		$key =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("c", hex($1))/ge;
		$val =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("c", hex($1))/ge;

		$val =~ s/\r\n/\n/g;

		# {R[hw肳Ăꍇ͕ϊB
#		jcode'convert(*key, $encoding) if ($encoding);
		Jcode::convert(\$key, $encoding) if ($encoding);
#		jcode'convert(*val, $encoding) if ($encoding);
		Jcode::convert(\$val, $encoding) if ($encoding);

		# AzzinbVjɃZbg
		$in{$key} = $val;
	}

	# Azz̃OuԂ
#print "Action: " . $in{'Action'} . "<br>\n";
	return %in;
}




# bN֘A̐ݒl
$RetryNum = 100;			# gC
$Interval = 0.1;		# gC̃C^[o
$EX_LOCK = 2;			# rbN
$UN_LOCK = 8;			# bN
$LOCKTYPE = $EX_LOCK;	# bN^Cv͔rbN
$useflock = 0;			# flock()gꍇ1ɂ
$LPrefix = 'L-';		# bNt@C̃vtBNX
#
# lock(lfh, lockfile)
# <IN>  lfh: bNt@C̃nhiopenLockŎw肳ꂽt@C
#       ɓB
#       lockfile: bNt@C
# <OUT> true:   false: s
#
sub lock($$)
{
	my($lfh, $lockfile) = @_;

	if ($useflock) {		# flock()g
		flock($lfh, $LOCKTYPE);
		return 1;
	}
	else {
		my($retry) = $RetryNum;
		while (-f $lockfile) {
			select(undef, undef, undef, $Interval);
			return undef if (--$retry <= 0);
		}
		return open($lfh, ">$lockfile");
	}
}


#
# unlock(lfh, lockfile)
# <IN>  lfh: bNt@C̃nhiopenLockŎw肳ꂽt@C
#       ɓB
#       lockfile: bNt@C
# <OUT> Ȃ
#
sub unlock ($$)
{
	my($lfh, $lockfile) = @_;

	if ($useflock) {		# flock()g
		flock($lfh, $UN_LOCK);
	}
	else {
		close($lfh);
		unlink($lockfile);
	}
}


#
# openLock(fh, modefile)
# <IN>  fh: nh
#       modefile: [h܂ރt@C
# <OUT> true or false
#
sub openLock(*$)
{
	my($fh, $modefile) = @_;
	my($lockf);

	($mode, $file) = ($modefile =~ /^(\+?(?:<|>>?)\s*?)(.+)$/);
	if ($file =~ /(\/|\\)/) {
		($path, $filename) = ($file =~ /^(.*[\/|\\])(.+)$/);
	}
	else {
		$path = '';
		$filename = $file;
	}

	return undef unless $filename;
	$lockf = $path.$LPrefix."$filename";	# bNt@C
	lock($filename, $lockf) or return undef;

	open($fh, $modefile)
		or unlock($filename, $lockf), return undef;

	return 1;
}

#
# closeUnlock
# <IN>  fh: nh
#       modefile: [h܂ރt@C
# <OUT> Ȃ
#
sub closeUnlock(*$)
{
	my($fh, $file) = @_;

	if ($file =~ /(\/|\\)/) {
		($path, $filename) = ($file =~ /^(.*[\/|\\])(.+)$/);
	}
	else {
		$path = '';
		$filename = $file;
	}
	my($lockfile) = $path.'L-'."$filename";	# bNt@C
	unlock($filename, $lockfile);

	close($fh);
}


#
# exitError()
# <IN>  G[bZ[W
# <OUT> Ȃ
#
sub exitError
{
	my($msg) = @_;

	$msg =~ s/\n/<BR>\n/g;
print <<END_OF_ERR_HTML;
Content-Type: text/html

<HTML>
<HEAD>
<TITLE>G[II</TITLE>
</HEAD>
<BODY>
<FONT color="#FF0000">$msg</FONT><BR>
<FONT color="#0000FF">$!</FONT>
</BODY>
</HTML>
END_OF_ERR_HTML

	exit(1);
}

#
# getCookie()
# <IN>  G[bZ[W
# <OUT> Ȃ
#
sub getCookie
{
	my($cookie) = $ENV{'HTTP_COOKIE'};
#	my(%cookies, @cookie);
	local(*cookies);
	my(@cookie);

	@cookie = split(/;\s*/, $cookie);

print "cookie = @cookie\n";
	foreach (@cookie) {
		local($name, $val) = split(/=/);
print "name=$name, val=$val\n";
		$cookies{$name} = $val;
	}

	return *cookies;
}

#
# setCookie()
# <IN>  G[bZ[W
# <OUT> Ȃ
#
sub setCookie
{
	local(*data) = @_;
	my($cookie);

	$cookie = qq(Set-Cookie: );
	foreach (keys %data) {
		$cookie = qq($cookie $_=$data{$_};);
	}

	return $cookie;
}


#
# cF[̌j߂
# OSEX(1582N1015()ߌȌ)ŗL
#
# <IN> NAA
# <OUT> j (0:j - 6:yj)
#
sub getDayOfWeek
{
	my($year, $month, $day) = @_;

	# 1܂2̏ꍇ͑ON1314Ƃ݂Ȃ
	if ($month <= 2) {
		--$year;
		$month += 12;
	}

	return (($year + int($year/4) - int($year/100) + int($year/400)
					+ int((13*$month + 8)/5) + $day) % 7);
}

#
# <IN>	N
# <OUT> 邤N: true  N: false
#
sub leap
{
	my($year) = @_;

	if ($year % 100) {		# N 100 Ŋ؂Ȃ
		if ($year % 4) {	# N 4 Ŋ؂Ȃ
			return 0;	# N
		}
		else {
			return 1;	# 邤N
		}
	}
	else {					# N 100 Ŋ؂
		if ($year % 400) {	# N 400 Ŋ؂Ȃ
			return 0;	# N
		}
		else {				# N 400 Ŋ؂
			if ($year % 4000) {	# N 4000 Ŋ؂Ȃ
				return 1;	# 邤N
			}
			else {			# N 4000 Ŋ؂
				return 0;	#N
			}
		}
	}
}

@LeapYear = (0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
@NormYear = (0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

#
# <IN>  NA
# <OUT> ̌̍v
#
sub getDaysOfMonth
{
	my($year, $month) = @_;

	return leap($year) ? $LeapYear[$month] : $NormYear[$month];
}

1;
