#===============================================
# TkOpticalSpectrumRT
#===============================================
package TkOpticalSpectrumRT;
use clib::TkEllipsometry;
@ISA = qw(TkEllipsometry);

#JTu[`
#@EXPORT = qw(DelSpace Reduce01 MakePath RegExpQuote);

use strict;

my $pi    = Sci::pi();
my $kB    = Sci::kB();
my $c     = Sci::c();
my $e     = Sci::e();
my $e0    = Sci::e0();
my $me    = Sci::me();
my $mp    = Sci::mp();
my $mn    = Sci::mn();
my $h     = Sci::h();
my $hbar  = Sci::hbar();
my $torad = Sci::torad();
my $todeg = Sci::todeg();

#============================================================
#@ϐ擾֐
#============================================================

#============================================================
#@RXgN^AfXgN^
#============================================================

#============================================================
#@pNXŒ`Ȃ֐
#============================================================

sub CreateWidgets
{
	my ($this) = @_;
	my $App    = $this->App();
	my $args   = $App->Args();
	my $mw     = $this->mw();

	$this->{ini}  = new IniFile(undef, 0, 0);
	$this->{dini} = new IniFile(undef, 0, 0);
	$this->{Ellipsometry} = new Ellipsometry;

	$this->{nLorentz} = 5 if(!defined $this->{nLorentz});
	$this->{nDrude}   = 1 if(!defined $this->{nDrude});
	$this->SUPER::CreateWidgets(1);

	$this->mw()->SetTitle("OpticalSpectrumFit2007 for RT / TkPlot");
	$this->App()->SetProgram("OpticalSpectrumFit2007 for RT / TkPlot");

#===================================================
# yC쐻
#===================================================
	my $EntryWidth =  12;

	my $Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	$this->MakeChooseFileEntry($Frame, 'Param', 'Param:', $this->{ini}->pVariable("ParameterFile", ""), 
				'&Choose', sub { $this->ChooseFile(@_); }, "ChooseParameterFile");
	$this->{SaveParamButton} = $Frame->MyButton(
			-text => '&Save',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'SaveParam'); },
		)->pack(-side => 'left');
	$this->{EditParamButton} = $Frame->MyButton(
			-text => 'ed',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'EditParam'); },
		)->pack(-side => 'left');

	$Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	$this->MakeChooseFileEntry($Frame, 'SampleCSV', 'Sample:', $this->{ini}->pVariable("SampleCSVFile", ""), 
				'&Choose', sub { $this->ChooseFile(@_); }, "ChooseSampleFile");
	$this->{EditDataButton} = $Frame->MyButton(
			-text => 'ed',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'EditSampleCSV'); },
		)->pack(-side => 'left');

	$Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	$this->MakeChooseFileEntry($Frame, 'SubstrateCSV', 'Substrate:', $this->{ini}->pVariable("SubstrateCSVFile", ""),
				'&Choose', sub { $this->ChooseFile(@_); }, "ChooseSubstrateFile");
	$this->{EditDataButton} = $Frame->MyButton(
			-text => 'ed',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'EditSubstrateCSV'); },
		)->pack(-side => 'left');

	$Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	my $lsb1 = $this->{ChooseXListBox} = $Frame->MyBrowseEntry(
			-label      => "X:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => [],
			-SelIndex   => 0,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb1->configure(-browsecmd  => [\&SelChangeListBox, $this, "X", $this->{ChooseXListBox}]);
	my $lsb2 = $this->{ChooseY1ListBox} = $Frame->MyBrowseEntry(
			-label      => "Y1:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => [],
			-SelIndex   => 1,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb2->configure(-browsecmd  => [\&SelChangeListBox, $this, "Y1", $this->{ChooseY1ListBox}]);
	my $lsb3 = $this->{ChooseY2ListBox} = $Frame->MyBrowseEntry(
			-label      => "Y2:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => [],
			-SelIndex   => 2,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb3->configure(-browsecmd  => [\&SelChangeListBox, $this, "Y2", $this->{ChooseY2ListBox}]);

	$Frame = $mw->MyLabFrame(
			-label     => 'Fitting1',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw', -fill => 'x');
	my $lsb4 = $this->{ChooseLSQMethodListBox} = $Frame->MyBrowseEntry(
			-label      => "LSQ Method:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => ['Amoeba::Simplex', 'PDL::Simplex', 'ModifiedNewton'],
			-SelIndex   => 0,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb4->configure(-browsecmd  => [\&SelChangeListBox, $this, "LSQMethod", $this->{ChooseLSQMethodListBox}]);
	my $lsb5 = $this->{ChooseFitToListBox} = $Frame->MyBrowseEntry(
			-label      => "Fit to:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => ['RT', 'R', 'T'],
			-SelIndex   => 0,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');

	$Frame = $mw->MyLabFrame(
			-label     => 'Fitting2',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeLabelEntry($Frame, "FitEmin", "Emin:", 
			$this->{ini}->pVariable('FitEmin', ''), "%s", $EntryWidth, "eV", 0, 0);
	$this->MakeLabelEntry($Frame, "FitEmax", "Emax:", 
			$this->{ini}->pVariable('FitEmax', ''), "%s", $EntryWidth, "eV", 0, 1);
	$this->MakeLabelEntry($Frame, "nSkipData", "nSkip:", 
			$this->{ini}->pVariable('nSkipData', 2), "%d", $EntryWidth, "", 0, 2);
	$this->MakeLabelEntry($Frame, "EPS", "EPS:", 
			$this->{ini}->pVariable('EPS', 1.0e-5), "%12.4g", $EntryWidth, "", 1, 0);
	$this->MakeLabelEntry($Frame, "nMaxIter", "MaxIter:", 
			$this->{ini}->pVariable('nMaxIter', 1000), "%d", $EntryWidth, "", 1, 1);
	$this->MakeLabelEntry($Frame, "nSaveSpectraInterval", "SaveIntvl:", 
			$this->{ini}->pVariable('nSaveSpectraInterval', 10), "%d", $EntryWidth, "", 1, 2);

	$Frame = $mw->MyLabFrame(
			-label     => 'Structure',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	my $Frame1 = $Frame->MyFrame()->pack(-anchor => 'nw');
	$this->MakeLabelEntry($Frame1, "Angle", "Angle:", 
			$this->{ini}->pVariable('Angle', 0.0), "%8.4f", $EntryWidth, "deg", 0, 0);
	my $lsb6 = $this->{ChooseLayerModelListBox} = $Frame1->MyBrowseEntry(
			-label      => "Layer Model:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 20,
			-Selections => ["Film/Substrate", "Surface(EMA)/Film/Substrate", "Film/Interface(EMA)/Substrate"],
			-SelIndex   => 0,
		)->grid(-row => 0, -column => 3, -columnspan => 1, -sticky => 'e' );
	$lsb6->configure(-browsecmd  => [\&SelChangeListBox, $this, "LayerModel", $this->{ChooseLayerModelListBox}]);
	$Frame1 = $Frame->MyFrame()->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame1, "SurfaceThickness", "Surface thickness:", $this->{dini}->pVariable('SurfaceThicknesscheck', 1),
			$this->{ini}->pVariable('SurfaceThickness', 0.0), "%12.6g", $EntryWidth, "nm", 0, 0);
	$this->MakeCheckEntry($Frame1, "SurfaceVf", "Vf:", $this->{dini}->pVariable('SurfaceVfcheck', 0),
			$this->{ini}->pVariable('SurfaceVf', 1.0), "%12.6g", $EntryWidth, "", 0, 1);
	$this->MakeCheckEntry($Frame1, "FilmThickness", "Film thickness:", $this->{dini}->pVariable('FilmThicknesscheck', 1),
			$this->{ini}->pVariable('FilmThickness', 100.0), "%12.6g", $EntryWidth, "nm", 1, 0);
	$Frame1 = $Frame->MyFrame()->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame1, "SubstrateThickness", "Substrate thickness:", $this->{dini}->pVariable('SubstrateThicknesscheck', 0),
			$this->{ini}->pVariable('SubstrateThickness', 0.5), "%12.6g", $EntryWidth, "mm", 0, 1);
	$Frame1 = $Frame->MyFrame()->pack(-anchor => 'nw');

	$Frame = $mw->MyLabFrame(
			-label     => 'Scattering',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame, "Scale", "scale:", $this->{dini}->pVariable('Scalecheck', 0) ,
			$this->{ini}->pVariable('Scale', 1.0), "%12.6g", $EntryWidth, "", 0, 0);
	$this->MakeCheckEntry($Frame, "Rayleighl0", "Rayleigh lamba0:", $this->{dini}->pVariable('Rayleighl0check', 0) ,
			$this->{ini}->pVariable('Rayleighl0', 0.0), "%12.6g", $EntryWidth, "", 0, 1);

	$Frame = $mw->MyLabFrame(
			-label     => 'Dielectric background',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame, "e1inf", "e1:", $this->{dini}->pVariable('e1infcheck', 1) ,
			$this->{ini}->pVariable('e1inf', 0.155), "%12.6g", $EntryWidth, "e0", 0, 0);
	$this->MakeCheckEntry($Frame, "e2inf", "e2:", $this->{dini}->pVariable('e2infcheck', 0) ,
			$this->{ini}->pVariable('e2inf', 0.0  ), "%12.6g", $EntryWidth, "e0", 0, 1);
	$this->MakeCheckEntry($Frame, "Caucy2", "Caucy2:", $this->{dini}->pVariable('Caucy2check', 0) ,
			$this->{ini}->pVariable('Caucy2', 0.0), "%12.6g", $EntryWidth, "", 1, 0);
	$this->MakeCheckEntry($Frame, "Caucy4", "Caucy4:", $this->{dini}->pVariable('Caucy4check', 0) ,
			$this->{ini}->pVariable('Caucy4', 0.0), "%12.6g", $EntryWidth, "", 1, 1);

	$Frame = $mw->MyLabFrame(
			-label     => 'Tauc-Lorentz',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame, "A", "A:", $this->{dini}->pVariable('Acheck', 1) ,
			$this->{ini}->pVariable('A', 122.8), "%12.6g", $EntryWidth, "", 0, 0);
	$this->MakeCheckEntry($Frame, "C", "C:", $this->{dini}->pVariable('Ccheck', 1) ,
			$this->{ini}->pVariable('C', 10.8), "%12.6g", $EntryWidth, "", 0, 1);
	$this->MakeCheckEntry($Frame, "Eg", "Eg:", $this->{dini}->pVariable('Egcheck', 1) ,
			$this->{ini}->pVariable('Eg', 4.4), "%12.6g", $EntryWidth, "eV", 1, 0);
	$this->MakeCheckEntry($Frame, "En0", "En0:", $this->{dini}->pVariable('En0check', 1) ,
			$this->{ini}->pVariable('En0', 155.9), "%12.6g", $EntryWidth, "eV", 1, 1);

	$Frame = $mw->MyLabFrame(
			-label     => "Lorentz",
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	for(my $i = 0 ; $i < $this->{nLorentz} ; $i++) {
		my $i1 = $i + 1;
		$this->MakeCheckEntry($Frame, "E0${i1}", "E0:", $this->{dini}->pVariable("E0${i1}check", 1) ,
				$this->{ini}->pVariable("E0${i1}", 2.64), "%12.6g", $EntryWidth, "eV", $i, 0);
		$this->MakeCheckEntry($Frame, "Ne${i1}", "Ne:", $this->{dini}->pVariable("Ne${i1}check", 1) ,
				$this->{ini}->pVariable("Ne${i1}", 2e26), "%12.6g", $EntryWidth, "m-3", $i, 1);
		$this->MakeCheckEntry($Frame, "G${i1}", "G:", $this->{dini}->pVariable("G${i1}check", 1) ,
				$this->{ini}->pVariable("G${i1}", 2.64),   "%12.6g", $EntryWidth, "eV", $i, 2);
	}

	$Frame = $mw->MyLabFrame(
			-label     => "Drude",
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	for(my $i = 0 ; $i < $this->{nDrude} ; $i++) {
		my $i1 = $i + 1;
		$this->MakeCheckEntry($Frame, "DrudeEp${i1}", "Ep:", $this->{dini}->pVariable("DrudeEp${i1}check", 1) ,
				$this->{ini}->pVariable("DrudeEp${i1}", 0.5),      "%12.6g", $EntryWidth, "eV", $i, 1);
		$this->MakeCheckEntry($Frame, "Drudetau${i1}", "tau:", $this->{dini}->pVariable("Drudetau${i1}check", 1) ,
				$this->{ini}->pVariable("Drudetau${i1}", 1.0e-14), "%12.6g", $EntryWidth, "s", $i, 2);
	}

	$Frame = $mw->MyLabFrame(
			-label     => "Point by Point",
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	my $button = $Frame->MyCheckbutton(
		-text     => "Allow Negative e2",
		-variable => $this->{ini}->pVariable("PbPAllowNegativeE2", 0),
		-onvalue  => 1,
		-offvalue => 0,
		-indicatoron => 'no',
		)->pack(-anchor => 'nw')+

	$this->UpdateParameters();

	$Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	$this->{RecalcButton} = $Frame->MyButton(
			-text => 'Re&calc',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'Recalc'); },
		)->pack(-side => 'left');
	$this->{FitButton} = $Frame->MyButton(
			-text => '&Fit',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'Fit'); },
		)->pack(-side => 'left');
	$this->{PointByPointButton} = $Frame->MyButton(
			-text => 'Point By Point',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'PointByPoint'); },
		)->pack(-side => 'left');
	$this->{SaveForSCOUTButton} = $Frame->MyButton(
			-text => 'Save for &SCOUT',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'SaveForSCOUT'); },
		)->pack(-side => 'left');
	$this->{SaveLayersButton} = $Frame->MyButton(
			-text => 'Save Layers',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'SaveLayers'); },
		)->pack(-side => 'left');

#c[o[Open{^t@Cǂݍ݂ɃoCh
	$mw->{OpenButton}->configure(
			-command  => sub { $this->ChooseFile('SampleCSVFile', $this->{SPEFileFileEntry}); },
		) if($mw->{OpenButton});
}

sub SelChangeListBox
{
	my ($this, $type, $lb) = @_;
#print "this:$this  lb=$lb\n";
	my $s = $lb->GetText();
	if($type eq 'LayerModel') {
		if($s eq "Surface(EMA)/Film/Substrate") {
			$this->{SurfaceThicknessButton}->SetText("Surface thickness:");
		}
		elsif($s eq "Film/Interface(EMA)/Substrate") {
			$this->{SurfaceThicknessButton}->SetText("Interface thickness:");
		}
		else {
		}
	}
#	$this->CreateGraphFrame();
	$this->AssignGraphData();
	$this->Draw();
}

#===================================================
# f[^
#===================================================
sub BuildLayerModel
{
	my ($this, $IsPrint, $BuildOptimize) = @_;
	$IsPrint = 1 if(!defined $IsPrint);
	$BuildOptimize = 1 if(!defined $BuildOptimize);

	my $ini    = $this->{ini};
	my $dini   = $this->{dini};
	my $el     = $this->{Ellipsometry};

	my $optics = new Optics;
	my $Layers = new MultiLayer;
	$Layers->SetIncidentAngle($ini->{Angle});

	my $pObsE     = $el->GetData('.*eV.*', '.*E.*');
	my $pObsPsi   = $el->GetData('Psi');
	my $pObsDelta = $el->GetData('Delta');
	my $pObsEps1  = $el->GetData('e1');
	my $pObsEps2  = $el->GetData('e2');
	my $pObsR     = $el->GetData('R');
	my $pObsT     = $el->GetData('T');
	my $nData     = @$pObsE;
	my $nE        = $nData;
	$ini->{FitEmin} = $pObsE->[0]        if($ini->{FitEmin} eq '');
	$ini->{FitEmax} = $pObsE->[$nData-1] if($ini->{FitEmax} eq '');
	my $Emin  = $ini->{FitEmin};
	my $Emax  = $ini->{FitEmax};
	my $Estep = $pObsE->[1] - $pObsE->[0];

$Estep = 0.05 if(!defined $Estep);
$nData = int( ($Emax - $Emin) / $Estep + 1.001);

	my $Air       = new OpticalMaterial("air");
	my $Surface   = new OpticalMaterial("Specify", "Surface");
	my $Film      = new OpticalMaterial("Specify", "Film");
	my $Substrate = new OpticalMaterial("Specify", "Substrate");

	$Surface->AddDielectricModel(
		"EMA1",
		"EMA",
		"Model", "Average",
		"pMaterials",       [$Film,             $Air],
		"pVolumeFractions", [$ini->{SurfaceVf}, 1.0 - $ini->{SurfaceVf}],
		);

	$Film->AddDielectricModel(
		"Constant1",
		"Constant",
		"e1inf", $ini->{e1inf},
		"e2inf", $ini->{e2inf},
		);
	$Film->AddDielectricModel(
		"TaucLorentz1",
		"TaucLorentz",
		"A",     $ini->{A},
		"Eg",    $ini->{Eg},
		"En0",   $ini->{En0},
		"C",     $ini->{C}
		);
	$Film->AddDielectricModel(
		"Caucy1",
		"Caucy",
		"pA",    [$ini->{Caucy2}, $ini->{Caucy4}],
		"pn",    [2,              4],
		);
	for(my $i = 0 ; $i < $this->{nLorentz} ; $i++) {
		my $i1 = $i + 1;
		$Film->AddDielectricModel(
			"Lorentz$i1",
			"Lorentz",
			"Ne", $ini->{"Ne$i1"},
			"E0", $ini->{"E0$i1"},
			"G",  $ini->{"G$i1"},
			);
	}
	for(my $i = 0 ; $i < $this->{nDrude} ; $i++) {
		my $i1 = $i + 1;
		$Film->AddDielectricModel(
			"Drude$i1",
			"Drude",
			"Ep",  $ini->{"DrudeEp$i1"},
			"tau", $ini->{"Drudetau$i1"},
			);
	}

	if($ini->{SubstrateCSVFile}) {
		my @ret = $Substrate->AddDielectricModel(
			"Substrate",
			"EFile",
			"Path", $ini->{SubstrateCSVFile},
			);
		if(@ret == 0) {
			print "Error: Can not read [$ini->{SubstrateCSVFile}].\n";
			return;
		}
	}

	$Layers->AddLayer($Air,       -1.0,                              0.0);
	if($this->{ChooseLayerModelListBox}->GetText() eq "Surface(EMA)/Film/Substrate") {
		$Layers->AddLayer($Surface,      $ini->{SurfaceThickness}*1.0e-9,      1.0);
	}
	$Layers->AddLayer($Film,      $ini->{FilmThickness}*1.0e-9,      1.0);
	if($this->{ChooseLayerModelListBox}->GetText() eq "Film/Interface(EMA)/Substrate") {
		$Layers->AddLayer($Surface,      $ini->{SurfaceThickness}*1.0e-9,      1.0);
	}
	$Layers->AddLayer($Substrate, $ini->{SubstrateThickness}*1.0e-3, 0.0);
	$Layers->AddLayer($Air,       -1.0,                              0.0);

	$this->{Layers} = $Layers;

	$Layers->PrintLayers() if($IsPrint);

#=========================================================
# tBbeBOݒ
#=========================================================
	return if(!$BuildOptimize);
	my $ppA = $Film->pVariable('Caucy1::pA');
	my $pA  = $$ppA;
	my $ppV = $Surface->pVariable('EMA1::pVolumeFractions');
	my $pV  = $$ppV;
	my $optimize = new Optimize();
	$optimize->AddParameters(
		"Scale",  \$ini->{Scale},
							$dini->{Scalecheck}, $dini->{Scalescale}, $dini->{Scalemin}, $dini->{Scalemax},
							sub {
								$ini->{Scale} = $_[0];
							},

		"Rayleighl0",  \$ini->{Rayleighl0},
							$dini->{Rayleighl0check}, $dini->{Rayleighl0scale}, $dini->{Rayleighl0min}, $dini->{Rayleighl0max},
							sub {
								$ini->{Rayleighl0} = $_[0];
							},
		);

	my $iFilm      = 1;
	my $iSubstrate = 2;
	if($this->{ChooseLayerModelListBox}->GetText() eq "Surface(EMA)/Film/Substrate") {
		$iFilm++;
		$iSubstrate++;
		$optimize->AddParameters(
			"SurfaceThickness",  $Layers->pLayerThickness(1),
							$dini->{SurfaceThicknesscheck}, $dini->{SurfaceThicknessscale}, $dini->{SurfaceThicknessmin}, $dini->{SurfaceThicknessmax},
							sub {
								$Layers->SetLayerThickness(1, $_[0]);
								$ini->{SurfaceThickness} = $_[0]*1.0e9;
							},
			"SurfaceVf",  \$ini->{SurfaceVf},
							$dini->{SurfaceVfcheck}, $dini->{SurfaceVfscale}, $dini->{SurfaceVfmin}, $dini->{SurfaceVfmax},
							sub {
								$pV->[0] = $_[0];
								$pV->[1] = 1.0 - $_[0];
								$ini->{SurfaceVf} = $_[0];
							},
			);
	};
	if($this->{ChooseLayerModelListBox}->GetText() eq "Film/Interface(EMA)/Substrate") {
		$iSubstrate++;
	}

	$optimize->AddParameters(
		"FilmThickness",  $Layers->pLayerThickness($iFilm),
							$dini->{FilmThicknesscheck}, $dini->{FilmThicknessscale}, $dini->{FilmThicknessmin}, $dini->{FilmThicknessmax},
							sub {
								$Layers->SetLayerThickness($iFilm, $_[0]);
								$ini->{FilmThickness} = $_[0]*1.0e9;
							},

		"SubstrateThickness",  $Layers->pLayerThickness($iSubstrate),
							$dini->{SubstrateThicknesscheck}, $dini->{SubstrateThicknessscale}, $dini->{SubstrateThicknessmin}, $dini->{SubstrateThicknessmax},
							sub {
								$Layers->SetLayerThickness($iSubstrate, $_[0]);
								$ini->{SubstrateThickness} = $_[0]*1.0e3;
							},

		"Film-e1",      $Layers->pVariable($iFilm, 'Constant1::e1inf'),
							$dini->{e1infcheck}, $dini->{e1infscale}, $dini->{e1infmin}, $dini->{e1infmax},
							sub {
								$Layers->SetVariable($iFilm, 'Constant1::e1inf', $_[0]); 
								$ini->{e1inf} = $_[0];
							},

		"Film-e2",      $Layers->pVariable($iFilm, 'Constant1::e2inf'),
							$dini->{e2infcheck}, $dini->{e2infscale}, $dini->{e2infmin}, $dini->{e2infmax},
							sub {
								$Layers->SetVariable($iFilm, 'Constant1::e2inf', $_[0]); 
								$ini->{e2inf} = $_[0];
							},

		"Film-Caucy2",  \$pA->[0],
							$dini->{Caucy2check}, $dini->{Caucy2scale}, $dini->{Caucy2min}, $dini->{Caucy2max},
							sub {
								$ini->{Caucy2} = $pA->[0] = $_[0];
							},

		"Film-Caucy4",  \$pA->[1],
							$dini->{Caucy4check}, $dini->{Caucy4scale}, $dini->{Caucy4min}, $dini->{Caucy4max},
							sub {
								$ini->{Caucy4} = $pA->[1] = $_[0];
							},

		"Film-TLA",     $Layers->pVariable($iFilm, 'TaucLorentz1::A'),
							$dini->{Acheck}, $dini->{Ascale}, $dini->{Amin}, $dini->{Amax},
							sub {
								$Layers->SetVariable($iFilm, 'TaucLorentz1::A', $_[0]); 
								$ini->{A} = $_[0];
							},

		"Film-TLC",     $Layers->pVariable($iFilm, 'TaucLorentz1::C'),
							$dini->{Ccheck}, $dini->{Cscale}, $dini->{Cmin}, $dini->{Cmax},
							sub {
								$Layers->SetVariable($iFilm, 'TaucLorentz1::C', $_[0]); 
								$ini->{C} = $_[0];
							},

		"Film-TLEg",    $Layers->pVariable($iFilm, 'TaucLorentz1::Eg'),
							$dini->{Egcheck}, $dini->{Egscale}, $dini->{Egmin}, $dini->{Egmax},
							sub {
								$Layers->SetVariable($iFilm, 'TaucLorentz1::Eg', $_[0]); 
								$ini->{Eg} = $_[0];
							},

		"Film-TLEn0",   $Layers->pVariable($iFilm, 'TaucLorentz1::En0'),
							$dini->{En0check}, $dini->{En0scale}, $dini->{En0min}, $dini->{En0max},
							sub {
								$Layers->SetVariable($iFilm, 'TaucLorentz1::En0', $_[0]); 
								$ini->{En0} = $_[0];
							},
		);
	for(my $i = 0 ; $i < $this->{nLorentz} ; $i++) {
		my $i1 = $i + 1;
		$optimize->AddParameters(
			"Film-L${i1}E0",    $Layers->pVariable($iFilm, "Lorentz${i1}::E0"),
							$dini->{"E0${i1}check"}, $dini->{"E0${i1}scale"}, $dini->{"E0${i1}min"}, $dini->{"E0${i1}max"},
							sub {
								$Layers->SetVariable($iFilm, "Lorentz${i1}::E0", $_[0]); 
								$ini->{"E0${i1}"} = $_[0];
							},

			"Film-L${i1}Ne",    $Layers->pVariable($iFilm, "Lorentz${i1}::Ne"),
							$dini->{"Ne${i1}check"}, $dini->{"Ne${i1}scale"}, $dini->{"Ne${i1}min"}, $dini->{"Ne${i1}max"},
							sub {
								$Layers->SetVariable($iFilm, "Lorentz${i1}::Ne", $_[0]); 
								$ini->{"Ne${i1}"} = $_[0]; 
								$ini->{"A${i1}"} = $optics->CalLorentzAfromNe($ini->{"Ne${i1}"}, 1.0);
							},

			"Film-L${i1}G",     $Layers->pVariable($iFilm, "Lorentz${i1}::G"),
							$dini->{"G${i1}check"}, $dini->{"G${i1}scale"}, $dini->{"G${i1}min"}, $dini->{"G${i1}max"},
							sub {
								$Layers->SetVariable($iFilm, "Lorentz${i1}::G", $_[0]); 
								$ini->{"G${i1}"} = $_[0];
							},

			);
	}
	for(my $i = 0 ; $i < $this->{nDrude} ; $i++) {
		my $i1 = $i + 1;
		$optimize->AddParameters(
			"Film-D${i1}Ep",    $Layers->pVariable($iFilm, "Drude${i1}::Ep"),
							$dini->{"DrudeEp${i1}check"}, $dini->{"DrudeEp${i1}scale"}, $dini->{"DrudeEp${i1}min"}, $dini->{"DrudeEp${i1}max"},
							sub {
								$Layers->SetVariable($iFilm, "Drude${i1}::Ep", $_[0]); 
								$ini->{"DrudeEp${i1}"} = $_[0];
							},

			"Film-D${i1}tau",    $Layers->pVariable($iFilm, "Drude${i1}::tau"),
							$dini->{"Drudetau${i1}check"}, $dini->{"Drudetau${i1}scale"}, $dini->{"Drudetau${i1}min"}, $dini->{"Drudetau${i1}max"},
							sub {
								$Layers->SetVariable($iFilm, "Drude${i1}::tau", $_[0]); 
								$ini->{"Drudetau${i1}"} = $_[0]; 
							},
			);
	}

	if($this->{ChooseLayerModelListBox}->GetText() eq "Film/Interface(EMA)/Substrate") {
		$optimize->AddParameters(
			"SurfaceThickness",  $Layers->pLayerThickness(2),
							$dini->{SurfaceThicknesscheck}, $dini->{SurfaceThicknessscale}, $dini->{SurfaceThicknessmin}, $dini->{SurfaceThicknessmax},
							sub {
								$Layers->SetLayerThickness(2, $_[0]);
								$ini->{SurfaceThickness} = $_[0]*1.0e9;
							},
			"SurfaceVf",  \$ini->{SurfaceVf},
							$dini->{SurfaceVfcheck}, $dini->{SurfaceVfscale}, $dini->{SurfaceVfmin}, $dini->{SurfaceVfmax},
							sub {
								$pV->[0] = $_[0];
								$pV->[1] = 1.0 - $_[0];
								$ini->{SurfaceVf} = $_[0];
							},
			);
	};

	$this->{Optimize} = $optimize;
}

sub Recalc
{
	my ($this) = @_;

	$this->UpdateParameters();
	$this->BuildLayerModel(1, 0);

	my $el     = $this->{Ellipsometry};
	my $Layers = $this->{Layers};

	my $pObsE = $el->GetData('.*eV.*', '.*E.*');
	my $pObsR = $el->GetData('R.*');
	my $pObsT = $el->GetData('T.*');
	my $FitTo     = $this->{ChooseFitToListBox}->GetText();

	my ($pE, $pR, $pT, $S2) = $this->CalRTArrays($Layers, $pObsE, $pObsR, $pObsT, $FitTo);
	$this->{pEArray}  = $pE;
	$this->{pRArray}  = $pR;
	$this->{pTArray}  = $pT;

	$this->App()->print("Recalc: S2=$S2\n");

	$this->SetS2($S2);

	return $S2;
}

sub PointByPoint
{
	my ($this) = @_;
	my $App        = $this->App();
	my $ini        = $this->{ini};
	my $el         = $this->{Ellipsometry};

	$this->UpdateParameters();
	$this->BuildLayerModel(0, 0);

	my $Layers = new MultiLayer;
	$Layers->SetIncidentAngle($ini->{Angle});
	my $Air       = new OpticalMaterial("air");
	my $Film      = new OpticalMaterial("Specify", "Film");
	my $Substrate = new OpticalMaterial("Specify", "Substrate");
	$Film->AddDielectricModel(
		"Constant1",
		"Constant",
		"e1inf", $ini->{e1inf},
		"e2inf", $ini->{e2inf},
		);
	if($ini->{SubstrateCSVFile}) {
		my @ret = $Substrate->AddDielectricModel(
			"Substrate",
			"EFile",
			"Path", $ini->{SubstrateCSVFile},
			);
		if(@ret == 0) {
			print "Error: Can not read [$ini->{SubstrateCSVFile}].\n";
			return;
		}
	}

	$Layers->AddLayer($Air,       -1.0,                              0.0);
	$Layers->AddLayer($Film,      $ini->{FilmThickness}*1.0e-9,      1.0);
	$Layers->AddLayer($Substrate, $ini->{SubstrateThickness}*1.0e-3, 0.0);
	$Layers->AddLayer($Air,       -1.0,                              0.0);

	my $pObsE        = $el->GetData('.*eV.*', '.*E.*');
	my $pObsR        = $el->GetData('R.*');
	my $pObsT        = $el->GetData('T.*');
	my $nData        = @$pObsE;
	my $IniSubstrate = $this->{Layers}->pLayer(1);
	my $Method       = $this->{ChooseLSQMethodListBox}->GetText();
	my $FitTo        = $this->{ChooseFitToListBox}->GetText();

	my (@PbPE, @PbPe1, @PbPe2, @PbPR, @PbPT, @PbPS2);
	my $c = 0;
	my ($e1ini, $e2ini);
	for(my $i = 0 ; $i < $nData ; $i++) {
		next if($ini->{nSkipData} > 0 and $i % $ini->{nSkipData} != 0);
		my $E  = $pObsE->[$i];
		next if($E < $ini->{FitEmin} or $ini->{FitEmax} < $E);

		my $lwl  = $ini->{Rayleighl0} / Optics::eVTonm($E);
		my $lwl2 = $lwl * $lwl;
		my $sf = $ini->{Scale} - $lwl2 * $lwl2;

		($e1ini, $e2ini) = $IniSubstrate->CalEps($E);

		my ($e1opt, $e2opt) = ($e1ini, $e2ini);
		my $optimize = new Optimize();
		$optimize->AddParameters(
				"e1",  \$e1opt, 1, 0.1, '', '', 
					sub { $Layers->SetVariable(1, 'Constant1::e1inf', $_[0]); $e1opt = $_[0]; },
				"e2",  \$e2opt, 1, 0.1, '', '', 
					sub { $Layers->SetVariable(1, 'Constant1::e2inf', $_[0]); $e2opt = $_[0]; },
				);
		my ($OptVars, $MinVal) = $optimize->Optimize(
				$Method, undef, undef, undef,
				$ini->{EPS}, $ini->{nMaxIter}, $ini->{iPrintLevel},
				sub { $this->CalS2ForPontByPonint($optimize, $FitTo, $Layers, $E, $pObsR->[$i] * $sf, $pObsT->[$i] * $sf, @_); },
				undef,
				sub { Optimize::BuildDifferentialMatrixes(@_); },
				);
		
		if($MinVal > 1.0e-15 and $c >= 1)  {
			$App->printf("%6.2f: (%10.4g,%10.4g) => (%10.4g,%10.4g) [%10.4g] XXX\n", 
						$E, $e1ini, $e2ini, $e1opt, $e2opt, $MinVal);
			($e1ini, $e2ini) = ($PbPe1[$c-1], $PbPe2[$c-1]);
#			$App->printf("%8s(%10.4g,%10.4g)\n", '   Try '$e1ini, $e2ini);

			my ($OptVars2, $MinVal2) = $optimize->Optimize(
					$Method, undef, undef, undef,
					$ini->{EPS}, $ini->{nMaxIter}, $ini->{iPrintLevel},
					sub { $this->CalS2ForPontByPonint($optimize, $FitTo, $Layers, $E, $pObsR->[$i] * $sf, $pObsT->[$i] * $sf, @_); },
					undef,
					sub { Optimize::BuildDifferentialMatrixes(@_); },
					);
			
			if($MinVal2 < $MinVal) {
				$MinVal = $MinVal2;
				for(my $i = 0 ; $i < @$OptVars ; $i++) {
					$OptVars->[$i] = $OptVars2->[$i];
				}
			}
		}

		$optimize->RecoverParameters($OptVars);
		$App->printf("%6.2f: (%10.4g,%10.4g) => (%10.4g,%10.4g) [%10.4g]\n", $E, $e1ini, $e2ini, $e1opt, $e2opt, $MinVal);

		my ($Rtots, $Rtotp, $Ttots, $Ttotp) = $this->CalRT($E, $Layers);
		my $Rcal = ($Rtots + $Rtotp) / 2.0;
		my $Tcal = ($Ttots + $Ttotp) / 2.0;
		$PbPE[$c]  = $E;
		$PbPe1[$c] = $e1opt;
		$PbPe2[$c] = $e2opt;
		$PbPR[$c]  = $Rcal;
		$PbPT[$c]  = $Tcal;
		$PbPS2[$c] = $MinVal;

		($e1ini, $e2ini) = ($e1opt, $e2opt);
		$c++;
	}
	$this->{PbPE}  = \@PbPE;
	$this->{PbPe1} = \@PbPe1;
	$this->{PbPe2} = \@PbPe2;
	$this->{PbPR}  = \@PbPR;
	$this->{PbPT}  = \@PbPT;
	$this->{PbPS2} = \@PbPS2;
}

sub CalS2ForPontByPonint
{
	my ($this, $optimize, $FitTo, $Layers, $E, $R, $T, $pVars, $iPrintLevel) = @_;
	my $ini = $this->{ini};

	$optimize->RecoverParameters($pVars);
	my ($e1, $e2) = $Layers->pLayer(1)->CalEps($E);
	return 1.0e10 if(!$ini->{PbPAllowNegativeE2} and $e2 < 0.0);

	my ($Rtots, $Rtotp, $Ttots, $Ttotp) = $this->CalRT($E, $Layers);
	my $Rcal = ($Rtots + $Rtotp) / 2.0;
	my $Tcal = ($Ttots + $Ttotp) / 2.0;
#print "E=$E: e=($e1,$e2) R=($R,$T) / ($Rcal,$Tcal)\n";
	my $dR = $R - $Rcal;
	my $dT = $T - $Tcal;
	my $S2 = $dR * $dR + $dT * $dT;
#print "E=$E: S2=$S2\n";
	return $S2;
}

sub Fit
{
	my ($this) = @_;
	my $ini      = $this->{ini};
	my $dini     = $this->{dini};
	$this->UpdateParameters();
	$this->BuildLayerModel(0, 1);

	my $optimize = $this->{Optimize};
	my $Method = $this->{ChooseLSQMethodListBox}->GetText();
	my $FitTo  = $this->{ChooseFitToListBox}->GetText();

print "Method: $Method\n";
print "Fit to: $FitTo\n";
print "nMaxIter: $ini->{nMaxIter}\n";

	my $el    = $this->{Ellipsometry};
	my $pObsE = $el->GetData('.*eV.*', '.*E.*');
	my $pObsR = $el->GetData('R.*');
	my $pObsT = $el->GetData('T.*');

#=========================================================
# œK̎s
#=========================================================
	$optimize->SetnS2Calculation(0);
#	$this->{nS2} = 0;
	my ($OptVars, $MinVal) = $optimize->Optimize(
				$Method, undef, undef, undef,
				$ini->{EPS}, $ini->{nMaxIter}, $ini->{iPrintLevel},
				sub { $this->CalS2($FitTo, $pObsE, $pObsR, $pObsT, @_); },
				undef,
				sub { Optimize::BuildDifferentialMatrixes(@_); },
				);
	print "\nOptimized at:\n";
	$optimize->PrintParameters(1);

	$optimize->RecoverParameters($OptVars);

	$this->SetS2($MinVal);

	$this->UpdateParameters();
}

sub CalS2
{
	my ($this, $FitTo, $pObsE, $pObsR, $pObsT, $pVars, $iPrintLevel) = @_;
#print "pVars=", join(',', @$pVars);

	my $optimize = $this->{Optimize};
	my $ini      = $this->{ini};

	$optimize->RecoverParameters($pVars);
#	$this->UpdateParameters();
	$this->BuildLayerModel(0, 0);
	my ($pE, $pR, $pT, $S2) = $this->CalRTArrays($this->{Layers}, $pObsE, $pObsR, $pObsT, $FitTo);

	$optimize->IncrementnS2();
	my $nS2         = $optimize->nS2Calculation();
	my $nS2Interval = $ini->{nSaveSpectraInterval};
	print "S2[$nS2] = $S2 / ";
	$S2 += $optimize->CalPenalty(1.0e10, $pVars, 1);
	print "$S2\n";
	$optimize->PrintParameters(1, $pVars, $S2, 0);

	if($nS2Interval > 0 and $nS2 % $nS2Interval == 0) {
		$this->Recalc();
#		$this->CreateGraphFrame();
		$this->AssignGraphData(0);
		$this->Draw();
	}
	$this->UpdateParameters();
	$this->mw()->update();

	return $S2;
}

sub CalRT
{
	my ($this, $E, $Layers) = @_;
#	my ($Rtots, $Rtotp, $Ttots, $Ttotp) = $Layers->CalEpsRTForSubstrate($E, $this->{ini}->{Angle});
	my ($rs123, $rp123, $ts123, $tp123, $Rtots, $Rtotp, $Ttots, $Ttotp)
					= $Layers->CalFresnelCoefficient($E);
	return ($Rtots, $Rtotp, $Ttots, $Ttotp);
}

sub CalRTArrays
{
	my ($this, $Layers, $pObsE, $pObsR, $pObsT, $FitTo) = @_;
	my $ini = $this->{ini};
	my $el  = $this->{Ellipsometry};

	my $Angle = $ini->{Angle};
	$el->SetIncidentAngle($Angle);

	my $nData = @$pObsE;
	my (@E, @R, @T);
	my $S2 = 0.0;
	my $c = 0;
	for(my $i = 0 ; $i < $nData ; $i++) {
		next if($ini->{nSkipData} > 0 and $i % $ini->{nSkipData} != 0);
		my $E  = $pObsE->[$i];
		next if($E < $ini->{FitEmin} or $ini->{FitEmax} < $E);

		my $lwl  = $ini->{Rayleighl0} / Optics::eVTonm($E);
		my $lwl2 = $lwl * $lwl;
		my $sf = $ini->{Scale} - $lwl2 * $lwl2;

#		my ($rs, $rp, $ts, $tp, $Rs, $Rp, $Ts, $Tp) = $Layers->CalFresnelCoefficient($E);
		my ($Rs, $Rp, $Ts, $Tp) = $this->CalRT($E, $this->{Layers});
#print "$E,[$i]: $rs, $rp\n";
		my $R = ($Rs + $Rp) / 2.0;
		my $T = ($Ts + $Tp) / 2.0;
		$E[$c] = $E;
		$R[$c] = $R;
		$T[$c] = $T;

		if($FitTo eq 'RT' and $pObsR  and $pObsT) {
			my $dT = ($pObsT->[$i] * $sf - $T);
			my $dR = ($pObsR->[$i] * $sf - $R);
			$S2 += $dT * $dT + $dR * $dR;
		}
		elsif($FitTo eq 'R' and $pObsR) {
			my $d = ($pObsR->[$i] * $sf - $R);
			$S2 += $d * $d;
		}
		elsif($FitTo eq 'T' and $pObsT) {
			my $d = ($pObsT->[$i] * $sf - $T);
			$S2 += $d * $d;
		}
		else {
			print "Error: Invalid Fitting Target [$FitTo].\n";
			return;
		}
		$c++;
	}
	$S2 = sqrt($S2 / $c);

	return (\@E, \@R, \@T, $S2);
}

sub ReadSampleDataFile
{
	my ($this, $filepath, $IsPrint) = @_;
	my $App = $this->App();
#print "type=$type\n";

	$this->Initialize(0, 1);

	$this->{Path} = $filepath;
	my ($nData, $pLabelArray, @pDataArray) = $this->{Ellipsometry}->Read($filepath);
	if(!defined $nData) {
		$App->print("Error: Can not read [$filepath].\n");
		return $this->{Path} = undef;
	}

	my $nDataArray = $this->{Ellipsometry}->nDataArray();
#print "nDataArray: $nDataArray\n";
	$this->{"ChooseXListBox"}->DeleteAllItem();
	$this->{"ChooseY1ListBox"}->DeleteAllItem();
	$this->{"ChooseY2ListBox"}->DeleteAllItem();
	for(my $i = 0 ; $i < $nDataArray ; $i++) {
#print "$i: $pLabelArray->[$i]\n";
		$this->{"ChooseXListBox"}->AddItem($pLabelArray->[$i]);
		$this->{"ChooseY1ListBox"}->AddItem($pLabelArray->[$i]);
		$this->{"ChooseY2ListBox"}->AddItem($pLabelArray->[$i]);
	}
	$this->{"ChooseXListBox"}->SetCurSel('.*E.*', '.*eV.*');
	$this->{"ChooseY1ListBox"}->SetCurSel('R', 'e1', 'n', 'Psi');
	$this->{"ChooseY2ListBox"}->SetCurSel('T', 'e2', 'k', 'Delta');

	$this->CreateGraphFrame();
	$this->AssignGraphData();
	return $filepath;
}

sub ReadSubstrateDataFile
{
	my ($this, $filepath, $IsPrint) = @_;
	my $App = $this->App();
#print "type=$type\n";

	$this->{Layers}    = undef;
	$this->{Optimize}  = undef;
	$this->{Substrate} = new Ellipsometry;

	$this->{SubstratePath} = $filepath;
	my ($nData, $pLabelArray, @pDataArray) = $this->{Substrate}->Read($filepath);
	if(!defined $nData) {
		$App->print("Error: Can not read [$filepath].\n");
		return $this->{SubstratePath} = undef;
	}

#	$this->CreateGraphFrame();
#	$this->AssignGraphData();
	return $filepath;
}

sub SaveForSCOUT
{
	my ($this) = @_;
	my $App    = $this->App();
	my $optics = new Optics;
	my $ini    = $this->{ini};

	my $pE     = $this->{Ellipsometry}->GetData('E.*', '.*eV.*');
	my $pR     = $this->{Ellipsometry}->GetData('R.*');
	my $pT     = $this->{Ellipsometry}->GetData('T.*');
	my $nData  = @$pE;

	my $path = $this->ChooseSaveFile();
	return if(!defined $path);

	my $out = new JFile;
	if(!$out->Open($path, "w")) {
		$App->print("Error: Can not write to [$path].\n");
		return undef;
	}
	$out->print("E(eV),wl(nm),R,T\n");
	for(my $i = 0 ; $i < $nData ; $i++) {
		my $E = $pE->[$i];
		my $wl = Optics::eVTonm($E);
		my $R = $pR->[$i];
		my $T = $pT->[$i];
		$out->print("$E,$wl,$R,$T\n");
	}
	$out->Close();
	
	$path = "$path.txt";
	$App->print("Parameters are stored in [$path].\n");
	$out = new JFile;
	if(!$out->Open($path, "w")) {
		$App->print("Error: Can not write to [$path].\n");
		return undef;
	}

	$out->print("[Background]\n");
	$out->print("e1 : $ini->{e1inf}\n");
	$out->print("e2 : $ini->{e2inf}\n");
	$out->print("\n");

	$out->print("[Tauc-Lorentz]\n");
	$out->print("A  : $ini->{A}\n");
	$out->print("C  : $ini->{C}\n");
	my $EgK = Optics::eVToKiser($ini->{Eg});
	$out->printf("Eg : %12.6g eV  %12.6g cm-1\n", $ini->{Eg}, $EgK);
	$EgK = Optics::eVToKiser($ini->{En0});
	$out->printf("En0: %12.6g eV %512.6g cm-1\n", $ini->{En0}, $EgK);
	$out->print("\n");

	for(my $i = 1 ; ; $i++) {
		last if(!defined $ini->{"Ne$i"});
		$out->print("[Lorentz$i]\n");

		$EgK = Optics::eVToKiser($ini->{"E0$i"});
		$out->printf("E0 : %12.6g       %12.6g cm-1\n", $ini->{"E0$i"}, $EgK);
		$EgK = Optics::eVToKiser($ini->{"G$i"});
		$out->printf("G  : %12.6g eV    %12.6g cm-1\n", $ini->{"G$i"}, $EgK);
		my $A = $optics->CalLorentzAfromNe($ini->{"Ne$i"}, 1.0);
		$out->printf("Ne : %12.6g cm-3  A=%12.6g\n", $ini->{"Ne$i"}, $A);
		$out->print("\n");
	}

	for(my $i = 1 ; ; $i++) {
		last if(!defined $ini->{"DrudeEp$i"});
		$out->print("[Drude$i]\n");
		$EgK = Optics::eVToKiser($ini->{"DrudeEp$i"});
		$out->printf("Ep : %12.6g    %12.6g cm-1\n", $ini->{"DrudeEp$i"}, $EgK);
		my $EgeV = Optics::HzToeV(1.0 / $ini->{"Drudetau$i"});
		$EgK = Optics::eVToKiser($EgeV);
		$out->printf("tau: %12.6g s  %12.6g cm-1  %12.6g eV\n", $ini->{"Drudetau$i"}, $EgK, $EgeV);
		$out->print("\n");
	}

	$out->Close();
}

sub CreateGraphFrame
{
	my ($this, $canvas, $TargetData) = @_;
	$canvas = $this->Canvas();
	my $App = $this->App();
	my $font = $App->{'GraphFrameFont'};
	my @font = split(/,/, $font) if($font);
	my $w = $canvas->width();
	my $h = $canvas->height();

#	my $FileType = $this->FileType();
#	return undef unless($FileType);
#	my $pDataArray = $this->DataArray();
#	return unless($pDataArray);

	my $GraphFrameArray = $this->{'GraphFrameArray'} = new GraphFrameArray($this->mw());

	$GraphFrameArray->SetCanvasSize($w, $h);

	$GraphFrameArray->AddGraphFrame();
	my $GraphFrame0  = $GraphFrameArray->GetGraphFrame(0);
	my $FramePosStr0 = $App->{"GraphFrame0Position"};
	$GraphFrame0->SetXCaption("");
	my $XScale0      = $GraphFrame0->GetXScale(0);
	my $YScale0      = $GraphFrame0->GetYScale(0);
	$GraphFrame0->SetPositionByStr($FramePosStr0);
	$XScale0->SetScaleStringVisible(0);
	$XScale0->SetCaptionVisible(1);

	$GraphFrameArray->AddGraphFrame();
	my $GraphFrame1  = $GraphFrameArray->GetGraphFrame(1);
	$GraphFrame1->SetYCaption("");
	my $FramePosStr1 = $App->{"GraphFrame1Position"};
	my $XScale1      = $GraphFrame1->GetXScale(0);
	my $YScale1      = $GraphFrame1->GetYScale(0);
	$GraphFrame1->SetPositionByStr($FramePosStr1);
	$XScale1->SetScaleStringVisible(1);
	$XScale1->SetCaptionVisible(1);

	$GraphFrame0->SetViewRange(0, 0, 1, 1);
	$GraphFrame1->SetViewRange(0, 0, 1, 1);

}

sub ShowScaleDialog
{
	my ($this, $GraphFrame, $command, $Title, @a) = @_;
#$command: "XScale" "YScale"
#ŏ̂SundefViewRangeɌݒlg
#̂QundefPlotTypeɌݒlgݒ
#̂Ƃ1,0́AX,YPlotType̓Ȃǂ
#Ō1́AScaleDialogOKꂽOt̍ĕ`s
#@@YViewRange͓邪APlotType͖̓
	return $GraphFrame->ShowScaleDialog($Title, undef, undef, undef, undef, 
			undef, undef, 1, 0, 1);
}

sub AdjustViewRange($$)
{
	my ($this) = @_;
	my $GraphFrameArray = $this->GetGraphFrameArray();
	my $GraphFrame0  = $GraphFrameArray->GetGraphFrame(0);
	$GraphFrame0->SetViewRange($GraphFrame0->GetViewRange(), 1) if($GraphFrame0);
}

sub AssignGraphData
{
	my ($this, $ResetViewRange) = @_;
	$ResetViewRange = 1 if(!defined $ResetViewRange);

	my $GraphFrameArray = $this->GetGraphFrameArray();
	my $GraphFrame0  = $GraphFrameArray->GetGraphFrame(0);
	my $GraphFrame1  = $GraphFrameArray->GetGraphFrame(1);
	$GraphFrame0->ClearAllData();
	$GraphFrame1->ClearAllData();

	my $XLabel  = $this->{"ChooseXListBox"}->GetText();
	$XLabel = 'X' if(!$XLabel);
	my $Y1Label = $this->{"ChooseY1ListBox"}->GetText();
	$Y1Label = 'Y1' if(!$Y1Label);
	my $Y2Label = $this->{"ChooseY2ListBox"}->GetText();
	$Y2Label = 'Y2' if(!$Y2Label);
	$GraphFrame0->SetXCaption($XLabel);

	my $pX    = $this->{Ellipsometry}->GetData($XLabel, '.*E.*', '.*eV.*');
	my $pY1   = $this->{Ellipsometry}->GetData($Y1Label);
	my $pY2   = $this->{Ellipsometry}->GetData($Y2Label);
	my $nData = $this->{Ellipsometry}->nData();
	my $YLabel = '';
	$YLabel .= $Y1Label if($pY1);
	$YLabel .= ",$Y2Label" if($pY2);
	$GraphFrame0->SetXCaption("");
	$GraphFrame0->SetYCaption("$Y1Label,$Y2Label");
	if($pX) {
		my $ini = $this->{ini};
		my (@y1, @y2);
		for(my $i = 0 ; $i < @$pX ; $i++) {
			my $E  = $pX->[$i];
			my $lwl  = $ini->{Rayleighl0} / Optics::eVTonm($E);
			my $lwl2 = $lwl * $lwl;
			my $sf = $ini->{Scale} - $lwl2 * $lwl2;

			if($pY1) {
				$y1[$i] = $pY1->[$i] * $sf;
			}
			if($pY2) {
				$y2[$i] = $pY2->[$i] * $sf;
			}
		}
		$GraphFrame0->AddGraphData($pX, \@y1,
				2, "black", "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y1Label}(obs)") if($pY1);
		$GraphFrame0->AddGraphData($pX, \@y2,
				2, "red",   "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y2Label}(obs)") if($pY2);
	}

	if($pX and $pY1 and $pY2) {
		my @alpha;
		my $d = $this->{ini}->{FilmThickness} * 1.0e-7; # cm
		for(my $i = 0 ; $i < @$pX ; $i++) {
			my $R = $pY1->[$i];
			my $T = $pY2->[$i];
			my $Tc = $T / (1.0 - $R);
			$Tc = 1.0 if($Tc <= 0.0);
			$alpha[$i] = -log($Tc) / $d;
		}
		$GraphFrame1->AddGraphData($pX, \@alpha,
				2, "black", "", 6, "red", 0, "red", "XAutoSkip", "Energy", "alpha(obs)");
	}

	my $pCalE = $this->{pEArray};
	my $pCalR = $this->{pRArray};
	my $pCalT = $this->{pTArray};
	if($pCalE) {
		$GraphFrame0->AddGraphData($pCalE, $pCalR,
				0, "black", "circle", 3, "", 1, "black", "XAutoSkip", "Energy", "${Y1Label}(cal)") if($pCalR and $pY1);
#				1, "black", "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y1Label}(cal)") if($pCalR and $pY1);
		$GraphFrame0->AddGraphData($pCalE, $pCalT,
				0, "red",   "circle", 3, "", 1, "red", "XAutoSkip", "Energy", "${Y2Label}(cal)") if($pCalT and $pY2);
#				1, "red",   "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y2Label}(cal)") if($pCalT and $pY2);

		my @alpha;
		my $d = $this->{ini}->{FilmThickness} * 1.0e-7; # cm
		for(my $i = 0 ; $i < @$pCalR ; $i++) {
			my $R = $pCalR->[$i];
			my $T = $pCalT->[$i];
			my $Tc = $T / (1.0 - $R);
			$Tc = 1.0 if($Tc <= 0.0);
#print "R=$R,$T,$Tc\n";
			$alpha[$i] = -log($Tc) / $d;
		}
		$GraphFrame1->AddGraphData($pCalE, \@alpha,
				0, "black", "circle", 3, "", 1, "black", "XAutoSkip", "Energy", "alpha(obs)");
	}

	if($this->{PbPE}) {
		$GraphFrame0->AddGraphData($this->{PbPE}, $this->{PbPR},
				0, "", "square", 3, "", 1, "black", "XAutoSkip", "Energy", "${Y1Label}(PbP)");
#				1, "black", "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y1Label}(PbP)");
		$GraphFrame0->AddGraphData($this->{PbPE}, $this->{PbPT},
				0, "",   "square", 3, "", 1, "red", "XAutoSkip", "Energy", "${Y2Label}(PbP)");
#				1, "red",   "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y2Label}(PbP)");

		my @alpha;
		my $d = $this->{ini}->{FilmThickness} * 1.0e-7; # cm
		for(my $i = 0 ; $i < @$pCalR ; $i++) {
			my $R = $this->{PbPR}->[$i];
			my $T = $this->{PbPR}->[$i];
			my $Tc = $T / (1.0 - $R);
			$Tc = 1.0 if($Tc <= 0.0);
#print "R=$R,$T,$Tc\n";
			$alpha[$i] = -log($Tc) / $d;
		}
		$GraphFrame1->AddGraphData($this->{PbPE}, \@alpha,
				0, "black", "square", 3, "", 1, "black", "XAutoSkip", "Energy", "alpha(PbP)");
	}

	$GraphFrame0->SetYScalePlotType('x');
	$GraphFrame1->SetYScalePlotType('x');

	$GraphFrame1->SetXCaption("Energy / eV");
	$GraphFrame1->SetYCaption("");

	if($GraphFrame1) {
		$GraphFrame0->AddSynchronousFrame('x', $GraphFrame1);
		$GraphFrame1->AddSynchronousFrame('x', $GraphFrame0);
	}

	if($ResetViewRange) {
		$GraphFrame0->CalMinMax();
		$GraphFrame1->CalMinMax();
		$GraphFrame0->AdjustViewRange(0.05, 0.05, 0.05, 0.05);
		$GraphFrame1->AdjustViewRange(0.05, 0.05, 0.05, 0.05);
		$GraphFrame0->SetViewRange($GraphFrame0->GetViewRange(), 1);
	}
}

1;
