#===============================================
# TkOpticalSpectrumSubstrateRT
#===============================================
package TkOpticalSpectrumSubstrateRT;
use clib::TkEllipsometry;
@ISA = qw(TkEllipsometry);

#JTu[`
#@EXPORT = qw(DelSpace Reduce01 MakePath RegExpQuote);

use strict;

my $pi    = Sci::pi();
my $kB    = Sci::kB();
my $c     = Sci::c();
my $e     = Sci::e();
my $e0    = Sci::e0();
my $me    = Sci::me();
my $mp    = Sci::mp();
my $mn    = Sci::mn();
my $h     = Sci::h();
my $hbar  = Sci::hbar();
my $torad = Sci::torad();
my $todeg = Sci::todeg();

#============================================================
#@ϐ擾֐
#============================================================

#============================================================
#@RXgN^AfXgN^
#============================================================

#============================================================
#@pNXŒ`Ȃ֐
#============================================================

sub CreateWidgets
{
	my ($this) = @_;
	my $App    = $this->App();
	my $args   = $App->Args();
	my $mw     = $this->mw();

	$this->{ini}  = new IniFile(undef, 0, 0);
	$this->{dini} = new IniFile(undef, 0, 0);
	$this->{Ellipsometry} = new Ellipsometry;

	$this->{nLorentz} = 5 if(!defined $this->{nLorentz});
	$this->{nDrude}   = 1 if(!defined $this->{nDrude});
	$this->SUPER::CreateWidgets(1);

	$this->mw()->SetTitle("OpticalSpectrumFit2007 for Substrate RT / TkPlot");
	$this->App()->SetProgram("OpticalSpectrumFit2007 for Substrate RT / TkPlot");

#===================================================
# yC쐻
#===================================================
	my $EntryWidth =  12;

	my $Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	$this->MakeChooseFileEntry($Frame, 'Param', 'Param:', $this->{ini}->pVariable("ParameterFile", ""), 
				'&Choose', sub { $this->ChooseFile(@_); }, "ChooseParameterFile");
	$this->{SaveParamButton} = $Frame->MyButton(
			-text => '&Save',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'SaveParam'); },
		)->pack(-side => 'left');
	$this->{EditParamButton} = $Frame->MyButton(
			-text => 'ed',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'EditParam'); },
		)->pack(-side => 'left');

	$Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	$this->MakeChooseFileEntry($Frame, 'SampleCSV', 'Sample:', $this->{ini}->pVariable("SampleCSVFile", ""), 
				'&Choose', sub { $this->ChooseFile(@_); }, "ChooseSampleFile");
	$this->{EditDataButton} = $Frame->MyButton(
			-text => 'ed',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'EditSampleCSV'); },
		)->pack(-side => 'left');

	$Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	my $lsb1 = $this->{ChooseXListBox} = $Frame->MyBrowseEntry(
			-label      => "X:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => [],
			-SelIndex   => 0,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb1->configure(-browsecmd  => [\&SelChangeListBox, $this, "X", $this->{ChooseXListBox}]);
	my $lsb2 = $this->{ChooseY1ListBox} = $Frame->MyBrowseEntry(
			-label      => "Y1:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => [],
			-SelIndex   => 1,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb2->configure(-browsecmd  => [\&SelChangeListBox, $this, "Y1", $this->{ChooseY1ListBox}]);
	my $lsb3 = $this->{ChooseY2ListBox} = $Frame->MyBrowseEntry(
			-label      => "Y2:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => [],
			-SelIndex   => 2,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb3->configure(-browsecmd  => [\&SelChangeListBox, $this, "Y2", $this->{ChooseY2ListBox}]);

	$Frame = $mw->MyLabFrame(
			-label     => 'Fitting1',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw', -fill => 'x');
	my $lsb4 = $this->{ChooseLSQMethodListBox} = $Frame->MyBrowseEntry(
			-label      => "LSQ Method:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => ['Amoeba::Simplex', 'PDL::Simplex', 'ModifiedNewton'],
			-SelIndex   => 0,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$lsb4->configure(-browsecmd  => [\&SelChangeListBox, $this, "LSQMethod", $this->{ChooseLSQMethodListBox}]);
	my $lsb5 = $this->{ChooseFitToListBox} = $Frame->MyBrowseEntry(
			-label      => "Fit to:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 5,
			-Selections => ['RT', 'R', 'T'],
			-SelIndex   => 0,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');

	$Frame = $mw->MyLabFrame(
			-label     => 'Fitting2',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeLabelEntry($Frame, "FitEmin", "Emin:", 
			$this->{ini}->pVariable('FitEmin', ''), "%s", $EntryWidth, "eV", 0, 0);
	$this->MakeLabelEntry($Frame, "FitEmax", "Emax:", 
			$this->{ini}->pVariable('FitEmax', ''), "%s", $EntryWidth, "eV", 0, 1);
	$this->MakeLabelEntry($Frame, "nSkipData", "nSkip:", 
			$this->{ini}->pVariable('nSkipData', 2), "%d", $EntryWidth, "", 0, 2);
	$this->MakeLabelEntry($Frame, "EPS", "EPS:", 
			$this->{ini}->pVariable('EPS', 1.0e-5), "%12.4g", $EntryWidth, "", 1, 0);
	$this->MakeLabelEntry($Frame, "nMaxIter", "MaxIter:", 
			$this->{ini}->pVariable('nMaxIter', 1000), "%d", $EntryWidth, "", 1, 1);
	$this->MakeLabelEntry($Frame, "nSaveSpectraInterval", "SaveIntvl:", 
			$this->{ini}->pVariable('nSaveSpectraInterval', 10), "%d", $EntryWidth, "", 1, 2);

	$Frame = $mw->MyLabFrame(
			-label     => 'Structure',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	my $Frame1 = $Frame->MyFrame()->pack(-anchor => 'nw');
	$this->MakeLabelEntry($Frame1, "Angle", "Angle:", 
			$this->{ini}->pVariable('Angle', 0.0), "%8.4f", $EntryWidth, "deg", 0, 0);
	my $lsb6 = $this->{ChooseLayerModelListBox} = $Frame1->MyBrowseEntry(
			-label      => "Layer Model:",
			-state      => "readonly",
			-takefocus  => 1,
			-width      => 10,
			-Selections => ["Film/Substrate"],
			-SelIndex   => 0,
		)->grid(-row => 0, -column => 3, -columnspan => 1, -sticky => 'e' );
	$lsb6->configure(-browsecmd  => [\&SelChangeListBox, $this, "LayerModel", $this->{ChooseLayerModelListBox}]);
	$Frame1 = $Frame->MyFrame()->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame1, "SubstrateThickness", "Substrate thickness:", $this->{dini}->pVariable('SubstrateThicknesscheck', 0),
			$this->{ini}->pVariable('SubstrateThickness', 0.5), "%12.6g", $EntryWidth, "mm", 0, 0);
	$Frame1 = $Frame->MyFrame()->pack(-anchor => 'nw');

	$Frame = $mw->MyLabFrame(
			-label     => 'Scattering',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame, "Scale", "scale:", $this->{dini}->pVariable('Scalecheck', 0) ,
			$this->{ini}->pVariable('Scale', 1.0), "%12.6g", $EntryWidth, "", 0, 0);
	$this->MakeCheckEntry($Frame, "Rayleighl0", "Rayleigh lamba0:", $this->{dini}->pVariable('Rayleighl0check', 0) ,
			$this->{ini}->pVariable('Rayleighl0', 0.0), "%12.6g", $EntryWidth, "", 0, 1);

	$Frame = $mw->MyLabFrame(
			-label     => 'Dielectric background',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame, "e1inf", "e1:", $this->{dini}->pVariable('e1infcheck', 1) ,
			$this->{ini}->pVariable('e1inf', 0.155), "%12.6g", $EntryWidth, "e0", 0, 0);
	$this->MakeCheckEntry($Frame, "e2inf", "e2:", $this->{dini}->pVariable('e2infcheck', 0) ,
			$this->{ini}->pVariable('e2inf', 0.0  ), "%12.6g", $EntryWidth, "e0", 0, 1);
	$this->MakeCheckEntry($Frame, "Caucy2", "Caucy2:", $this->{dini}->pVariable('Caucy2check', 0) ,
			$this->{ini}->pVariable('Caucy2', 0.0), "%12.6g", $EntryWidth, "", 1, 0);
	$this->MakeCheckEntry($Frame, "Caucy4", "Caucy4:", $this->{dini}->pVariable('Caucy4check', 0) ,
			$this->{ini}->pVariable('Caucy4', 0.0), "%12.6g", $EntryWidth, "", 1, 1);

	$Frame = $mw->MyLabFrame(
			-label     => 'Tauc-Lorentz',
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	$this->MakeCheckEntry($Frame, "A", "A:", $this->{dini}->pVariable('Acheck', 1) ,
			$this->{ini}->pVariable('A', 122.8), "%12.6g", $EntryWidth, "", 0, 0);
	$this->MakeCheckEntry($Frame, "C", "C:", $this->{dini}->pVariable('Ccheck', 1) ,
			$this->{ini}->pVariable('C', 10.8), "%12.6g", $EntryWidth, "", 0, 1);
	$this->MakeCheckEntry($Frame, "Eg", "Eg:", $this->{dini}->pVariable('Egcheck', 1) ,
			$this->{ini}->pVariable('Eg', 4.4), "%12.6g", $EntryWidth, "eV", 1, 0);
	$this->MakeCheckEntry($Frame, "En0", "En0:", $this->{dini}->pVariable('En0check', 1) ,
			$this->{ini}->pVariable('En0', 155.9), "%12.6g", $EntryWidth, "eV", 1, 1);

	$Frame = $mw->MyLabFrame(
			-label     => "Lorentz",
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	for(my $i = 0 ; $i < $this->{nLorentz} ; $i++) {
		my $i1 = $i + 1;
		$this->MakeCheckEntry($Frame, "E0${i1}", "E0:", $this->{dini}->pVariable("E0${i1}check", 1) ,
				$this->{ini}->pVariable("E0${i1}", 2.64), "%12.6g", $EntryWidth, "eV", $i, 0);
		$this->MakeCheckEntry($Frame, "Ne${i1}", "Ne:", $this->{dini}->pVariable("Ne${i1}check", 1) ,
				$this->{ini}->pVariable("Ne${i1}", 2e26), "%12.6g", $EntryWidth, "m-3", $i, 1);
		$this->MakeCheckEntry($Frame, "G${i1}", "G:", $this->{dini}->pVariable("G${i1}check", 1) ,
				$this->{ini}->pVariable("G${i1}", 2.64),   "%12.6g", $EntryWidth, "eV", $i, 2);
	}

	$Frame = $mw->MyLabFrame(
			-label     => "Drude",
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	for(my $i = 0 ; $i < $this->{nDrude} ; $i++) {
		my $i1 = $i + 1;
		$this->MakeCheckEntry($Frame, "DrudeEp${i1}", "Ep:", $this->{dini}->pVariable("DrudeEp${i1}check", 1) ,
				$this->{ini}->pVariable("DrudeEp${i1}", 0.5),      "%12.6g", $EntryWidth, "eV", $i, 1);
		$this->MakeCheckEntry($Frame, "Drudetau${i1}", "tau:", $this->{dini}->pVariable("Drudetau${i1}check", 1) ,
				$this->{ini}->pVariable("Drudetau${i1}", 1.0e-14), "%12.6g", $EntryWidth, "s", $i, 2);
	}

	$Frame = $mw->MyLabFrame(
			-label     => "Point by Point",
			-labelside => 'acrosstop',
			)->pack(-anchor => 'nw');
	my $button = $Frame->MyCheckbutton(
		-text     => "Allow Negative e2",
		-variable => $this->{ini}->pVariable("PbPAllowNegativeE2", 0),
		-onvalue  => 1,
		-offvalue => 0,
		-indicatoron => 'no',
		)->pack(-anchor => 'nw')+

	$this->UpdateParameters();

	$Frame = $mw->MyFrame()->pack(-anchor => 'nw', -fill => 'x');
	$this->{RecalcButton} = $Frame->MyButton(
			-text => 'Re&calc',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'Recalc'); },
		)->pack(-side => 'left');
	$this->{FitButton} = $Frame->MyButton(
			-text => '&Fit',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'Fit'); },
		)->pack(-side => 'left');
	$this->{PointByPointButton} = $Frame->MyButton(
			-text => 'Point By Point',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'PointByPoint'); },
		)->pack(-side => 'left');
	$this->{SaveForSCOUTButton} = $Frame->MyButton(
			-text => 'Save for &SCOUT',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'SaveForSCOUT'); },
		)->pack(-side => 'left');
	$this->{SaveLayersButton} = $Frame->MyButton(
			-text => 'Save Layers',
			-takefocus => 1,
			-command => sub { $this->ButtonPressed('RButtonDown', 'SaveLayers'); },
		)->pack(-side => 'left');

#c[o[Open{^t@Cǂݍ݂ɃoCh
	$mw->{OpenButton}->configure(
			-command  => sub { $this->ChooseFile('SampleCSVFile', $this->{SPEFileFileEntry}); },
		) if($mw->{OpenButton});
}

sub SelChangeListBox
{
	my ($this, $type, $lb) = @_;
#print "this:$this  lb=$lb\n";
	my $s = $lb->GetText();
	$this->AssignGraphData();
	$this->Draw();
}

sub ChooseFile
{
	my ($this, $type, $widget, $Option) = @_;
	my $App = $this->App();
	my $canvas = $this->Canvas();
	my $mw = $this->mw();

#print "Opt=$Option\n";
	my $mode = 'open';
	my $fmask = '*.csv;*.spe;*.jel;*.asp;*.smo;*isa;*.ref;*.pal;*.bef;*.aft;*.R';
	if($Option eq 'ChooseParameterFile') {
#		$mode = 'save';
		$fmask = '*.prm';
	}

	my $dir = '';
	unless($widget) {
		$dir = $this->App()->{WorkDir};
		chdir($dir);
	}
	my $defstr = '';
	my $message = 'Choose file';
	my $filepath = Dialog::OpenFileDialog($mw, 
				'open', $fmask, $defstr, $message, $dir);
	if($filepath) {
		my $DirPath = $this->SetWorkDir($filepath);
		if($widget) {
			$widget->SetText($filepath);
		}
	}
	else {
		return undef;
	}

	my $ret;
	if($Option eq 'ChooseParameterFile') {
		$ret = $this->ReadParameterFile($filepath);
		return undef unless($ret);
		$this->Draw();
	}
	elsif($Option eq 'ChooseSampleFile') {
		$ret = $this->ReadSampleDataFile($filepath);
		return undef unless($ret);
		$this->Draw();
	}

	return $ret;
}

#===================================================
# f[^
#===================================================
sub BuildLayerModel
{
	my ($this, $IsPrint, $BuildOptimize) = @_;
	$IsPrint = 1 if(!defined $IsPrint);
	$BuildOptimize = 1 if(!defined $BuildOptimize);

	my $ini    = $this->{ini};
	my $dini   = $this->{dini};
	my $el     = $this->{Ellipsometry};

	my $optics = new Optics;
	my $Layers = new MultiLayer;
	$Layers->SetIncidentAngle($ini->{Angle});

	my $pObsE     = $el->GetData('.*eV.*', '.*E.*');
	my $nData     = @$pObsE;
	$ini->{FitEmin} = $pObsE->[0]        if($ini->{FitEmin} eq '');
	$ini->{FitEmax} = $pObsE->[$nData-1] if($ini->{FitEmax} eq '');
	my $Emin  = $ini->{FitEmin};
	my $Emax  = $ini->{FitEmax};
	my $Estep = $pObsE->[1] - $pObsE->[0];

$Estep = 0.05 if(!defined $Estep);
$nData = int( ($Emax - $Emin) / $Estep + 1.001);

	my $Air       = new OpticalMaterial("air");
	my $Substrate = new OpticalMaterial("Specify", "Substrate");
	$Substrate->AddDielectricModel(
		"Constant1",
		"Constant",
		"e1inf", $ini->{e1inf},
		"e2inf", $ini->{e2inf},
		);
	$Substrate->AddDielectricModel(
		"TaucLorentz1",
		"TaucLorentz",
		"A",     $ini->{A},
		"Eg",    $ini->{Eg},
		"En0",   $ini->{En0},
		"C",     $ini->{C}
		);
	$Substrate->AddDielectricModel(
		"Caucy1",
		"Caucy",
		"pA",    [$ini->{Caucy2}, $ini->{Caucy4}],
		"pn",    [2,              4],
		);
	for(my $i = 0 ; $i < $this->{nLorentz} ; $i++) {
		my $i1 = $i + 1;
		$Substrate->AddDielectricModel(
			"Lorentz$i1",
			"Lorentz",
			"Ne", $ini->{"Ne$i1"},
			"E0", $ini->{"E0$i1"},
			"G",  $ini->{"G$i1"},
			);
	}
	for(my $i = 0 ; $i < $this->{nDrude} ; $i++) {
		my $i1 = $i + 1;
		$Substrate->AddDielectricModel(
			"Drude$i1",
			"Drude",
			"Ep",  $ini->{"DrudeEp$i1"},
			"tau", $ini->{"Drudetau$i1"},
			);
	}

	$Layers->AddLayer($Air,       -1.0,                              0.0);
	$Layers->AddLayer($Substrate, $ini->{SubstrateThickness}*1.0e-3, 0.0);
	$Layers->AddLayer($Air,       -1.0,                              0.0);

	$this->{Layers} = $Layers;

	$Layers->PrintLayers() if($IsPrint);

#=========================================================
# tBbeBOݒ
#=========================================================
	return if(!$BuildOptimize);
	my $ppA = $Substrate->pVariable('Caucy1::pA');
	my $pA  = $$ppA;
	my $optimize = new Optimize();
	$optimize->AddParameters(
		"Scale",  \$ini->{Scale},
							$dini->{Scalecheck}, $dini->{Scalescale}, $dini->{Scalemin}, $dini->{Scalemax},
							sub {
								$ini->{Scale} = $_[0];
							},

		"Rayleighl0",  \$ini->{Rayleighl0},
							$dini->{Rayleighl0check}, $dini->{Rayleighl0scale}, $dini->{Rayleighl0min}, $dini->{Rayleighl0max},
							sub {
								$ini->{Rayleighl0} = $_[0];
							},

		"Thickness",  $Layers->pLayerThickness(1),
							$dini->{SubstrateThicknesscheck}, $dini->{SubstrateThicknessscale}, 
							$dini->{SubstrateThicknessmin},   $dini->{SubstrateThicknessmax},
							sub {
								$Layers->SetLayerThickness(2, $_[0]);
								$ini->{SubstrateThickness} = $_[0]*1.0e3;
							},

		"e1",      $Layers->pVariable(1, 'Constant1::e1inf'),
							$dini->{e1infcheck}, $dini->{e1infscale}, $dini->{e1infmin}, $dini->{e1infmax},
							sub {
								$Layers->SetVariable(1, 'Constant1::e1inf', $_[0]); 
								$ini->{e1inf} = $_[0];
							},

		"e2",      $Layers->pVariable(1, 'Constant1::e2inf'),
							$dini->{e2infcheck}, $dini->{e2infscale}, $dini->{e2infmin}, $dini->{e2infmax},
							sub {
								$Layers->SetVariable(1, 'Constant1::e2inf', $_[0]); 
								$ini->{e2inf} = $_[0];
							},

		"Caucy2",  \$pA->[0],
							$dini->{Caucy2check}, $dini->{Caucy2scale}, $dini->{Caucy2min}, $dini->{Caucy2max},
							sub {
								$ini->{Caucy2} = $pA->[0] = $_[0];
							},

		"Caucy4",  \$pA->[1],
							$dini->{Caucy4check}, $dini->{Caucy4scale}, $dini->{Caucy4min}, $dini->{Caucy4max},
							sub {
								$ini->{Caucy4} = $pA->[1] = $_[0];
							},

		"TLA",     $Layers->pVariable(1, 'TaucLorentz1::A'),
							$dini->{Acheck}, $dini->{Ascale}, $dini->{Amin}, $dini->{Amax},
							sub {
								$Layers->SetVariable(1, 'TaucLorentz1::A', $_[0]); 
								$ini->{A} = $_[0];
							},

		"TLC",     $Layers->pVariable(1, 'TaucLorentz1::C'),
							$dini->{Ccheck}, $dini->{Cscale}, $dini->{Cmin}, $dini->{Cmax},
							sub {
								$Layers->SetVariable(1, 'TaucLorentz1::C', $_[0]); 
								$ini->{C} = $_[0];
							},

		"TLEg",    $Layers->pVariable(1, 'TaucLorentz1::Eg'),
							$dini->{Egcheck}, $dini->{Egscale}, $dini->{Egmin}, $dini->{Egmax},
							sub {
								$Layers->SetVariable(1, 'TaucLorentz1::Eg', $_[0]); 
								$ini->{Eg} = $_[0];
							},

		"TLEn0",   $Layers->pVariable(1, 'TaucLorentz1::En0'),
							$dini->{En0check}, $dini->{En0scale}, $dini->{En0min}, $dini->{En0max},
							sub {
								$Layers->SetVariable(1, 'TaucLorentz1::En0', $_[0]); 
								$ini->{En0} = $_[0];
							},
		);
	for(my $i = 0 ; $i < $this->{nLorentz} ; $i++) {
		my $i1 = $i + 1;
		$optimize->AddParameters(
			"L${i1}E0",    $Layers->pVariable(1, "Lorentz${i1}::E0"),
							$dini->{"E0${i1}check"}, $dini->{"E0${i1}scale"}, $dini->{"E0${i1}min"}, $dini->{"E0${i1}max"},
							sub {
								$Layers->SetVariable(1, "Lorentz${i1}::E0", $_[0]); 
								$ini->{"E0${i1}"} = $_[0];
							},

			"L${i1}Ne",    $Layers->pVariable(1, "Lorentz${i1}::Ne"),
							$dini->{"Ne${i1}check"}, $dini->{"Ne${i1}scale"}, $dini->{"Ne${i1}min"}, $dini->{"Ne${i1}max"},
							sub {
								$Layers->SetVariable(1, "Lorentz${i1}::Ne", $_[0]); 
								$ini->{"Ne${i1}"} = $_[0]; 
								$ini->{"A${i1}"} = $optics->CalLorentzAfromNe($ini->{"Ne${i1}"}, 1.0);
							},

			"L${i1}G",     $Layers->pVariable(1, "Lorentz${i1}::G"),
							$dini->{"G${i1}check"}, $dini->{"G${i1}scale"}, $dini->{"G${i1}min"}, $dini->{"G${i1}max"},
							sub {
								$Layers->SetVariable(1, "Lorentz${i1}::G", $_[0]); 
								$ini->{"G${i1}"} = $_[0];
							},
			);
	}
	for(my $i = 0 ; $i < $this->{nDrude} ; $i++) {
		my $i1 = $i + 1;
		$optimize->AddParameters(
			"D${i1}Ep",    $Layers->pVariable(1, "Drude${i1}::Ep"),
							$dini->{"DrudeEp${i1}check"}, $dini->{"DrudeEp${i1}scale"}, $dini->{"DrudeEp${i1}min"}, $dini->{"DrudeEp${i1}max"},
							sub {
								$Layers->SetVariable(1, "Drude${i1}::Ep", $_[0]); 
								$ini->{"DrudeEp${i1}"} = $_[0];
							},

			"D${i1}tau",    $Layers->pVariable(1, "Drude${i1}::tau"),
							$dini->{"Drudetau${i1}check"}, $dini->{"Drudetau${i1}scale"}, $dini->{"Drudetau${i1}min"}, $dini->{"Drudetau${i1}max"},
							sub {
								$Layers->SetVariable(1, "Drude${i1}::tau", $_[0]); 
								$ini->{"Drudetau${i1}"} = $_[0]; 
							},
			);
	}

	$this->{Optimize} = $optimize;
}

sub Recalc
{
	my ($this) = @_;

	$this->UpdateParameters();
	$this->BuildLayerModel(1, 0);

	my $el    = $this->{Ellipsometry};
	my $pObsE = $el->GetData('.*eV.*', '.*E.*');
	my $pObsR = $el->GetData('R.*');
	my $pObsT = $el->GetData('T.*');
	my $FitTo = $this->{ChooseFitToListBox}->GetText();

	my $S2;
	($this->{pEArray}, $this->{pRArray}, $this->{pTArray}, $S2)
				= $this->CalRTArrays($this->{Layers}, $pObsE, $pObsR, $pObsT, $FitTo);
	$this->App()->print("Recalc: S2=$S2\n");
	$this->SetS2($S2);
	return $S2;
}

sub PointByPoint
{
	my ($this) = @_;
	my $App        = $this->App();
	my $ini        = $this->{ini};
	my $el         = $this->{Ellipsometry};

	$this->UpdateParameters();
	$this->BuildLayerModel(0, 0);

	my $Layers = new MultiLayer;
	$Layers->SetIncidentAngle($ini->{Angle});
	my $Air       = new OpticalMaterial("air");
	my $Substrate = new OpticalMaterial("Specify", "Substrate");
	$Substrate->AddDielectricModel(
		"Constant1",
		"Constant",
		"e1inf", $ini->{e1inf},
		"e2inf", $ini->{e2inf},
		);
	$Layers->AddLayer($Air,       -1.0,                              0.0);
	$Layers->AddLayer($Substrate, $ini->{SubstrateThickness}*1.0e-3, 0.0);
	$Layers->AddLayer($Air,       -1.0,                              0.0);

	my $pObsE        = $el->GetData('.*eV.*', '.*E.*');
	my $pObsR        = $el->GetData('R.*');
	my $pObsT        = $el->GetData('T.*');
	my $nData        = @$pObsE;
	my $IniSubstrate = $this->{Layers}->pLayer(1);
	my $Method       = $this->{ChooseLSQMethodListBox}->GetText();
	my $FitTo        = $this->{ChooseFitToListBox}->GetText();

	my (@PbPE, @PbPe1, @PbPe2, @PbPR, @PbPT, @PbPS2);
	my $c = 0;
	for(my $i = 0 ; $i < $nData ; $i++) {
		next if($ini->{nSkipData} > 0 and $i % $ini->{nSkipData} != 0);
		my $E  = $pObsE->[$i];
		next if($E < $ini->{FitEmin} or $ini->{FitEmax} < $E);

		my $lwl  = $ini->{Rayleighl0} / Optics::eVTonm($E);
		my $lwl2 = $lwl * $lwl;
		my $sf = $ini->{Scale} - $lwl2 * $lwl2;

		my ($e1ini, $e2ini) = $IniSubstrate->CalEps($E);
#print "E=$E: eini=($e1ini,$e2ini)\n";
		my ($e1opt, $e2opt) = ($e1ini, $e2ini);
		my $optimize = new Optimize();
		$optimize->AddParameters(
				"e1",  \$e1opt, 1, 0.1, '', '', sub { $Layers->SetVariable(1, 'Constant1::e1inf', $_[0]); $e1opt = $_[0]; },
				"e2",  \$e2opt, 1, 0.1, '', '', sub { $Layers->SetVariable(1, 'Constant1::e2inf', $_[0]); $e2opt = $_[0]; },
				);
		my $ObsT;
		my $ObsR;
		$ObsT = $pObsT->[$i] * $sf if($pObsT);
		$ObsR = $pObsR->[$i] * $sf if($pObsR);
		my ($OptVars, $MinVal) = $optimize->Optimize(
				$Method, undef, undef, undef,
				$ini->{EPS}, $ini->{nMaxIter}, $ini->{iPrintLevel},
				sub { $this->CalS2ForPontByPonint($optimize, $FitTo, $Layers, $E, $ObsR, $ObsT, @_); },
				undef,
				sub { Optimize::BuildDifferentialMatrixes(@_); },
				);

		if($MinVal > 1.0e-15 and $c >= 1)  {
			$App->printf("%6.2f: (%10.4g,%10.4g) => (%10.4g,%10.4g) [%10.4g] XXX\n", 
						$E, $e1ini, $e2ini, $e1opt, $e2opt, $MinVal);
			($e1ini, $e2ini) = ($PbPe1[$c-1], $PbPe2[$c-1]);
#			$App->printf("%8s(%10.4g,%10.4g)\n", '   Try '$e1ini, $e2ini);

			my ($OptVars2, $MinVal2) = $optimize->Optimize(
					$Method, undef, undef, undef,
					$ini->{EPS}, $ini->{nMaxIter}, $ini->{iPrintLevel},
					sub { $this->CalS2ForPontByPonint($optimize, $FitTo, $Layers, $E, $pObsR->[$i] * $sf, $pObsT->[$i] * $sf, @_); },
					undef,
					sub { Optimize::BuildDifferentialMatrixes(@_); },
					);
			
			if($MinVal2 < $MinVal) {
				$MinVal = $MinVal2;
				for(my $i = 0 ; $i < @$OptVars ; $i++) {
					$OptVars->[$i] = $OptVars2->[$i];
				}
			}
		}

		$optimize->RecoverParameters($OptVars);
		$App->printf("%6.2f: (%10.4g,%10.4g) => (%10.4g,%10.4g) [%10.4g]\n", $E, $e1ini, $e2ini, $e1opt, $e2opt, $MinVal);

		my ($Rtots, $Rtotp, $Ttots, $Ttotp) = $this->CalRT($E, $Layers);
		my $Rcal = ($Rtots + $Rtotp) / 2.0;
		my $Tcal = ($Ttots + $Ttotp) / 2.0;
		$PbPE[$c]  = $E;
		$PbPe1[$c] = $e1opt;
		$PbPe2[$c] = $e2opt;
		$PbPR[$c]  = $Rcal;
		$PbPT[$c]  = $Tcal;
		$PbPS2[$c] = $MinVal;
		$c++;
	}
	$this->{PbPE}  = \@PbPE;
	$this->{PbPe1} = \@PbPe1;
	$this->{PbPe2} = \@PbPe2;
	$this->{PbPR}  = \@PbPR;
	$this->{PbPT}  = \@PbPT;
	$this->{PbPS2} = \@PbPS2;
}

sub CalS2ForPontByPonint
{
	my ($this, $optimize, $FitTo, $Layers, $E, $R, $T, $pVars, $iPrintLevel) = @_;
	my $ini = $this->{ini};

	$optimize->RecoverParameters($pVars);
	my ($e1, $e2) = $Layers->pLayer(1)->CalEps($E);
	return 1.0e10 if(!$ini->{PbPAllowNegativeE2} and $e2 < 0.0);

	my ($Rtots, $Rtotp, $Ttots, $Ttotp) = $this->CalRT($E, $Layers);
	my $Rcal = ($Rtots + $Rtotp) / 2.0;
	my $Tcal = ($Ttots + $Ttotp) / 2.0;
#print "E=$E: e=($e1,$e2) R=($R,$T) / ($Rcal,$Tcal)\n";
	my $S2 = 0.0;
	if(defined $R) {
		my $dR = $R - $Rcal;
		$S2 += $dR * $dR;
	}
	if(defined $T) {
		my $dT = $T - $Tcal;
		$S2 += $dT * $dT;
	}
#print "E=$E: S2=$S2\n";
	return $S2;
}

sub CalRT
{
	my ($this, $E, $Layers) = @_;
#	my ($Rtots, $Rtotp, $Ttots, $Ttotp) = $Layers->CalEpsRTForSubstrate($E, $this->{ini}->{Angle});
	my ($rs123, $rp123, $ts123, $tp123, $Rtots, $Rtotp, $Ttots, $Ttotp)
					= $Layers->CalFresnelCoefficient($E);
	return ($Rtots, $Rtotp, $Ttots, $Ttotp);
}

sub Fit
{
	my ($this) = @_;
	my $ini      = $this->{ini};
	my $dini     = $this->{dini};
	$this->UpdateParameters();
	$this->BuildLayerModel(0, 1);

	my $optimize = $this->{Optimize};
	my $Method   = $this->{ChooseLSQMethodListBox}->GetText();
	my $FitTo    = $this->{ChooseFitToListBox}->GetText();
print "Method: $Method\n";
print "Fit to: $FitTo\n";
print "nMaxIter: $ini->{nMaxIter}\n";

	my $el    = $this->{Ellipsometry};
	my $pObsE = $el->GetData('.*eV.*', '.*E.*');
	my $pObsR = $el->GetData('R.*');
	my $pObsT = $el->GetData('T.*');

	$optimize->SetnS2Calculation(0);
#	$this->{nS2} = 0;
	my ($OptVars, $MinVal) = $optimize->Optimize(
				$Method, undef, undef, undef,
				$ini->{EPS}, $ini->{nMaxIter}, $ini->{iPrintLevel},
				sub { $this->CalS2($FitTo, $pObsE, $pObsR, $pObsT, @_); },
				undef,
				sub { Optimize::BuildDifferentialMatrixes(@_); },
				);
	print "\nOptimized at:\n";
	$optimize->PrintParameters(1);

	$optimize->RecoverParameters($OptVars);
	$this->SetS2($MinVal);
	$this->UpdateParameters();
}

sub CalS2
{
	my ($this, $FitTo, $pObsE, $pObsR, $pObsT, $pVars, $iPrintLevel) = @_;
#print "pVars=", join(',', @$pVars);

	my $optimize = $this->{Optimize};
	my $ini      = $this->{ini};

	$optimize->RecoverParameters($pVars);
#	$this->UpdateParameters();
	$this->BuildLayerModel(0, 0);
	my ($pE, $pR, $pT, $S2) = $this->CalRTArrays($this->{Layers}, $pObsE, $pObsR, $pObsT, $FitTo);

	$optimize->IncrementnS2();
	my $nS2         = $optimize->nS2Calculation();
	my $nS2Interval = $ini->{nSaveSpectraInterval};
	print "S2[$nS2] = $S2 / ";
	$S2 += $optimize->CalPenalty(1.0e10, $pVars, 1);
	print "$S2\n";
	$optimize->PrintParameters(1, $pVars, $S2, 0);

	if($nS2Interval > 0 and $nS2 % $nS2Interval == 0) {
		$this->Recalc();
#		$this->CreateGraphFrame();
		$this->AssignGraphData(0);
		$this->Draw();
	}
	$this->UpdateParameters();
	$this->mw()->update();

	return $S2;
}

sub CalRTArrays
{
	my ($this, $Layers, $pObsE, $pObsR, $pObsT, $FitTo) = @_;
	my $ini = $this->{ini};
	my $el  = $this->{Ellipsometry};

	my $Angle = $ini->{Angle};
	$el->SetIncidentAngle($Angle);

	my $nData = @$pObsE;
	my (@E, @R, @T);
	my $S2 = 0.0;
	my $c = 0;
	for(my $i = 0 ; $i < $nData ; $i++) {
		next if($ini->{nSkipData} > 0 and $i % $ini->{nSkipData} != 0);
		my $E  = $pObsE->[$i];
		next if($E < $ini->{FitEmin} or $ini->{FitEmax} < $E);

		my $lwl  = $ini->{Rayleighl0} / Optics::eVTonm($E);
		my $lwl2 = $lwl * $lwl;
		my $sf = $ini->{Scale} - $lwl2 * $lwl2;

		my ($Rs, $Rp, $Ts, $Tp) = $this->CalRT($E, $this->{Layers});
		my $R = ($Rs + $Rp) / 2.0;
		my $T = ($Ts + $Tp) / 2.0;
#print "$E [$i]: $R, $T\n";
		$E[$c] = $E;
		$R[$c] = $R * $sf;
		$T[$c] = $T;

		if($FitTo eq 'RT' and $pObsR  and $pObsT) {
			my $dT = ($pObsT->[$i] * $sf - $T);
			my $dR = ($pObsR->[$i] * $sf - $R);
			$S2 += $dT * $dT + $dR * $dR;
		}
		elsif($FitTo eq 'R' and $pObsR) {
			my $d = ($pObsR->[$i] * $sf - $R);
			$S2 += $d * $d;
		}
		elsif($FitTo eq 'T' and $pObsT) {
			my $d = ($pObsT->[$i] * $sf - $T);
			$S2 += $d * $d;
		}
		else {
			print "Error: Invalid Fitting Target [$FitTo].\n";
			return;
		}
		$c++;
	}
	$S2 = sqrt($S2 / $c);

	return (\@E, \@R, \@T, $S2);
}

sub ReadSampleDataFile
{
	my ($this, $filepath, $IsPrint) = @_;
	my $App = $this->App();
#print "type=$type\n";

	$this->{Layers}     = undef;
	$this->{Optimize}   = undef;

	$this->{Path} = $filepath;
	my ($nData, $pLabelArray, @pDataArray) = $this->{Ellipsometry}->Read($filepath);
	if(!defined $nData) {
		$App->print("Error: Can not read [$filepath].\n");
		return $this->{Path} = undef;
	}

	my $nDataArray = $this->{Ellipsometry}->nDataArray();
#print "nDataArray: $nDataArray\n";
	$this->{"ChooseXListBox"}->DeleteAllItem();
	$this->{"ChooseY1ListBox"}->DeleteAllItem();
	$this->{"ChooseY2ListBox"}->DeleteAllItem();
	for(my $i = 0 ; $i < $nDataArray ; $i++) {
#print "$i: $pLabelArray->[$i]\n";
		$this->{"ChooseXListBox"}->AddItem($pLabelArray->[$i]);
		$this->{"ChooseY1ListBox"}->AddItem($pLabelArray->[$i]);
		$this->{"ChooseY2ListBox"}->AddItem($pLabelArray->[$i]);
	}
	$this->{"ChooseXListBox"}->SetCurSel('.*E.*', '.*eV.*');
	$this->{"ChooseY1ListBox"}->SetCurSel('R', 'e1', 'n', 'Psi');
	$this->{"ChooseY2ListBox"}->SetCurSel('T', 'e2', 'k', 'Delta');

	$this->CreateGraphFrame();
	$this->AssignGraphData();
	return $filepath;
}

sub ReadSubstrateDataFile
{
	my ($this, $filepath, $IsPrint) = @_;
	my $App = $this->App();
#print "type=$type\n";

	$this->{Layers}    = undef;
	$this->{Optimize}  = undef;
	$this->{Substrate} = new Ellipsometry;

	$this->{SubstratePath} = $filepath;
	my ($nData, $pLabelArray, @pDataArray) = $this->{Substrate}->Read($filepath);
	if(!defined $nData) {
		$App->print("Error: Can not read [$filepath].\n");
		return $this->{SubstratePath} = undef;
	}

#	$this->CreateGraphFrame();
#	$this->AssignGraphData();
	return $filepath;
}

sub CreateGraphFrame
{
	my ($this, $canvas, $TargetData) = @_;
	$canvas = $this->Canvas();
	my $w = $canvas->width();
	my $h = $canvas->height();

	my $GraphFrameArray = $this->{'GraphFrameArray'} = new GraphFrameArray($this->mw());
	$GraphFrameArray->SetCanvasSize($w, $h);
	$GraphFrameArray->AddGraphFrame();
	my $GraphFrame0  = $GraphFrameArray->GetGraphFrame(0);
	my $FramePosStr0 = $this->App()->{"GraphFrame0Position"};
	$GraphFrame0->SetPositionByStr($FramePosStr0);
	my $XScale0 = $GraphFrame0->GetXScale(0);
	my $YScale0 = $GraphFrame0->GetYScale(0);
	$XScale0->SetScaleStringVisible(1);
	$XScale0->SetCaptionVisible(1);

	$GraphFrame0->SetViewRange(0, 0, 1, 1);
}

sub AssignGraphData
{
	my ($this, $ResetViewRange) = @_;
	$ResetViewRange = 1 if(!defined $ResetViewRange);

	my $GraphFrameArray = $this->GetGraphFrameArray();
	my $GraphFrame0  = $GraphFrameArray->GetGraphFrame(0);
	$GraphFrame0->ClearAllData();

	my $XLabel  = $this->{"ChooseXListBox"}->GetText();
	$XLabel  = 'X'  if(!$XLabel);
	my $Y1Label = $this->{"ChooseY1ListBox"}->GetText();
	$Y1Label = 'Y1' if(!$Y1Label);
	my $Y2Label = $this->{"ChooseY2ListBox"}->GetText();
	$Y2Label = 'Y2' if(!$Y2Label);
	$GraphFrame0->SetXCaption($XLabel);

	my $pX    = $this->{Ellipsometry}->GetData($XLabel, '.*E.*', '.*eV.*');
	my $pY1   = $this->{Ellipsometry}->GetData($Y1Label);
	my $pY2   = $this->{Ellipsometry}->GetData($Y2Label);
	my $nData = $this->{Ellipsometry}->nData();
	my $YLabel = '';
	$YLabel .= $Y1Label if($pY1);
	$YLabel .= ",$Y2Label" if($pY2);
	$GraphFrame0->SetYCaption("$Y1Label,$Y2Label");
	if($pX) {
		my $ini = $this->{ini};
		my (@y1, @y2);
		for(my $i = 0 ; $i < @$pX ; $i++) {
			my $E  = $pX->[$i];
			my $lwl  = $ini->{Rayleighl0} / Optics::eVTonm($E);
			my $lwl2 = $lwl * $lwl;
			my $sf = $ini->{Scale} - $lwl2 * $lwl2;

			if($pY1) {
				$y1[$i] = $pY1->[$i] * $sf;
			}
			if($pY2) {
				$y2[$i] = $pY2->[$i] * $sf;
			}
		}
		$GraphFrame0->AddGraphData($pX, \@y1,
				2, "black", "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y1Label}(obs)") if($pY1);
		$GraphFrame0->AddGraphData($pX, \@y2,
				2, "red",   "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y2Label}(obs)") if($pY2);
	}

	my $pCalE  = $this->{pEArray};
	my $pCalY1 = $this->{"p${Y1Label}Array"};
	my $pCalY2 = $this->{"p${Y2Label}Array"};
	if($pCalE) {
		$GraphFrame0->AddGraphData($pCalE, $pCalY1,
				0, "black", "circle", 3, "", 1, "black", "XAutoSkip", "Energy", "${Y1Label}(cal)") if($pCalY1);
#				1, "black", "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y1Label}(cal)") if($pCalY1);
		$GraphFrame0->AddGraphData($pCalE, $pCalY2,
				0, "red",   "circle", 3, "", 1, "red", "XAutoSkip", "Energy", "${Y2Label}(cal)") if($pCalY2);
#				1, "red",   "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y2Label}(cal)") if($pCalY2);
	}

	if($this->{PbPE}) {
		$GraphFrame0->AddGraphData($this->{PbPE}, $this->{PbPR},
				0, "", "square", 3, "", 1, "black", "XAutoSkip", "Energy", "${Y1Label}(PbP)");
#				1, "black", "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y1Label}(PbP)");
		$GraphFrame0->AddGraphData($this->{PbPE}, $this->{PbPT},
				0, "",   "square", 3, "", 1, "red", "XAutoSkip", "Energy", "${Y2Label}(PbP)");
#				1, "red",   "", 6, "red", 0, "red", "XAutoSkip", "Energy", "${Y2Label}(PbP)");
	}

	$GraphFrame0->SetYScalePlotType('x');
	if($ResetViewRange) {
		$GraphFrame0->CalMinMax();
		$GraphFrame0->AdjustViewRange(0.05, 0.05, 0.05, 0.05);
	}
}
1;