#!/bin/bash

JCODE=Jcode-2.03
MM=Math-Matrix-0.4
MMR=Math-MatrixReal-2.01
OPENGL=OpenGL-0.54
if [ -e $OPENGL.03.tar.gz ]; then
  mv $OPENGL.03.tar.gz $OPENGL.tar.gz
fi

PWD=`pwd`
chmod +x *Plot *View Draw

for f in $JCODE $MM $MMR $OPENGL
do
  if [ -e $f.tar.gz ]; then
	cd $PWD
	tar xvfz $f.tar.gz
	cd $f
	perl Makefile.PL
	make
	sudo make install
  else
	echo $f.tar.gz is not found. Skipped.
  fi
done

perl -x -S $0 $@ TkPlot.pl TkPlot

exit 0

#!/usr/bin/perl -w
#line 34

use strict;
use Cwd;

my $BaseDir = $ENV{'TkPerlDir'};
print "Base directory: $BaseDir\n";
my $outfile = $ARGV[0];
my $AppDir  = $ARGV[1];
$AppDir = 'TkPlot' unless($AppDir);
unless($outfile) {
	print "Error: Perl Script Name is not specified.\n";
	exit 1;
}
my $infile = $outfile . ".prev";
unlink($infile);
unless(rename($outfile, $infile)) {
	print "Error: Could not rename [$outfile] to [$infile].\n";
	exit 1;
}

open(IN,  "<$infile") or die "Error: $!\n";
open(OUT, ">$outfile") or die "Error: $!\n";
while(<IN>) {
#print "line: $_";
	if(/^#Start:\s*use\s/i) {
#print "Start in\n";
		print OUT;
		print OUT "use lib \"$BaseDir/lib\";\n";
		print OUT "use lib \"$BaseDir/$AppDir\";\n";
		while(<IN>) {
#print "line2: $_";
			if(/^#End:\s*use\s/i) {
#print "End out\n";
				print OUT;
				last;
			}
		}
	}
	else {
		print OUT;
	}
}
close(OUT);
close(IN);

chmod(0777, $outfile);

print "$outfile updated.\n";

exit;

__END__

:EndOfPerl
