import numpy
import matplotlib.pyplot
from pymatgen.io.vasp.outputs import Vasprun
from pymatgen.electronic_structure.plotter import BSDOSPlotter,\
     BSPlotter,BSPlotterProjected,DosPlotter

dos_vasprun=Vasprun("./vasprun.xml")
dos_data=dos_vasprun.complete_dos
bs_vasprun=Vasprun("./vasprun.xml",parse_projected_eigen=True)
bs_data=bs_vasprun.get_band_structure(line_mode=1)
plt_3=BSDOSPlotter(bs_projection='elements', dos_projection=None,\
 fig_size=(5.5, 6.5), vb_energy_range=5, cb_energy_range=10, egrid_interval=1)
plt_3.get_plot(bs=bs_data,dos=None)
matplotlib.pyplot.savefig('band.png',img_format='png')

