#!/bin/bash

VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

UseCalculatedPOSCAR=$1
SCRIPTDir=$2
TemplateDir=$3
xarray=($4)
iSite=$5
post=$6
DebugMode=0


nx=${#xarray[@]}

if [ "$UseCalculatedPOSCAR" = "" ]; then
	echo UseCalculatedPOSCAR is not specified.
	echo usage: CalcDiagonal.sh UseCalculatedPOSCAR iSite
	exit 0
fi
if [ "$iSite" = "" ]; then
	echo iSite is not specified.
	echo usage: CalcDiagonal.sh UseCalculatedPOSCAR iSite
	exit 0
fi

for ((ix = 0; ix < $nx; ix++)) {
	ixm1=`expr $ix - 1`
	xm1=${xarray[$ixm1]}
	x=${xarray[$ix]}
	ym1=$xm1
	y=$x

#================================
# Main calculation
#================================
	WorkDir=$x$y$post
	if [ -d $WorkDir ]; then
		echo "[Work]: [$WorkDir] exists. Skip."
#		continue
	else
		echo Work for [$WorkDir]

# Copy the final POSCAR to WorkDir
		if [ "$UseCalculatedPOSCAR" = "1" ]; then
			SourcePOSCAR=$xm1$ym1$post/VCRelax/POSCAR
			if [ -f "$SourcePOSCAR" ]; then
				cp $SourcePOSCAR $TemplateDir
			fi
		fi

# Execute VASP
		$SCRIPTDir/CalcOne.sh $SCRIPTDir $TemplateDir $iSite $x $y $post
	fi
}

exit 1
