#!/bin/bash

VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

SCRIPTDir=$1
TemplateRootDir=$2
TemplatePOSCARFlagDir=$3
xarray=($4)
yarray=($5)
iSite=$6
post=$7
DebugMode=0

COPYPOCARFLAGPath="/usr/bin/perl $SCRIPTDir/CopyPOSCARFlags.pl"

ny=${#yarray[@]}
nx=${#xarray[@]}

for ((iy = 0; iy < $ny; iy++)) {
	y=${yarray[$iy]}

	for ((ix = 0; ix < $nx; ix++)) {
		x=${xarray[$ix]}

#================================
# Main calculation
#================================
		WorkDir=$x$y$post
		TemplateDir=$TemplateRootDir/$x$y$post
		if [ -d $WorkDir ]; then
			echo "[Work]: [$WorkDir] exists. Skip."
		else
# Copy template dir to WorkDir
			mkdir $WorkDir
			echo "cp $TemplateDir/{DoVASP.sh,hosts,INCAR,KPOINTS,POSCAR,POTCAR} $WorkDir"
			cp $TemplateDir/{DoVASP.sh,hosts,INCAR,KPOINTS,POSCAR,POTCAR} $WorkDir

# Copy template POSCAR flags to WorkDir
			$COPYPOCARFLAGPath $WorkDir $TemplatePOSCARFlagDir $WorkDir/POSCAR


# Execute VASP
			if [ "$DebugMode" = "1" ]; then
				echo "Calculating in [$WorkDir]."
			else
				$SCRIPTDir/CalcOneFromTemplate.sh $iSite $x $y $post
			fi
		fi
	}
}

exit 1
