#!/bin/bash

VASPDir=$TkPerlDir/VASP
SCRIPTDir=$VASPDir/script
CMD="/usr/bin/perl $VASPDir/VASP.pl"
AddMDHistoryCMD="/usr/bin/perl $SCRIPTDir/AddMDHistory.pl"
#VASPCommand=./DoVASP-HF-mpi.sh
VASPCommand=./DoVASP.sh
ModifyINCARCommand="/usr/bin/perl $SCRIPTDir/ModifyINCARforPBE0.pl"

BandScript=EffectiveMassFromBand.pl

TemplateDir=`pwd`/Template-PBE0
#TemplatePath=$TemplateDir/Template-cubic-Perovskite.cif
#HistoryFile=History.csv

# Set SkipIfDirectoryExists=1 if you do not want to repeat finished tasks
SkipIfDirectoryExists=0

post=

#ASiteList="Mg Ca Sr Ba Cd"
#BSiteList="C Si Ge Sn Ti Zr Hf Ce Pt"
#ASiteList="Mg Ca"
#BSiteList="C Ge Sn Ti Zr Hf"
DirList="*-PBE0 *-PBE96"

#===========================
# Calculate all
#===========================

OriginalDir=`pwd`

PrevDir=
for Dir in $DirList
do
	WorkDir=$Dir
	echo Working in $WorkDir...
	
	cp $OriginalDir/$BandScript $WorkDir

	cd $WorkDir
	echo === Working in \"`pwd`\"
	echo === Files in \"$wd\"
	ls

	echo ''
	echo === Execute [$OriginalDir/$BandScript]
#	$VASPCommand
#	perl $VASPDir/script/Summarize2.pl ./ > Summarize.txt
#	perl $VASPDir/script/Summarize.pl  ./ > Summarize-SpinPolarized.txt
#	perl $VASPDir/script/MakeSummaryHTML.pl
	perl $OriginalDir/$BandScript

	echo ''
	echo === Exit to \"$OriginalDir\"
	cd $OriginalDir

	echo ''
	echo ''

	PrevDir=$WorkDir
done

#===========================
# Post processors
#===========================
#$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 0000.last/SCF MergedCIF.cif
#$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
#$SCRIPTDir/MakeSummaryCSV.pl TotalEnergy.csv .

#rm $HistoryFile
#for Template in $TemplateList
#do
#	$AddMDHistoryCMD $HistoryFile $Template
#done
