#!/bin/bash

VASPDir=$TkPerlDir/VASP
SCRIPTDir=$VASPDir/script
CMD="/usr/bin/perl $VASPDir/VASP.pl"
AddMDHistoryCMD="/usr/bin/perl $SCRIPTDir/AddMDHistory.pl"
#VASPCommand=./DoVASP-HF-mpi.sh
VASPCommand=./DoVASP.sh
ModifyINCARCommand="/usr/bin/perl $SCRIPTDir/ModifyINCARforPBE0.pl"

TemplateDir=`pwd`/Template-PBE0
#TemplatePath=$TemplateDir/Template-cubic-Perovskite.cif
#HistoryFile=History.csv

# Set SkipIfDirectoryExists=1 if you do not want to repeat finished tasks
SkipIfDirectoryExists=0

post=

#ASiteList="Mg Ca Sr Ba Cd"
#BSiteList="C Si Ge Sn Ti Zr Hf Ce Pt"
#ASiteList="Mg Ca"
#BSiteList="C Ge Sn Ti Zr Hf"
DirList=2*

#===========================
# Calculate all
#===========================

OriginalDir=`pwd`

PrevDir=
for Dir in $DirList
do
	WorkDir=$Dir
	echo Working in $WorkDir...

	if [ -f STOP.`hostname` ]; then
		exit -1
	fi

	if [ "$SkipIfDirectoryExists" = "1" -a -d $WorkDir ]; then
		echo [$WorkDir] exists.
		echo Skip.
		continue
	fi

#	mkdir $WorkDir
#	cp $PBE96Dir/{INCAR,POSCAR,POTCAR,KPOINTS} $WorkDir
#	cp $TemplateDir/{*.sh,hosts,*.klist} $WorkDir
#	$ModifyINCARCommand $WorkDir/INCAR

#	echo "sed -e \"s/{A}/$A/g\" $TemplatePath \> cif.temp"
#	sed -e "s/{A}/$A/g" $TemplatePath > cif.temp
#	echo "sed -e \"s/{B}/$B/g\" cif.temp \> cif.temp"
#	sed -e "s/{B}/$B/g" cif.temp > $WorkDir/${A}${B}O3-cubic.cif
#	rm cif.temp

	chmod +x $WorkDir/*.sh

	cd $WorkDir
	echo === Working in \"`pwd`\"
	echo === Files in \"$wd\"
	ls

	echo ''
	echo === Execute [$VASPCommand]
	$VASPCommand

	echo ''
	echo === Exit to \"$OriginalDir\"
	cd $OriginalDir

	echo ''
	echo ''

	PrevDir=$WorkDir
done

#===========================
# Post processors
#===========================
#$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 0000.last/SCF MergedCIF.cif
#$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
$SCRIPTDir/MakeSummaryCSV.pl TotalEnergy.csv .

#rm $HistoryFile
#for Template in $TemplateList
#do
#	$AddMDHistoryCMD $HistoryFile $Template
#done
