#!/bin/bash

SCRIPTDir=`pwd`/script
VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"
AddMDHistoryCMD="/usr/bin/perl $SCRIPTDir/AddMDHistory.pl"
VASPCommand=./DoVASP-HF-mpi.sh
ModifyINCARCommand="/usr/bin/perl $SCRIPTDir/ModifyINCARforPBE0.pl"

Header=MgSiO3-cubic
BaseDir=`pwd`/$Header
TemplateDir=`pwd`/Template-${Header}-Volume
#TemplatePath=$TemplateDir/Template-cubic-Perovskite.cif
#HistoryFile=History.csv

post=

aList="3.3 3.4 3.5 3.6 3.7 3.8 3.9 4.0 4.1 4.2 4.3 4.4"

#===========================
# Calculate all
#===========================

OriginalDir=`pwd`

mkdir $BaseDir

PrevDir=
for a in $aList
do
	WorkDir=$BaseDir/$Header-${a}
	echo Working in $WorkDir...

	if [ -f STOP.`hostname` ]; then
		exit -1
	fi

	if [ -d $WorkDir ]; then
		echo [$WorkDir] exists.
		echo Skip.
		continue
	fi

	mkdir $WorkDir
	cp $TemplateDir/{*.sh,hosts,INCAR,POTCAR,KPOINTS,*.klist} $WorkDir

	echo "sed -e \"s/{a}/$a/g\" $TemplateDir/POSCAR \> $WorkDir/POSCAR"
	sed -e "s/{a}/$a/g" $TemplateDir/POSCAR > $WorkDir/POSCAR

	chmod +x $WorkDir/*.sh

	cd $WorkDir
	echo === Working in \"`pwd`\"
	echo === Files in \"$wd\"
	ls

	echo ''
	echo === Execute [$VASPCommand]
	$VASPCommand

	echo ''
	echo === Exit to \"$OriginalDir\"
	cd $OriginalDir

	echo ''
	echo ''

	PrevDir=$WorkDir
done

#===========================
# Post processors
#===========================
#$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 0000.last/SCF MergedCIF.cif
#$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType

cd $BaseDir
perl $SCRIPTDir/MakeSummaryCSV.pl TotalEnergy.csv .
cd $OriginalDir

#rm $HistoryFile
#for Template in $TemplateList
#do
#	$AddMDHistoryCMD $HistoryFile $Template
#done
