#!/bin/bash

nCPU=16

SCRIPTDir=$TkPerlDir/VASP/script
VASPDir=$TkPerlDir/VASP
VASPCMD="/usr/bin/perl $VASPDir/VASP.pl"
ConvergenceCMD="/usr/bin/perl $VASPDir/Convergence.pl"
WIEN2kplCMD="/usr/bin/perl $TkPerlDir/WIEN2k/WIEN2k.pl"
MakeCIFCMD="$VASPCMD --Action=ConvCONTCARFiles"
MakeSymmetrizedCIFCMD="$WIEN2kplCMD --Action=MakeSymmetrizedStructFile --TOL=0.001 *-final.cif out.struct"
MakeXSFCMD="$VASPCMD --Action=MakeRelaxXSFFile --kMagnetization=0.8 --ArrowColor=255:0:0 --ArrowRadius=0.2"

BaseDir=`pwd`
TemplateDir=`pwd`
#VASPCommand=DoVASP.sh
#VASPCommand=Convergence.sh
VASPCommand=ConvergedDFT.sh

CIFList=*.cif

#===========================
# Perform ConvergedDFT.sh
#===========================
OriginalDir=`pwd`

PrevCIF=
for CIF in $CIFList
do
	echo "for $CIF"
	WorkDir=${CIF%%.*}
	echo Working in $WorkDir...

	if [ -d $WorkDir ]; then
		echo [$WorkDir] exists.
	else
		continue
	fi

	cd $WorkDir/VCRelax1
	$MakeCIFCMD .
	$MakeSymmetrizedCIFCMD
	$MakeXSFCMD .
	cd $OriginalDir

	cd $WorkDir/VCRelax
	$MakeCIFCMD .
	$MakeSymmetrizedCIFCMD
	$MakeXSFCMD .
	cd $OriginalDir

	cd $WorkDir
	echo === Working in \"`pwd`\"
	echo === Files in \"$wd\"
	ls

	perl $VASPDir/Summarize2.pl ./ > Summarize.txt
	perl $VASPDir/Summarize.pl  ./ > Summarize-SpinPolarized.txt
	perl $VASPDir/MakeSummaryHTML.pl

	echo ''
	echo === Exit to \"$OriginalDir\"
	cd $OriginalDir

	echo ''
	echo ''

	PrevDir=$WorkDir
done

#===========================
# Post processors
#===========================
#$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 0000.last/SCF MergedCIF.cif
#$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
$SCRIPTDir/MakeSummaryCSV.pl TotalEnergy.csv .

#rm $HistoryFile
#for Template in $TemplateList
#do
#	$AddMDHistoryCMD $HistoryFile $Template
#done
