#!/bin/bash

SCRIPTDir=`pwd`/script
VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"
AddMDHistoryCMD="/usr/bin/perl $SCRIPTDir/AddMDHistory.pl"
VASPCommand=./DoVASP.sh

TemplateDir=`pwd`/Template
HistoryFile=History.csv

post=

cList="0.97 0.98 0.99 1.00 1.01 1.02 1.03"

#===========================
# Calculate all
#===========================

OriginalDir=`pwd`

PrevDir=
for c in $cList
do
	WorkDir=$c
	echo Working in $WorkDir...

	if [ -f STOP.`hostname` ]; then
		exit -1
	fi

	if [ -d $WorkDir ]; then
		echo [$WorkDir] exists.
		echo Skip.
		continue
	fi

	mkdir $WorkDir
	cp $TemplateDir/{*.sh,hosts,INCAR,KPOINTS,POTCAR} $WorkDir

	echo "	sed -e "s/{c}/$c/g" $TemplateDir/POSCAR > $WorkDir/POSCAR"
	sed -e "s/{c}/$c/g" $TemplateDir/POSCAR > $WorkDir/POSCAR
	chmod +x $WorkDir/DoVASP.sh

	cd $WorkDir
	echo === Working in \"`pwd`\"
	echo === Files in \"$wd\"
	ls

	echo ''
	echo === Execute [$VASPCommand]
	$VASPCommand

	echo ''
	echo === Exit to \"$OriginalDir\"
	cd $OriginalDir

	echo ''
	echo ''
	
	PrevDir=$WorkDir
done

#===========================
# Post processors
#===========================
#$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 0000.last/SCF MergedCIF.cif
$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType

rm $HistoryFile
for Template in $TemplateList
do
	$AddMDHistoryCMD $HistoryFile $Template
done
