#!/bin/bash

SCRIPTDir=`pwd`/script
VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

TemplateDir=Original
TemplateSymDir=Original.sym
RelaxedSymPOSCAR=$TemplateSymDir/POSCAR.relaxed

iSite=16
AtomType=Se
xarray="00 05 10 15 20 25 30 35 40 45 50"
yarray="00 05 10 15 20 25 30 35 40 45 50"
yForLine=00
post=


cp $TemplateSymDir/POSCAR $TemplateDir

#===========================
# Calculate symmetry points
#===========================
x=00
y=00
$SCRIPTDir/CalcOne.sh $SCRIPTDir $TemplateDir $iSite $x $y $post
if [ -f 0000/POSCAR ]; then
	cp 0000/POSCAR $RelaxedSymPOSCAR
fi

x=00
y=50
if [ -f $RelaxedSymPOSCAR ]; then
	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
fi
$CMD --Action=ModifyPOSCAR --Positions=$iSite:x:0.$x\;$iSite:y:0.$y\;$iSite:z:0.3 $TemplateDir/POSCAR
$SCRIPTDir/CalcOne.sh $SCRIPTDir $TemplateDir $iSite $x $y $post

x=25
y=25
z=30
if [ -f $RelaxedSymPOSCAR ]; then
	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
fi
$CMD --Action=ModifyPOSCAR --Positions=$iSite:x:0.$x\;$iSite:y:0.$y\;$iSite:z:0.$z $TemplateDir/POSCAR
$SCRIPTDir/CalcOne.sh $SCRIPTDir $TemplateDir $iSite $x $y $post


#===========================
# Calculate symmetry lines
#===========================
if [ -f $RelaxedSymPOSCAR ]; then
	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
fi
$SCRIPTDir/CalcDiagonal.sh 1 $SCRIPTDir $TemplateDir "$xarray" $iSite $post
if [ -f $RelaxedSymPOSCAR ]; then
	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
fi
$SCRIPTDir/CalcLineX.sh 1 $SCRIPTDir $TemplateDir "$xarray" $yForLine $iSite $post
if [ -f $RelaxedSymPOSCAR ]; then
	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
fi
$SCRIPTDir/CalcDiagonal2.sh 1 $SCRIPTDir $TemplateDir "$xarray" $iSite $post


#===========================
# Calculate all
#===========================
if [ -f $RelaxedSymPOSCAR ]; then
	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
fi
$SCRIPTDir/CalcMap.sh 1 $SCRIPTDir $TemplateDir "$xarray" "$yarray" $iSite $post

#===========================
# Post processors
#===========================
$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 2525/SCF MergedCIF.cif
$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
