#!/bin/bash

VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

SCRIPTDir=$1
TemplateRootDir=$2
TemplatePOSCARFlagDir=$3
xarray=($4)
iSite=$5
post=$6
DebugMode=0

COPYPOCARFLAGPath="/usr/bin/perl $SCRIPTDir/CopyPOSCARFlags.pl"

nx=${#xarray[@]}

if [ "$iSite" = "" ]; then
	echo iSite is not specified.
	echo usage: CalcDiagonal2.sh UseCalculatedPOSCAR iSite
	exit 0
fi

for ((ix = 0; ix < $nx; ix++)) {
	ixm1=`expr $ix - 1`
	xm1=${xarray[$ixm1]}
	x=${xarray[$ix]}

	ym1=`expr 83333 - $xm1`
	ym1=`printf "%03d" $ym1`
	y=`expr 83333 - $x`
	y=`printf "%03d" $y`

#================================
# Main calculation
#================================
	WorkDir=$x$y${post}.relaxed
	TemplateDir=$TemplateRootDir/$x$y$post

	if [ -d $WorkDir ]; then
		echo "[Work]: [$WorkDir] exists. Skip."
#		continue
	else
		echo "Working in [$WorkDir]"
# Copy template dir to WorkDir
		mkdir $WorkDir
		echo "cp $TemplateDir/{DoVASP.sh,hosts,INCAR,KPOINTS,POSCAR,POTCAR} $WorkDir"
		cp $TemplateDir/{DoVASP.sh,hosts,INCAR,KPOINTS,POSCAR,POTCAR} $WorkDir

# Copy template POSCAR flags to WorkDir
		$COPYPOCARFLAGPath $WorkDir $TemplatePOSCARFlagDir $WorkDir/POSCAR

# Execute VASP
		if [ "$DebugMode" = "1" ]; then
			echo "Calculating in [$WorkDir]."
		else
			$SCRIPTDir/CalcOneFromTemplate.sh $iSite $x $y ${post}.relaxed
		fi
	fi
}

exit 1
