#!/bin/bash

SCRIPTDir=`pwd`/script
VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

TemplateRootDir=`pwd`/../Se
TemplatePOSCARFlagDir=`pwd`/template

iSite=16
AtomType=Se
xarray="00 05 10 15 20 25 30 35 40 45 50"
yarray="00 05 10 15 20 25 30 35 40 45 50"
yForLine=00
post=


#===========================
# Calculate symmetry points
#===========================
$SCRIPTDir/CalcMapFromTemplate.sh $SCRIPTDir $TemplateRootDir $TemplatePOSCARFlagDir "$xarray" "$yarray" $iSite $post

#===========================
# Post processors
#===========================
$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 2525/SCF MergedCIF.cif
$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
