import sys
import tkinter as tk
from tkinter import ttk
import json


filename = sys.argv[1]

def load_json_file(filename):
    with open(filename, 'r') as file:
        data = json.load(file)
    return data

def populate_treeview(treeview, parent, data):
    # ツリービューに要素を挿入
#    item_id = treeview.insert(parent, 'end', text = 'aa')

    # ツリービューのヘッダー設定
    headers = list(data.keys())
#    print("h=", headers)
    for i in range(len(headers)):
        column = str(headers[i])
#        treeview.heading(i, text = column)
        item_id = treeview.insert(parent, 'end', text = column)

    # ツリービューにデータを挿入
#    for item in data:
#        treeview.insert(parent, 'end', values = list(item.values()))

    # 子要素を再帰的に処理
#    for child in element:
#        populate_treeview(treeview, item_id, child)


def main():
    # Tkinterウィンドウの作成
    root = tk.Tk()
    root.title("JSONファイルの表示")

    # ツリービューの作成
    treeview = ttk.Treeview(root)
    treeview.pack(fill = tk.BOTH, expand = True)

    # JSONファイルの読み込み
    json_data = load_json_file(filename)

    # ツリービューにデータを挿入
    populate_treeview(treeview, '', json_data)

    # Tkinterメインループの開始
    root.mainloop()

if __name__ == "__main__":
    main()
