import numpy as np
import scipy.signal


def func(x):
    return x**8

def diff(ndiff, x):
    if ndiff == 1:
        return 8.0 * x**7
    elif ndiff == 2:
        return 8.0 * 7.0 * x**6
    elif ndiff == 3:
        return 8.0 * 7.0 * 6.0 * x**5
    elif ndiff == 4:
        return 8.0 * 7.0 * 6.0 * 5.0 * x**4
    elif ndiff == 5:
        return 8.0 * 7.0 * 6.0 * 5.0 * 4.0 * x**3
    elif ndiff == 6:
        return 8.0 * 7.0 * 6.0 * 5.0 * 4.0 * 3.0 * x**2
    elif ndiff == 7:
        return 8.0 * 7.0 * 6.0 * 5.0 * 4.0 * 3.0 * 2.0 * x
    else:
        print("error: invalid ndiff=", ndiff)
        exit()

nx = 201
h = 0.1
x = [i * h for i in range(nx)]
y = [func(x[i]) for i in range(nx)]
i0 = 5
x0 = i0 * h
for ndiff in [1, 2, 3, 4, 5, 6]:
    for nsmooth in [3, 5, 7, 11, 15, 21, 27, 35]:
        for norder in [3, 4, 5, 6, 7, 8, 9, 10]:
            if nsmooth <= norder + 1:
                continue

            ys = scipy.signal.savgol_filter(y, nsmooth, norder, deriv = ndiff)
            dif = diff(ndiff, x[i0])
            print(f"{ndiff=:2} {nsmooth=:2} {norder=:2} {ys[i0]=:8.3g} {dif=:8.3g} {ys[i0]/h**ndiff=:8.3g} k={ys[i0]/h**ndiff/dif:8.3g}")
            
 